set define off verify off feedback off
whenever sqlerror exit sql.sqlcode rollback
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_050100 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2016.08.24'
,p_release=>'5.1.2.00.09'
,p_default_workspace_id=>61716057417882438171
,p_default_application_id=>89939
,p_default_owner=>'ANDREJGR'
);
end;
/
prompt --application/set_environment
 
prompt APPLICATION 89939 - Reports
--
-- Application Export:
--   Application:     89939
--   Name:            Reports
--   Date and Time:   15:37 Wednesday August 30, 2017
--   Exported By:     ANDREJGR
--   Flashback:       0
--   Export Type:     Application Export
--   Version:         5.1.2.00.09
--   Instance ID:     63113759365424
--

-- Application Statistics:
--   Pages:                     10
--     Items:                    2
--     Processes:               12
--     Regions:                  6
--     Buttons:                  2
--   Shared Components:
--     Logic:
--     Navigation:
--       Lists:                  2
--       Breadcrumbs:            1
--         Entries:              1
--     Security:
--       Authentication:         1
--     User Interface:
--       Themes:                 1
--       Templates:
--         Page:                 9
--         Region:              13
--         Label:                5
--         List:                11
--         Popup LOV:            1
--         Calendar:             1
--         Breadcrumb:           1
--         Button:               3
--         Report:               9
--     Globalization:
--     Reports:
--   Supporting Objects:  Included

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/ui_types
begin
null;
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_display_id=>nvl(wwv_flow_application_install.get_application_id,89939)
,p_owner=>nvl(wwv_flow_application_install.get_schema,'ANDREJGR')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Reports')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'F_10489939')
,p_page_view_logging=>'YES'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt=>'822BB738626036904437A08BDC088072EF4D23E04266DD9CB86F7D902C11A5EF'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'0'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(15549461811539463384)
,p_application_tab_set=>0
,p_logo_image=>'TEXT:Reports'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=> nvl(wwv_flow_application_install.get_proxy,'')
,p_flow_version=>'release 1.0'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221134020'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>3
,p_ui_type_name => null
);
end;
/
prompt --application/shared_components/navigation/lists
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15549419238425462538)
,p_name=>'Desktop Navigation Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549463027129463662)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Home'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-home'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'GEN PDF'
,p_list_item_link_target=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-file-pdf-o'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549565179380467038)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Employers'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-users'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549571627132954619)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Fonts'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-font'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549574807586956731)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Barcode'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-barcode'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549594611224476936)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Rotate'
,p_list_item_link_target=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-rotate-right'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549598066244122592)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'images'
,p_list_item_link_target=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-image'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549671378023337915)
,p_list_item_display_sequence=>75
,p_list_item_link_text=>'Header / Footer'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-header'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549601350858574604)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Other QR / Chart'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-cogs'
,p_parent_list_item_id=>wwv_flow_api.id(15549564803347465078)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15549461502300463242)
,p_name=>'Desktop Navigation Bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15549461713721463359)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Log Out'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_item_current_for_pages=>'&LOGOUT_URL.'
);
end;
/
prompt --application/shared_components/files
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000002BC000002BC080200000082D8FB140000000467414D410000B18E7CFB5193000000206348524D00007A25000080830000F9FF000080E8000075300000EA6000003A970000176F97A999D400013CA5494441';
wwv_flow_api.g_varchar2_table(2) := '5478DAEC9D3D681B4BD7C7556C31858B2D5CA84811438A1852C49022863431A48821450C296EE016C1A408264530291EC26D82B9C5C5DC229814179122A01401A530284560D3043685615C18C6856054A89842C5142AA650B1CF9C99FD92AC6FEB63573A';
wwv_flow_api.g_varchar2_table(3) := 'FF775E3F6B59D7B165EDCE6FCFC7FF1402140A8542A150A81154C097008542A150281442030A8542A150288406140A8542A150080D28140A8542A1101A5028140A85422134A05028140A85426840A15028140A85426840A15028140A85D08042A1502814';
wwv_flow_api.g_varchar2_table(4) := '0AA1018542A150281442030A8542A150288406140A8542A150080D28140A8542A1101A5028140A8542A1101A5028140A85422134A05028140A85426840A15028140A85D08042A15028140AA1018542A150281442030A8542A150288406140A8542A15028';
wwv_flow_api.g_varchar2_table(5) := '8406140A8542A150080D28140A8542A1101A5028140A85422134A05028140A85426840A15028140A85D08042A15028140AA1018542A15028140AA1018542A150281442030A8542A150288406140A8542A150080D28140A8542A1101A5028140A85422134';
wwv_flow_api.g_varchar2_table(6) := 'A05028140A85426840A15028140A85426840A15028140A85D08042A15028140AA1018542A150281442030A8542A150288406140A355DA9EECF547CA0BABF1A046DB366AD766AF5FEF150281442030A859A83DAA3EDFDED1EDB75B469AB3E6B0262E9B17A';
wwv_flow_api.g_varchar2_table(7) := '7FBB76FFDF0585422134A050A8393144DF5D59F5DEDDDB41EF759D88C235BF0F0A85426840A1507351C78D7DDF1BFDFE9BFAB038C398918981FF4A8F7C0AC61B50288406140A35075250038040753F599A35EBC8811C9A9E88BFB3799EC26207140AA101';
wwv_flow_api.g_varchar2_table(8) := '85422D52C337FBD9EDD432248776B4100950288406140AB54826D09BB152412B952F5032902268B0E0C2973FABC169597D29C90FC7FCED217BB1CFFE78CE9F3DE74FF7C48D0D512C72572F97AFB94C2FE23287F042A1E7627D162D10FD5F3107FE73F86E';
wwv_flow_api.g_varchar2_table(9) := 'EB455E2C8AE2067BB4C39EECB2677BECE53E7B7BC0FF39929F4ED4D7B2FE91D49917D468D0E4F0A3C630D192F08BB415262950288406140A355D5C508194418DCB5FBEF856E19FCBE2C581F8639F3FDAA3B7B7587103366FBD91475B3B4F1D08FBA963B7';
wwv_flow_api.g_varchar2_table(10) := '7C58CC7EEAF4258309569A36F43FE117885DE6AB4413065DDFA0B7B6E8831DFEF4B97879C03E96F8178D149EBA6441D300040A85426840A156230010AFE1C9FA9E5F4E1ED470D0E0C12F4F7D29F17F8F823FF7E4E31D717B132204CEF04840D616EDB3E2';
wwv_flow_api.g_varchar2_table(11) := '2FF94EC15F77D9ED0DF168473DDBE3FF1ECB2FA5E0B70F2F8292B69953F67AAD06BDCAEDE859ED8E8A4B2CA440A1101A50A879A87BB3892861A47D285D5AD84EB7414266415DFAE27735787FAC5E1E8AC77BF4E626758BD421CCDCA6D335A28FE995BBF9';
wwv_flow_api.g_varchar2_table(12) := 'BC43437AF97639C427C446293CBDD68AFEAD4DFE684FBD3AD42F8EFC5555177ED01451C144901C04DDC59B4378A28D5E11281442030A353F7A50D1C78EBD49B5CD17AEB60C240E482A102CF8EDC98FC7E2E53E7FB8C36F6E70E26A0EA0A440A39481CD29';
wwv_flow_api.g_varchar2_table(13) := 'D8C5FA141CF0315766A1A1679A8325698E82A797639EBCE6D25B1BF4E10E7DB5CFFF3B56BF3D7831BB8C28A2BF51F2176977FEF130D680422134A05033577BF8E31DDB51DB0412948002C0334D0927FCD93EBBB3CD4991392E2D44C103674895802C1001';
wwv_flow_api.g_varchar2_table(14) := '2B2C4D0897931B68E80B134E3737F002E1E665E9083F44298CAB8FFB05973AAE77679B3E7B2E3E9CC8DF9E825ACB2814A146883AA050288406146AE6D090F21BE88A3500283499ACF9E2D3317F7B401FEC50B7C8CC7668174B851326D8E6F9A42B17690B';
wwv_flow_api.g_varchar2_table(15) := '3FACA034ACE08C94D430B91B58BECD68DCDF666F0EF8C76375490311564574FCE114A62750288406146A2ED0D0658E2895B52932A58B3FAAC1FB23F9784F1437351CC8B86D21B5D98BDE3B7A144B70C22842128170529D0ECE75B921839011128003CBEF';
wwv_flow_api.g_varchar2_table(16) := '5C571081C43CE1DBF24973904E64F8A9D085A749A2B8C11FEFC9F7474AFF69344098F490EA9CC331248C8442A1101A50A8EBC9D633186B84332F7879201EEDD29B9BBE295734045090514502E411CC7E9F408313261792BDD33C214E4088CE9A06D1B985';
wwv_flow_api.g_varchar2_table(17) := '0F848F5CC184D33BE4307A64825D2106DF09F923011153125175887763833FDA552F0FC034A2CEC025A22B028142A1101A50A829920248CAE0A727FE3AD23B102B6E98BC43B2918B2BDBEAD54D57741E8B643336A649FA9810A00A127E07B95044987F04';
wwv_flow_api.g_varchar2_table(18) := '221D7B30DB7F987AF0FB24293C278C3AF468C7483FCD2E021FFDE2067DBCCBFF3E92BF7C639385450F281442030A15EFF6A3DC47F6CB73EB475A4AD578F0D7A17AB6CB6F166DD8404C5A9038F3CDDB19AF06828D593C31C0D3692A4DA1744ACBEFB3BCB8';
wwv_flow_api.g_varchar2_table(19) := 'B8D21EDF2A8A3F76837FDEC9260F4D1D86173DA4321B581E81426840A196921C54271FA8F4453FFD84D8A3A9C9E56959BC3910F7B659C1F55DE29302ED8C16B0C5DDF18B818B77B55A389D7D0A4E5298D9170E9CDEAE91A9EF4F2CA3D890400F5C80FF9C';
wwv_flow_api.g_varchar2_table(20) := '8831031574C62B1D81D007D542A1420AD575D72FB8ECDE8EF8EB1DF85EB744F87688DD38623288DE2D5DEF1C8C55A0101A50A8E552D74DA10CD12195DC3617FF3A139FCAFCD9BEB8B1690B14EC8EDBBBA4C0C95CD6A0DF97FAD1061BF9FB74C0C495A725';
wwv_flow_api.g_varchar2_table(21) := 'A5064E6259CDBA1E7426A95D980534F8571F2190E6F00C4678B736E98B7DF1AD1C34599A1E12AC54575B6D111E50080D28D43204197A5FC765FA9ADF96418DCA7F8ED9A35DE6BA616D41BCCB9A3BF5D82C41649E12BAB040A60B33AF062186A621BA420E';
wwv_flow_api.g_varchar2_table(22) := '9DDB7FFC695CE0D9B5688F740609A3148B485BF4319822614746B48CA314A16B45FFD99EF8EF048A5EED5BA69D62D09E412C140AA101855A924843EA2AAFEC28E70B5FFE7DC4EF6C5BCF66B646066FA86CA129898E45BA7FC2341688AEBD3F79A629B724';
wwv_flow_api.g_varchar2_table(23) := '2EB0D17A91AE17C5FAA628864B76AD1BE182AFAE6F087783BB1B30DFD2B1E33193EC86E885321DAF9533C8C66A21D0D055EB103FD895C5F06CF861CDF51FEDF0FF4E54830262B653FE0F0A590185D080422D53ACA1236AAC607EC125937F1DB2873B546F';
wwv_flow_api.g_varchar2_table(24) := '9F05221CB3C296C828554F0A8CD81803DCA9B3A879323D3D720E6B404D43570821AA39D01BB9CBD78ABCB8C16F6FF1873BF28FE7EAE581F87022FE2BC92F65F5BD0AE3A02E685063908B913C5C2D915EAAD9B1A4E0B2014B9DFBEACC57BF3C755A919F4A';
wwv_flow_api.g_varchar2_table(25) := 'E29F63FEF61D7F7D281EEFF2FBDBEC961D9CE1A6FCACAED4694E75C0E6F84185B027332C848CE20A861A537E94F6F14EBB08A007D7F59FED818975C3F46DC6A3BD4DDD03262750080D2854CED58AA73FC8E0D2571F8E846185C0F82FA56F944DBB63E867';
wwv_flow_api.g_varchar2_table(26) := '2CA20A3E96327BB677CC5D3BFA02A041FF0C2469C5044BC4F522BBBB2D9E1A38F85492DF2AC16F0F9840E391D9D88CA991919DB0D50E645B09A5444BA99E4B2AD98A9632ABD5F948DB0E9F546094ADBF555B4A25A4D454C1E4852F7F5435A0B0BFDED1D7';
wwv_flow_api.g_varchar2_table(27) := '07FCAE26892DFD13DA6154316F2D0A1ABA0A1A623B87EEC723AAA8AE59A408DF0C7ED4BD59758BECC99EFC5C02D7873873D1C2F30D85D08042E55910466E0AF1B9CC9FEC31B718DFA3DBC88170FA160484C7113DA42D9B160B0D400C6B843EDEE12FF7D5';
wwv_flow_api.g_varchar2_table(28) := 'BFC7C1F76A70499514CAC4CC932C4C1B0C2BC3D58EA9210D078159E947342C442BF5889579508610D1D44BC28A9E2F65101EB6E27F494AFDFC969075267F7952D3CCDB43F1648FDFDE6460ADBD1868E8E910950E30D87C84DFF955DB67E15D998201D338';
wwv_flow_api.g_varchar2_table(29) := '6F6ED23F0FE469155E1C3CDF50080D28D462A5521F83E04AFE385D98D6EE7CA6DEC87EF9C1935D71B3C86666A43864B31F98CEE82A3B60574A13A070C11EB82EBFB3C5FF782EFE3D869EC03AED18F10CB1F1AB4C30BD257BAE34315C51335A3173841C21';
wwv_flow_api.g_varchar2_table(30) := '4543B04B26FF2BF1B7EFE8C35DBABE41539D9FD4E9F67BB0DB33EF430CE92915B32E99EC28837052F3B44CE903BBB311BCD8931734B29B545D5DBE49376F70E53D8CB881426840A1A6AF5EB5EBF1A7D11064159CF9E2EDA1DE652151ED7644C5E7060DB2';
wwv_flow_api.g_varchar2_table(31) := 'B3E6204976C4BD06E9E805B1518D30F261763EC2DD22D421BE3E54FF9E04BF3C9896194483135A8612DACA8E7E4E886146D0D01A020D43B8E10A40E863087DB4F4019797549C56C45FEFD8A35D7A638B458D153DAD1DA048C2149D24AE915DF50AF68010';
wwv_flow_api.g_varchar2_table(32) := '3AFBDAC96EBF07C85990AA53A40F76E5C79364DA455BA56116F10085D08042CD9E15A2C192AA6B6440125D508110C197B278BCC78C13B348B905C4758E626E9106A7073DE8E7ABF4D348477EC47475BA727D533E7AAEFE39817A43C9555CC76959A105B9';
wwv_flow_api.g_varchar2_table(33) := '06F01E1A57B3A287FED0D0931E22898614428AA614B648C20084A833F9E984BF39A4F777FCB5224B7343C4015DB184AEEED09ECF990537785DDC10793CF8214390EA7A91BD38809A535B53D213174698B78E422134A050D70D36A8D8954F9979103516BC';
wwv_flow_api.g_varchar2_table(34) := '39607737FDD4466E769A1EFBFA6047A669D522F44C49F028A8106344F83487F0DBDBF2CF7D0D3DA6B02EDC630011CCAD2A0C676C29A8B36B05B657B42F19CC1A1A06D2831C991E44CBE42C1A42D5616982102DC195007A68E94F99F85DE5FF1ED1A7BBF4';
wwv_flow_api.g_varchar2_table(35) := '46911612534BDBD512F57C26298CAEF4C4EC5A3793F48473C527CA312651D18CEFAA432A6ED17FB4ABFE390AA43065A3512D2A42030AA101859A2A1CA8AEECAF4AB3825D52A8D30A7FBA471D37290220F1864D64C1ED59E138870246199941F5FC014C05';
wwv_flow_api.g_varchar2_table(36) := '03E18E2BEE6CCBFFBD0BBE57605369432E1CFA1114ACF0FED4ECD0D0ECD0561620801E9A72619186BEE8D02755D1EC8D0EDC041A342848090B1A3B85D00CA1BF016F4AD63400A15F10C1E54F0F7A311E6FD3DB1B748DA4E30A3EE90682AE8319FA3D38BD';
wwv_flow_api.g_varchar2_table(37) := '2310553B438B4423B262BF871B1BFCCD4170E12771A33622020AA101859A8154174CE8BDB346C5BFC7D0CE676F37E1EE935C2D39EC8603674EC42042BF848EF484048831E3B31D57DEDE52AF0FD5AFAAC603937451D25627C4816C9B8B81D0BD79A41D99';
wwv_flow_api.g_varchar2_table(38) := '15B76DA0A1777E62FCA4C5F4A86294EAC8940201CD171072D0006196B09F3680225443AA3A2C7D2C5A004CF0ADCF7CF1CFB178BCC78B1BB153B5DDBF59A779149D4B1786DFABB4C227A4ABF302D216A450B52E9305973DDA93A79540C941C48018814268';
wwv_flow_api.g_varchar2_table(39) := '40A1C68C3444D1051B6F689BCD53EF46BF2AE2ED01BBB179C5388184CB213C09FBF7184B0D1BB9337368A0D178A7380D414991AE6FCA9787EA7339102CA400D3FA681A23956AC7091715344DAFA4CD47442B6C9254413F3CB816345C131DFAD548B6FAF0';
wwv_flow_api.g_varchar2_table(40) := '830931284007DBC0A92002113E924A64E8A7356009015F916D056E10BFAAF2EF23F1608739AEBF4E6C9AA063FB77E6040DFE9502C91E4E0F6624B7FDA942836ACD8EF776C4C79340F2C847A41314101A50080D28D4B5A4EF41BF54AA7FEE0B937160295C';
wwv_flow_api.g_varchar2_table(41) := 'E0A676A133F54044AFB152B6F0703E4E8EB24094297B040BA935C21E6FCBFF8E839A2FA30148C00AAD24C010D89B69BD8C6F52D410113E6E96C94D98E206157530267BF6B4346D68E8AB560A1F9A61920212164DF3313ED65F32F4A04C04020CA45AA61E';
wwv_flow_api.g_varchar2_table(42) := '42BF7475C17FD2E0D90EBF558C1B35E7090DDDDE507189430407F611F34CE2A52CA4F4B12689AA43A8BB51FD5092171C290185D080428D124E883CFCBB4650AA54A5589DAB0FC7EC1E34E3C9698F90BE96ED92DE99D63AFE89A44BC231ACA07794DB9BEC';
wwv_flow_api.g_varchar2_table(43) := 'F5A1FAE9DBDF48B4039517B5E60510CD6B2D00884B263F94D8C35D635FDD3D2564144460A4309F16CD9E4D9BBEEBB217CFC1C4B32D3B820D69DF91F053A552C53DD8BD894268402D79BA61C057BBA751EABBEA332ADFBCA337366954E4489D8541034B61';
wwv_flow_api.g_varchar2_table(44) := '814D7CD86365C72B74FA4BCA822B1EEE04EFDF05E7D45EE825780CABBE5D0F4B060DAD394283B0CE51523598FC56D6BB2FBD016E51E921DD71668A76384090B479D4A2A0211E7E515D2BD267CF831F9E6DD1EC1A88A5E2930285426840AD94D4D569C25D';
wwv_flow_api.g_varchar2_table(45) := '4D122DA9CE7CFEC71EBDBDE1A7BC0D3AA7352E20D2C0078CAA22F13C08221EEFC9AF6565A719591EB216CB4A75B8302D37348C5B2039313734A08292350593A6DB427FAB9F1EFDFB58DCD8F489EB198387C40F8A10EA748CDF9CF5E8EDA1D09076ADAE16';
wwv_flow_api.g_varchar2_table(46) := '0A2542BC27BBC1975244D2297AE88A3A60460385D0805A6E56E8117B68A71BD6A50A843CABF267CF79A1D861A148120BC5F9A721E2D4431851209DAC10D7573A443DD953DF2BD02F199533CAA874D1DE2686A509AB080D23D73A8C0F0D32AC8880A8036F';
wwv_flow_api.g_varchar2_table(47) := 'DA6E8B40D64CABC59D1D5E7059AA49D25F03A78774DBC5AC4772F7AC97ECC85038C91CACC439EADE8EF85CB2B35364DC6B8103B150080DA8D58206D5ED001D592FA8E07B953FDCA151B43FB6558EE74CF2CEA9047386064E88E9994C8C9FA5131DAF6FC8';
wwv_flow_api.g_varchar2_table(48) := '67FBF29717B242DB24234CEF8399270923252377A6D583863EE8302D6830D32C40E65305ABA1641D6A1D8492A246C587637E0FD0215DE8C0239B071B78100532B7415943EA1B22A7870A144B12FFFEB6F85A0AA02F372E71E8CCE361C80185D0805A6685';
wwv_flow_api.g_varchar2_table(49) := '56D0E606CA740E42CAFF54E3C21E2F14AD2152DC19C1A3EA01DB45996E8B98FF6251A22470E063F8F3B8AE7AB9AF7E56C32474CB642220B4A0C0FFAF0D3BA46105D3F2B0349A6AD4E1BAE8D0E076FC26804303D0013A36C1E34141EC417F08F49728FFEF';
wwv_flow_api.g_varchar2_table(50) := '98DFDF36750C24297188BA1BF81CA1815E4D4F10E23B246D501D461D48D8B149EF6ECBCF6533072BE46D854590288406D4B2E382EA1E1551E7C18F2A7FB0E3AF1769CA9327EDCB940E24C85EC3A9E7B6D2D60E709FBABE215E1E04A7550921056B216150';
wwv_flow_api.g_varchar2_table(51) := 'A8154D930AE2995289894290A3EE8999F756C8F10A1DFA3F0758A1214274680ADE14A265BCA1CC780B2ECCA7FA9F3CF7F9A713FFEE96EF16D3F1063AF791DC5DD0508D7D249316CDA4D681998F15FDC8A31DFEA51498595FDDA60E8810288406D49203C4';
wwv_flow_api.g_varchar2_table(52) := '2F5FFC7140A3DA854E4420C27161B880D3C3807951D0C063634787C8277B1A1702E3E6680326665332A987166C81E19C0809968EE1B881A1B321569B1B268606B0836A29F06FB09D1426D2A01A82B7043855833D94520D137568C1F887A0EE8B7FDEB15B';
wwv_flow_api.g_varchar2_table(53) := '1BACD714CDEBACC9B881A5266C8518410011FC4E6BEA6AC410278F9F8BAFD56E4AC00C050AA101958F5CC388D7AC7480E1AC2AFED8859AF6C86B7921350A1DC10327F91765CA733AEEAB94F174CA873BEA6B59B5F5F663220C3250A8C9186264C3E9D187';
wwv_flow_api.g_varchar2_table(54) := '600D5F4232639F25CF197BF3CE37BEA2F68F4E530C41E76B473D6A736658F740AA05E23DDE91DF2BF6941A303C130310288406549688A1172BA8C8F1D004EAD3138195FAE9893FF7F9FA068D0A171658D808658C4E8F160919155D46F58FB0F483ECEE96';
wwv_flow_api.g_varchar2_table(55) := 'FCFB5DD030F6CFF6B7B3DECFA8A942839A293434A5124A36202A0445A93FAAF4CFE7FE9ACBE2B215272977E8188EB5D002C9F42A9B4916157DE010FFC95EECEB604F46D96D0685422134A0B22F15F68685D7AF16CC2A147F1DD23B706317FB232DB685F2';
wwv_flow_api.g_varchar2_table(56) := 'AA8D63FC834942E27C04EC1FEB45FE663FA8F1C0D83A8B76C0250C8C30B964D4A4DCD027433161F8610C6E80E254696A1D2494A94AF9B9EC3DDAA3518D24ECFD6B617F26CF465745B719940D813844A34369CDA5AFF683332FE94FC2F0020AA10195CB9C';
wwv_flow_api.g_varchar2_table(57) := '45386E4AA88F27FCC6563C3002EEDD5358B058689057EA2B65D428615212AE7AB8179C560253E608BF4F1378481F0B030C81C458C3A4E8D06FC0D5280592D74007185D612763991159A65B138A28D9DF47FEEDD07B943985892B1E66ED20C93A4761696E';
wwv_flow_api.g_varchar2_table(58) := '80E6CC35C25F1F06972CB08E0E519841E2E50885D080CA201C74451954F82505B6BEF7B76D32424693A5125B5F87506771350D4ED7DCEA54F9C29A8934143782F74781806247182B65C651860327A5E9A26C4F65ACE46A871C7AA0C3709218421583D313';
wwv_flow_api.g_varchar2_table(59) := '7638560BECA0E2124B6E431C671E7FB1CF1D37F69CE6CED4CA2447448AE10E92BD1EA9C201A9DCDC601F8EED000B1314C39A061442032A1F24A1A0BDEDD973667BE24968D694B26126226E94585C374447BC21191B61DA3E9FEE0597BE715F50762035CC';
wwv_flow_api.g_varchar2_table(60) := 'D6320B464DB6ECDCEAD01B1A35A55445CF353E340CC488407068A5680137C0B0ED86F18632A10778A4C1E5C7137A6F9B3A64BAB830562862003498E64C022B060802C715E8D8340FDED992DF2A71D9310A85D080CA30313455D064E2D50133067CF18D5A';
wwv_flow_api.g_varchar2_table(61) := '542240443405803B2947C505BA2FA42CA2E1A77209BBB91518FB5E4D0C4285A3AB03E3EA68012130DC20CDBE1860A8618A0D999612C6CC5F8C8B0E0A0C9FC24E0A80066B29D914D0A819B5658A4BCA5EECFB6B2E5D1C37D081C186D0FA89244E50151B6F';
wwv_flow_api.g_varchar2_table(62) := '70425307FA642FF8E58545BB581189426840659318D8A9C7D7373871796A7284B55B48E60DA6A6417267C1C420D3A5152E091E6FAB260FF44ED28E8610836593946D111A37594A08BD9B82A5F25DC808378C1A8118CD59B2373A28286890016F296E1E09';
wwv_flow_api.g_varchar2_table(63) := 'E0416E604271F0915441CBD4E2DCDA5C2034D0FE6ED3F4CAC82B5A80F043C5383A6874805A879B1BF4ED2142030AA10135771A689B614BA904840CBAAE4432F859158F77797FDF85C5D62E081BDB281065E64718942169A34975734B7D2E730C1CE4637A';
wwv_flow_api.g_varchar2_table(64) := 'C59044861C3D0E31B470F2C5BE7590EC9AB34A230866A99116726683AF46A975E8BD6E6C28889C45D98A810C81D90C144203EABA524AA5674DA9D4D5253CAE33F1F280AE15EDD8C0AC41838AEC16927C84E9E008223F064D0FF2D95E70EE99B911480DCB';
wwv_flow_api.g_varchar2_table(65) := '000DE3252F06424320B9F8704C6F6EB2B82193C0A285041AE29999D499F9B4CC71A101420E84784FF7C4859F707F7A6E5C5B619B260AA101354DC9768A1B425C5021507C2CD3DB5BBC10169CF3EC41439084193A8C9B94596CCDE5FFBC83BE507B314568';
wwv_flow_api.g_varchar2_table(66) := 'C8313474A1C3C8C3B807A38356A0C499C71EECDABA5D3F6A0262D17B3EC40233367376D030624F66373738617B45797D83FD7D14F38154A95062747B80D73A144203EADA91868EE082BD47310E7467943E7D4E9DA28C860EF3B5453A3C8E5ABE40426280';
wwv_flow_api.g_varchar2_table(67) := '48F2EDCDE0B46C5BDB6186750B8C9B70AFCF28344CB50563746810E6BF80A257C1F99B436AF838E100E75AA60E6CF6E810CFAD60D6D7E1FEB630059222F6A04E4510E1D744A1101A505390ED2030B7E2D0B4F6FE88AE17292134050470052499C3051695';
wwv_flow_api.g_varchar2_table(68) := '35C0606B27C40508363C7D1ED4193455DA69DD2D1B50C1AD3EB7D0D0850E23B4608C1272106D1534A45EA225C149F24BC92F6E8A829B0CC974925405CF9EED3475121B280B1325E2FAFF3B500D0E73E3E27B03AC97442134A06691A9903F2A0C0A1E2303';
wwv_flow_api.g_varchar2_table(69) := '1C93DF8D0DA159C688212E84644E3842027ECE1B9BF2ED816A9B7194264EAB7710334E42C996C0BD7ECAD0B0287A18128418151D60EEB652769E266B09AEDF2FBF7D76779715DC383D4123AFC6ECD839749841AD912A81891555F329750830C49D2D65EC';
wwv_flow_api.g_varchar2_table(70) := '1C647C578051061442036A5A3106B8A234397FFF8E9A4A72D659BE109B3CCAAC1143E7C84A5620ECF696FA580ACC984AE89934DE8E0A70C15C3CD1AB6916D090056E98141DF4CF0EE64FE6E9A26940131C1D04FBF3B97F638346EF7FDF09AB80E7890E23';
wwv_flow_api.g_varchar2_table(71) := '061BAA8EB58C84FFC433DD98D4C41E4A6BC47F7310D459DC52A1101C50080DA8E944187E78F4C12E8D0C1C592AA820A209D7590C33D8463807CA212131716F3BF859D5D7460E132A6D6388A9CFD0C460D1016B1A66040D19E58611CA249BE69960ED2003';
wwv_flow_api.g_varchar2_table(72) := '010B6CA7C12994F3FF1D6A8616A9AC84282CCC769A0E9AA61DDA3954E3960A27749384DE8A3B3BE2B41A2455CE28144203EA6AF0609892EE2CC9055C1CDDCEA194246B058FB69732B46188DA2592A689822B9E1D04350E632A954104D41257365C6368D6';
wwv_flow_api.g_varchar2_table(73) := '88ED15C27455F0CF257613BA87E2A12A711366C7A7CECCFD1BC6B573B0C186B0DCC129F097FB419DC92BCD970A0B1D50080D480C83A0A19D366350C139A50F773CB7E8476E078C74948B67071A6CC9824C9943DBCA47B8F9735DF9BFC3A0C18220F4700C';
wwv_flow_api.g_varchar2_table(74) := '30A280D0D0CD0DE315484A93A7803CD7CF0ABBB7CD2327723F0E39381D5E0EB3F66F98C4032A157B281548F9D1AEF85EEDC685B4B11B0AA10185EA082D586208BBAF04FFEFD82F16A10EA090B8E0D1C8E7206B7D95324607DB22E1407725441D8A1BC13F';
wwv_flow_api.g_varchar2_table(75) := '47418B9B46096583B058BA8090313634741548C2C04CEBE220D5852F9E3C37104078CAAA01CE176303250A33F76F18D73B12708124E50E60E4A0B9A1B8C1FE3E3185C15D3718880D28840654BBD7A7E6A3A8C1C01EEA103F45033C0ABA5A9F83AC952F28';
wwv_flow_api.g_varchar2_table(76) := '6BB363075E47A3B0F8CD224CFC832E0925A0E8D1FA3198C9112884866E74186702564B8A96920D0310FADD5467F2D5A11FB938D094DB349D6F2BE6A80592B687227271F0A31287B2E37A7F3C0F6A109693494F2642030AA101D54B607EF7BDCCEF6C4585';
wwv_flow_api.g_varchar2_table(77) := '5D845EA9701485EE4843160A1EED78EBF0D831A3B7EF6CC91FA5C0F281994819989195B82F23344C21E460A30E2A104D25EB02E25882F1BFDE5173CA700706BAC633DBE87CA161146EA071630549F2143E0949A27C6B937DAF84ED142A907865442134A0';
wwv_flow_api.g_varchar2_table(78) := 'AEC61B544BB0BF0EA9B9D8C9A87FCCB6568A9413038BBC1932D557C94D53A58CCC18C4C35DF9AB0AC6127A17D05B826105B8C6DB8206CC4FE40E1A66CD19C3C658F4CE5308A9601CBC82D1562D01EE4F7FBFA3EB1BE6C421BE1346E6E60F0D740468A0F1';
wwv_flow_api.g_varchar2_table(79) := '4C6DC7A42A0A6137A66DAF2811425F1F064D81D748144203AA5B70E56DF8ECFE8EBDD8C5BE0B696288A30B500899416888E76E1788B8B7237F79CA444EA200830A574B5AAF5CDC9D97071AD43CA0A11B1D203D1136618259640BBECA5B10AA13EF8F5971';
wwv_flow_api.g_varchar2_table(80) := '9346E3E0A7DB6C3995E1DA000D84A4CB21ABD1940A1F8A1B0023A86DC87CBA2BCE7D348B442134A03A88C1FFE5D37562C6ED90B07CC18574EC803444E6EC9B603695E9B77CB82DEB9E71A332E996B6C94D4819E8CB7A1BDAE4EC23A8A58206353B0B87DE';
wwv_flow_api.g_varchar2_table(81) := '090B214D21A4460765BE14F65340E94CA0DF66FF1C31C7D43790823FD59A8609E210BD1D9F0A712903312B2A6B70529592C609AA747B8B9E56F03A89426858BDEC437AA275EC01D7E2FCEF77B645821506F55266A7F2D17657AA9477939D66093FD5E33D';
wwv_flow_api.g_varchar2_table(82) := '5563D28EEC03B747CC43600DC45C6B1D343530B08D54F25399BA9BD667DAE62958E7940A3ECBB4857F9D56CCF4B0AB6879FFBE0B040FAF1BEDD41D07BA422134A0960F179247DAC9B13ECF659DB1A77B706571C958C4C0173D4BC2965C40F1A3499404A6';
wwv_flow_api.g_varchar2_table(83) := '0E433CDB0BCE3D18C3D332550BFAA08D9B2A42C3F4A16120372853EE200229D4C7135BDFA0DFB47E74D6B0682FE7CE6CA7624E171A2A05B7F2E77351A32AE5FCA646BFF8A0101A5039E386763893263ACF15FB51F14D9744BF5953D984061B63883D1F45';
wwv_flow_api.g_varchar2_table(84) := '680459904F9FAB334FDADF4F186EC0C205848605384F8BC03C8DEB83B6549F4B3E584D93747D03D50C41E6D18A39817F437F6E207A95EE6EF96755B88AC4864FEDB06C28C03999080DA8658086763A31119EE9FA92C6FE3EA26E9147A58E32F329892E13';
wwv_flow_api.g_varchar2_table(85) := 'A7A4BBD27A5A3FDA06C34753EAC8A5F1A6690758B880D030077AB8126710AA15BA3F71F3BCE05399920DDB4341A391B053AF7598E234ED9EDC00E50E046A242B6B45FAE158C559CE7EB14C1442032AD7DC20A34E82A046E98B7D5A70652AAB3A609644E6';
wwv_flow_api.g_varchar2_table(86) := '0650990043100E9B20B240C4831D297C69E1C85838C16FDA0AA0170E5D19101AE65DE220B4CCF4D4809BA3403FF25F991337F46F8809C099A4BD822E821B92BA48625A340B84BE38502D11154B2919A87474134B1C101A50792686C40856CA73DFBBBFC5';
wwv_flow_api.g_varchar2_table(87) := '9DD0B7CE566619F73A926550E8AA69B03326C2E8C8C3DDE0922AEBBC10393899304310B4B0A601BB2D6606197D4A1C440B3A290288384803B04A3438D445FE7314FA3744F3ABB2E9DFD08F1B7C272E6E2878D0AE492A77B6799D46F7242AB48F6C0FAC75';
wwv_flow_api.g_varchar2_table(88) := '402134A072237D33F0A55CB9B519CFDCE326586A1D17585E88216205B9167A3EAA731363B0FD126DB8729906CBD0C90EA7592234CC0C1AFA041B5A1063900D21ED97343AA88049EBDF7044DD0D6AEDD1B2EADF303CDE105942955C525E77E5A90793E531';
wwv_flow_api.g_varchar2_table(89) := '4381D0805A024C485733D00F27D5E2868D2884DCE010DE395A22FBC4607FCEC09640DEDA50BFCBA64223810615C4264EB6E51237558486D941430F6E089A81E9BB84A003143740BA021E843C8512FCAF436AAC5098E9C3CCA07FC3006EA8468F40C8C1E4';
wwv_flow_api.g_varchar2_table(90) := '29F4F1BBE226FB540EDA0AA101A10195971C045437863945E3911CC4B060F38B92D3B707D4098B18F2E2C720A3C1D6262541922A484B0CEB9BC129783E0A1B1D455F68D4FC6B20069A4876174836030E382BF9EB036AD8DDCE8CEDB26D18659AF63C4B23';
wwv_flow_api.g_varchar2_table(91) := 'BDFECB662BF40F70428C8B83BD4B513DEE5D54C78D0C0AA10195016E48483F152704F7C326E77F1EF83044074CDFE2C2ABECB756AAC8B25AA45A2B6DBF2575DDE053098C9B5AA60AAB65020C28D422A161283740DC8B37792098F863DFDAA90DE086EC43';
wwv_flow_api.g_varchar2_table(92) := '83972A7128396EF5D58145067891F19A8CD080CA3631C4E3E8D23D9632B8A43E8C93801603B812AD85CDE2B9F063B0990841AEF65BBAEA9FA3A06D2AB7A5E992500A2750A116D36D31901B3A5B31A5680A65936875C61FECC643B4A9D31160A051D55146';
wwv_flow_api.g_varchar2_table(93) := 'FA29867003B1850EA45C702B4FF764E8FEA43AAA1C14061A101A509943878E0388DBFF287BB7375974FB221C0B0184E7041AECE40BD5690409EBD561D0327565D01C1148F33110080DA8C5B5688E640025380CB502A348AE41F7DCE7B7B7C2B3CCE97098';
wwv_flow_api.g_varchar2_table(94) := '6663061BE6D34F31344FE11748A950283DDC96675E98AA485F94C2EB12620342032A4B8AEC5D95F852A66B2E5D3329893E758E1987066688C142831D78CD0BAE7CBC1B34A531718250287C6C9B3C2AEE85A80C41430F74102D708A944D0573319BF09615';
wwv_flow_api.g_varchar2_table(95) := 'A765E66E881437B089BCA5E95CB8C11B661969476C570AA47C6B537E2DF72868402134A032A1564799916A0BF1E1D87743073A460AF15589AF11961F68906664A530198AF0E0C16E70EE43D567CB4083FDDD4D2BBC44C768D4F5BB2DA68F0E296ED0D020';
wwv_flow_api.g_varchar2_table(96) := 'A0219337A1DF479A9956FCC309735C9AE60667AE8590D7E7060D0A5EE8F814B662561DB7B256E49FCBD0E6ADCFD6B6EA8E86A2101A500B4F4C8491C0A660FF3BF4D6E132C49CA432203471326D08FDC8207B85902426066E2D19BEC27C5E2828335909B8';
wwv_flow_api.g_varchar2_table(97) := '18E91BB6A6698BC7BD10359516CDD9953834E14D0A8E4F9A1BA400DE1542BF87C5AB7D6FBD18CFA1B0F50D3C3575766ED0300A3AF4E00607BCA5E36E4C6B35ED818B83CBDF1FE92B5257860285D080CA4056C2DE7637057FFD8E165CB88EB8DD69513E90';
wwv_flow_api.g_varchar2_table(98) := '1844160B21098FDA25B8EBCA8FC7FA17150A10211C62696BCA6C97690B230DA86940839A55B00130D71EB7CC808AA6D08F688408EA943EDDB5E60DB60FD35F447A62626EA8A61E4F52150E7C7A42DCEAFF0E95B57E42624068402D24A8906E91084FC516';
wwv_flow_api.g_varchar2_table(99) := 'FCAF14D4FF73CF8FEA1C597EFC18D29D113235604298F484B4F4F0FA50D958279A35A172D68A396494B65081BC60ECD6164D9D897E6172CBC8EB90C4542A22ED2A45CED3FEB3E781E02A8E86AA54A103F6662234A066194FB0250B2A7DA6854767BEFF78';
wwv_flow_api.g_varchar2_table(100) := 'D75B733921ACB3FA3A17A3AEA593E042BADF327CFCD1AEBEE880F1631B0B1E51B9830635181A6022AB90FC142A9763AB069E7F68F0087043C52125E2569EECA94B1666514337B6E82AD6541884406840CD901BE29195F6537D20CEAADEFD6D5670C31112';
wwv_flow_api.g_varchar2_table(101) := '4E020D79F16390B12B433CF93A767E2C6E04BFBD90995A613E0285CA7A57C5C8DC00B50E2DB0988669F5D766853940C388DC009FBAAE297720E50229DDDF96E73EF8D34688203B63A5288406D494158D654A471802F1DDF36E6FE87B141645F5E3F404CF';
wwv_flow_api.g_varchar2_table(102) := '0F34F4C60893A108BE942088D932E11568B3C49247544E5B31FBD94B7301232A9450823DDD6351BFF1A2A0617AF106124ED38E1A324B7736F9F78ABA7AF383150F080DA8999635C4F940F1ADE217B7C2E68874A79693273F8630B4E074543684A32CDF1C';
wwv_flow_api.g_varchar2_table(103) := '40B78499D009C59E186940E51F1ABAB9A1251414462AA894BCF4C5CD4DBED0F4C4B49C22C15EDA2161D4C1B1D591A474A3C84FABB69621BEFDC1BA068406D4CC7021B18856F25B99AE6FB0B86C2A9A70CDD6002078DE220D0934442D1EEAEE6ED0E23088';
wwv_flow_api.g_varchar2_table(104) := 'AB1D486BE5D4C238036A115D15D39E87A93AEDA55513FE57099820233F95A8716E5838345C33E4607B28AA049E135B3FE98393F5A28078039CD0F1054DE2E51DA10135136808CCA48940F16F65BF08C4C0CC39C9D7080D2735107BB67352C88B1F83FDA7';
wwv_flow_api.g_varchar2_table(105) := '9543E2CA06F093B8590CBEFBF6B786EB29B48740C3B7446A40CD1F1AD4ACE6689BB484944D98A4ADDFE5106FD0F0F0EAD027B98706DF80422535D7AA02FD14A4ACB9E166515FC1C210433B9D6E452134A0A62A61905C7EA9306703EE455C686A0A07573A';
wwv_flow_api.g_varchar2_table(106) := 'C4662894E95464F9F163E01D5909E359B94E8257CFB9FE851B5024A57F6BD3EA0DD75C53D68042CD1D1AD4B4F214DDDCA0C09D4C7303D7F0C0219CA6CF73CE6E6F64011AAE692F1DDA3D39615D24F46192D00CAA7463837DAB240DE4480D080DA86BA621';
wwv_flow_api.g_varchar2_table(107) := 'BA537DCA16412AF1B944D78A76AFF54C44818DE6CA20B2BAB8F17C0C34EB38D160AAFB7B680B8D5A86A20739E22C2BEBD820A4EDA4684A7A4EB953A0D1D92D0A2E54471242A73799824DB59F62F456CC6AF46079DDE5A725DB4AAEA26803E629101A5093';
wwv_flow_api.g_varchar2_table(108) := '4043880B2D957E04EA18FE2BF9C54DBF40A849435C9D6DC373080DE98A48B0802C16835FD063899B146A192A2547E0066313693E33D0A0A50FE4FF0EFC8E739CB031476667131A6C3345D9011787D27A517CAB5C29D80A6F93B0A502A1013592D2E74C34';
wwv_flow_api.g_varchar2_table(109) := 'B5D2F8317C0662B0D58E9E93AA7CCC3934002BB871B32891FF7B677A2C718F422D3F34C4E860BF04ACD09461B9AFA0ECEE76B2F1BB638FCC9E33348CEADFB0062D1565C30D950239718B1CB82171AC4BFC1B9A98B44068408D20D9C9DD9620F8A7B2BFE6';
wwv_flow_api.g_varchar2_table(110) := 'FAE66E43388485D58E848F6C179DE93083134203744C80AF2E1431E026855A0668183AC82A610569830D52988FD02155614E114A8309DC2430679AC50DB3808611B901265A111257479EAC6B6E28C537481D490AC4068406D468198AB451B464FF9DD0B5';
wwv_flow_api.g_varchar2_table(111) := '4D61AE1D9E5348EC5F9C317C9CB21C6908FD1F9D62F0AD1AD859BA080DA8658286A1B60D4D136F304F8B3E0578167F1EB0C8589A47498A2C43C350FF86AA9984592984AD98364F515E77D9D74A0FFF06CC502034A0462C6B8889417C3AF1D68ACC8C7CA4';
wwv_flow_api.g_varchar2_table(112) := 'D1E45C66EA07696E0D1F3B47609B4843A110BC3A348E8FE04B8FD0805A4268E8850E212BD8784374AC8C4324D0F325A5C54DBBFDCB85A627A656E2B0963845DA4E8AB269AF28DDD8E0DFCAE1641D1B6F68E33C2B8406D428350DF64C69C1E923BE943431';
wwv_flow_api.g_varchar2_table(113) := '407C72CDF831D815052A8593A7219603A041FF3AE2F696BE3E82B98D317D09D0F911B512D0A03AA0215E526A76164D33CDEAEF63B65E6493DA444E171AAE3F9FA20C5DE22637B15628A7FA292AC6BF417CAFC0B9DF52989D4068408D11669026AB27BE54';
wwv_flow_api.g_varchar2_table(114) := '28819B0C6A4C1E59CA283A1930E1E41E1A0233FC5A7E2E59B7E8B07A1CB728D4B24243AB0734C8CE9083E9A78047B83E275A82DFDBD1E788BFB60CD0E045350D61954354DC60A30E27C50DFEBD9AE4267096154203AAA3C4A7152242DAE124F463F85AF2';
wwv_flow_api.g_varchar2_table(115) := '4D8C819330C6307AA344362981AD417C5599FA4DE644C726E8CAFE7C1E58E3A6A61934D1D2174A6CB9442D1D2B8CD38729F4592054D0904C9F11BF7C9F6CC4336CD31591D641953973727F9ACA648A6AAF5586DC2BA998FA06F1BD234FD155E9A5B0D001';
wwv_flow_api.g_varchar2_table(116) := 'A16165A921046AA9E2AC84392DC0C1C9BBB169AF051D73254626860C42038F47603B1D23B0F97A31F85A318C60CD19E00A8AD0805A6668688D64FA14081B88508110E2D521ED93A1A073B48C9CD6588AAB2BF49C26A454281CDF2CCA9F5E94A9EDC8DD76';
wwv_flow_api.g_varchar2_table(117) := 'FE2F0AA161F5D210E946237B92C8AF252F2A7DF22357B825800669A652F1A88E213EE62F0F0253292E5B30C046B5846A1B9338146A85A1C13C47CA160CA780E1AEE73EBBB9D9919A5C84CFF4B492143DA1A14A48C5144882CFF4CD0DE086F066C250421B';
wwv_flow_api.g_varchar2_table(118) := '0DA7111A50497421FC9C7FAB548B455A30931ED742D75861E8612C62C82634A47B2C95ADC6B8510CCE6858C601B59FD09D0ED7099C31815A6E68183A93C29C07106FA89B11986DA1FE3E4A374C85790AA787336C76A0618C3C8589315452750FC7B736E4';
wwv_flow_api.g_varchar2_table(119) := 'AF4A473E22E40604078486D5542B24067B0A401DC38F8A7763CB5E0B6C77657C75F0C76994C82C34D80C85B276D1C6A54AFDEF50FFEE425F136D9CA505A5907031456840AD02340C188029E093C00ECE568AB7353D507E6BDB7043E2EA46278D3ACC0D1A';
wwv_flow_api.g_varchar2_table(120) := 'FCD1EDA59D0E6838710AA5DB45F1DB4F8AC03A52BB288486D54B4F24ECACEFAF7F56ABB737FDA8F29192E872B0369E1F43A6DB251C9398882777DFD90E6A0C12136DF06650F61E424A1B92C4DD0AB5D2D0D0D4D820F4AD85D0D0D00AB8EDC2FCF7C473D2';
wwv_flow_api.g_varchar2_table(121) := '5E4FE15542641B1A468F37F88454A2FA061B7B38BABBA57EF989BD3E8ED24668C07248F8704EBDDB498C8145C64DCC9C6F7C8D2C0334D8E84281D8A8035B23F29F6353062A3B5C195AC80B2884063BEE52A8960468D0BCD0344F169C3FD8F652DDD7CCC9';
wwv_flow_api.g_varchar2_table(122) := '07348CC80D9615CA26EA009D990E392914CAF7B7C1C4250ECAB6111A101A561618CCBB5FD679F5C19E6F428EA24FA451E41F1A6C4AC2A660C105F2CE6620B8C9D0C828BAA06C2D6480DC80C24843782C8C73039C254143317DC1787FE8AFBB093490EC76';
wwv_flow_api.g_varchar2_table(123) := '4F8C95A7B0FE4EB61032DD87A92F8C9A1B4ACFF6549DC7595D1442C3729381EAE1A36E7101F2F98C3FDEA5B12D74FF9AA665484F988206652E3AC187634D0A4113F1008530D1DBF4A9A7448BCB7BBBF1D46C400787F0B99B3ECDA703B3129546428DE4AB';
wwv_flow_api.g_varchar2_table(124) := '7DA879BAE2F8A492464CCC5B20342C5D1AA20B1AF41D367DB95F5D23716ED22F2C2D34406E8244F60C77B7558D423513FA31A0101AC68106084A7C3CA10E09ED5B08996E21E4FCA1C11B060D65F3B144DCEAEB83A0DDDD7296AA0C4321342C1331B45373';
wwv_flow_api.g_varchar2_table(125) := 'DBC2DA5FC9DFBEF39DA26F1A25C233D9990E3164B610D2265F83BF8FA5C95062C1230AA161C02CAB1ED0D00A4493B17BDBD6FC2D9E60976B6818C00D7612A63D28ADB9D57F8F545B26B761EDF0EA8A42685822D93C7D3C243EAAFEE51F8F2A4E58E11807';
wwv_flow_api.g_varchar2_table(126) := '1BED7DC3357121B3D06047608B9B1B419D87D080D32C51080D03676777AB198840897F8F598158E7379AFF4843BF24454C0F501A69066A9FACB9F4C34947A8A11D2EF8A3E07683D0B00C3296E971A790ADFF659F4B9EEBD254DF54CF7E6BBE4CD0E084A6';
wwv_flow_api.g_varchar2_table(127) := '90C15F87CA943F9A6C2442030AA16110347471839066767C9D893BDB349A5A27F20F0D438B1B6CBC010E6E6C32986F97AA61889C22111A101A96A898A11D672814FF52AADE308EB084D8E8220F9DDD3A0A9AF8724183AD6650C58DA046A50DBC48CD5208';
wwv_flow_api.g_varchar2_table(128) := '0D28848621D0A0BAAA1A9A2A6829F9CF312D10BA4644AE220DE3861C6CFB65480FC4384CEB83F50DFEA36A7B30D34EFCAA8DD880D0B01CD0D04E4A75D4AFAA77778B9A1D94A68B189CEE30E3924183197449D4EBC320B0660C41D0347E35281442C3C853';
wwv_flow_api.g_varchar2_table(129) := 'AC6453C8A60468B8A0F4CEB66D9DA0B98286B18A228D738341075B0EA93FAE8101D4C9DD2DF5C34B820B58D680D0B044E909339BAA65A0F89279F777FCA88EA183129C8EF4045F4668E06E515DF826FB08273BD8EB2334A0101AC61999AD2440836C017B';
wwv_flow_api.g_varchar2_table(130) := 'D3BFDE89025441F92467D0303A3778614103A99AC1D97189C34981941EECE82B6A100FA3406E4068C82B227425DB82A8B1B8C5BD073BCC9838D1613366F20B0D3219844D5464EB649D9DF8EB7DE8986A07C6CDC9E202764FA0101AC6B297361E6842B240';
wwv_flow_api.g_varchar2_table(131) := 'A83A63CE062364026898BADDD38C6652F4EDC33496919547BBAA29BAAFB757C3BD582289D090B330038C7014DE8BE7D42D862727597E6888075A869D966B6EF0B51CD8699666A02518482334A0101AC6738A8443250404EAA410CFF647B909594268B08B';
wwv_flow_api.g_varchar2_table(132) := 'B8DEAB83B009B31731280C3F2034E443ADD43C2A53FCE8FFFDCE77DC64826561C9A141740EC20603E9473B81807B02610B1AC28B2242030AA1611C68D05F825956500E24DB4A7DAFF282CB960B1A46B1898CFB29CA8EEBFF73D4DD3981764F080DF9AB7E';
wwv_flow_api.g_varchar2_table(133) := '4CA6B129F1A5E4AD157957E5E35243833483A9202BE144DCF0A9A45F134D0DCADA5BB524186CB770F34121348C030DCA0CCB6EC9A0A9043C5388FB3BBCB06CD030941BAA29B3C8F25A917DAFC8007B2E111A729E98B05327C4CF8A57DC48A6CB8CE6E096';
wwv_flow_api.g_varchar2_table(134) := '7F68302909030DF0F8CD8DA0C183B6B9CCE953DBB84707080D28848631A141B4001ACC0C4C69337CE203183D2D1F34F4A4872E682845E870747B935F50DC76101A721C68B0FF2B2FA97F77CB2BA48CDB9C8237901596001A783402DB0EB4E4FAF8E5BE32';
wwv_flow_api.g_varchar2_table(135) := '2590A17574C40A989C4021348C3DFDB2099F72137480A7D428BDB1B5C4D0D08F1B2A4E5411E9C224CCEAE35DD16071E9236E43080DB9297B845ABFB6A9E73DA7DEB3E7BE3187EE000507F6D17ED18565800627820633D392AF6FA81F55287A6C1B4AD017';
wwv_flow_api.g_varchar2_table(136) := '3BEBF96A2A2251288486D1A14135CD612B2A6B3023ACD8EBC3558486C8FDA9A49FE39063FDE9CBE76062814268C84974A1D3C8B429D8DBC3B2E3721B5A30A50C940C328A5F1E6820000D328686DBDB410B9A2C61B26DCB5C073557D93629B4694021348C';
wwv_flow_api.g_varchar2_table(137) := '030D8108A079A20D990A8834E83D52297E5A5D1D68A846F3B2AB51B0C17A3994D70800C4C79330CC902A454721346437291175F848FFC3A16776CDB46BCA2C8A18B239CA52983113D6AD417C3809430B28D4D243C3B4A8A29FCB53ABF7FC4B7A770B8C9E';
wwv_flow_api.g_varchar2_table(138) := 'AC21FD359A30E954977F6D8CA80E9B65D5B54AFAB7382D8713B48368F40FEE4E080D99CC4DC486A61AFCCBFE5AD1231D27E1AA4043CC0DF6A35B0C7E7A26C988422134CC0A1AE49B433BBC2AAE9DE2518073B5A0C12994DC223BF79115101AF250D06024';
wwv_flow_api.g_varchar2_table(139) := '2E7C7A63D352823F9A2BC3524203B73D148F76032930D2804268982934043FAB3E71ED449BC4933EFFD03001379CE88FF7B785604986029314080D9985062E197DBC3BC119BB84D0E01827E97F8F8D911342030AA16196D0D0E4F4DE364F5D79F852A427';
wwv_flow_api.g_varchar2_table(140) := '867243E54A69648598668A3FF6F4AB66670B63D001A121BBB590F4CD811725147D32C679BB6423B06D0F05778BC185AFDA080D28848619A727DA92FFF58EDA0CC5D241833766B0A14CA0B8C17F7F6479011B2A101A322AFFC391EFB8D4B44B78EE78E7EA';
wwv_flow_api.g_varchar2_table(141) := '3241038FC64FF047BB309CAAA5303D814268982D34E87FF197E7BB6E3C299B3B6499A061AC4156D5F0C0A55FCA18674068C8686E429D56AB6B45CF44E67DE3FC68E75FAF66A481DBD6898F909B00FF4784061442C34CA1419A36EF873B894D9C53583268';
wwv_flow_api.g_varchar2_table(142) := '18851BCAD1AA5ABFC8F522BFF4B1A601A12173C4A04FD9EA8D2D7FAD684F157B9FED99BD73056B1AA413FA3B05179EB16708640BA10185D03043685042A3B9946F0EE2EB893F518622E3D030FA4C0ACB0D271A1D6E6FC3A80E1442C3E20A1792B2C7E89D';
wwv_flow_api.g_varchar2_table(143) := '28BD873B5D67CBAC5921CBD010CEC57EB4072EB741C0DB2AC048036A45A061CAE64E3D5C9EBA5CA523A748183A2FCF7C5A800CA92D6BA0E3CFA4A0B359734087AB950D1507820DA575421FEF68A682EB75521789290B8486F9764984EFB976A0DF8BF4D5';
wwv_flow_api.g_varchar2_table(144) := '4175CD4568E85C2478FBCE0C9A08A47EC5D02E1A85D0305B6850503C5463ECF6168B2D6857091AAAA98114D594D7D3B1E106EFEFA3F8964F59686823382034CC472D938F88DE80EC734913039B881896191A4831F85E8DEDA26110360A85D0303368904D';
wwv_flow_api.g_varchar2_table(145) := 'E3CFDE14FCF5018F12A374D1E989394343351A96DDE511A9D7C95A917D2D232520342CA8E6312256FECBF3DCD0C7690262584A68B0EED1E2E65620B81D2E11B4CC9470140AA16176D0601E063BDAAF255E20BCB0A2D0D0156908630FA6A5E2E466515CF8';
wwv_flow_api.g_varchar2_table(146) := 'AA2BD18C4268985759831292FB0F766D7F843F11312C67A4C1DCE2C867FBE0E9040E0DFAEE27409B061442C38CA101820D9ACEF9A5CFDC0D51C8C4EC89990EB21A5011D9731E66A950283FD9554D7125D78C4268987D21A4F1713AF4A3D3CC9F743CCCF2';
wwv_flow_api.g_varchar2_table(147) := '4183B9C521EAC34960AA19A0A8A109F480422134CC141AA0AC41C1CD0C7FB8CB27BA87C91734F41B8039609DE8EFFFBF7771451A420342C3DCC041F1EF15DF091B2CBD6B8CA35D4A6810EBC5E0CC4FE65FB7145634A0101A660A0DC24203342C49F1BF77';
wwv_flow_api.g_varchar2_table(148) := 'A24056131AAA4EA14A3A6C1B6C6EA21C953B9CAC17F9690537318486B94AD6B97773DB4B39B6B202416888A141DEDA0C9A42D9DE0963078991061442C38CA1414048CF6428C4E792308D97AB000DDE954843D5E970872C3B0931946D33C5835D51E368DD';
wwv_flow_api.g_varchar2_table(149) := '80D030FD8247D8F052BEE52ACC8149FFC973DBCBE439635733C49BFD1243837A75A88141801724544182B95380B10614C2C175A0A19B1EBAA1A12564D3365E4AD9606C6D83E7B610F23A950D03721369C7A7EA8BFDEE96CBB6C242078486297549D8C47C';
wwv_flow_api.g_varchar2_table(150) := '54CE40FF3DAA163742CF35273C2DA983D0904043F0EFB18606698A1F111A50080D738006CD0A4A46D020B9B8B393DF42C85940439CA7B08E4F27C50DFAF1A4474524120342C375A0410630342119ADDA0EC46F5ABDB9E1D90DDB4940DE476888D79A1BFC';
wwv_flow_api.g_varchar2_table(151) := 'ACC6ED12C6A441A93642030AA16186D060BF249B52687AD0A7DB8B43BA92D03038D850326186B2031F4F6E6F8A730F373A8486297749C415B6B0FB49E13D7EEE1792E8028DB67F1FD313F1BAB91934B96A2B53CD60A04105080D288486D9424333050DFA';
wwv_flow_api.g_varchar2_table(152) := 'ACFB58F21DC257121A7AA243B5406268B05E0EC7FAE0E9AE7EDDC20B3E061B101AA6000D2A156608A4FFFED02B14C31E4B02050D3134D091A7D02E3F343CDE038706EBEBD456B61C12B71E1442C36CA14198C70C3440DD318CC92EAE323454FB6428C263';
wwv_flow_api.g_varchar2_table(153) := '62420EFA3BFC7B92BAC847FFD346E7278486EB051CA0ACEF67A55A2CC6278067A121F66AC5F444BCFE7A17D8664B99CA5160F7040AA161F6D0103EDE52B2C1E9DD2DB6DAD0D0C50D65430C9E6DBC740A25F3E9D1AD4D795ABD125D40684068B8A61ACC7B';
wwv_flow_api.g_varchar2_table(154) := 'B0D37102C42590930E9B585A1BE9EFD0032D4CB32542030AA1614E8590CD40445F1260A726C5D3E7080D5D66D25D9D143649517EBC1BD458D039C11885D0305188C1B45CEAE5BF79E717602A95BF969C5766CF060795B1FAA1971F1A2EFDA01508DB7262';
wwv_flow_api.g_varchar2_table(155) := '91A1853E0D28848659174246D0D0D4D4A0843EF95E1D2234543B9DA46D59437C7C6230E21D29F89F4E30BC80D070FDEE096527B0AB96F4ED88FAA8F8914E3A9E6ABAB64E0B870C666653A90281917A4E41EAEF7F7B13771914C2C1F44061E0B0894EA706';
wwv_flow_api.g_varchar2_table(156) := '787E53097DD0820C053F2D67071AAEC910DE0C3A30D38E4F276F0E614A4E1B9313080DD78A3444D020253523EA696A30154283887E0B0B0DDC40837CB883BB0F0AA16171D000D69026F2A0C4AF2A23EE8A43437504682839C4FBEF845E329C4681D03085';
wwv_flow_api.g_varchar2_table(157) := 'EE09D90A6453B05707080DFDA0411ACB0ABD0478411E182F2C140AA161CED0602B1BC0E5C97C54F292B21B9B080DC3B9E1F626FD5EF5CE29BFE458D380D0702D68D027AD6848D114E25B89D9F2058486AED9544E040DA6C223F8706CCF3ADC8350080DF3';
wwv_flow_api.g_varchar2_table(158) := '840663D2A0426868080D0DAAC9D9831D8486BECD14B1B1F4D33DF6DBD7D0E0FDF2C1F91EA101A161E2F4841052D485684A51A3747DC3C79A865ED0202268608E1B98D60984061442C3BCA1A169FA2E9BC61BB221ECB84BFEC7738486C121879243FCF7EF';
wwv_flow_api.g_varchar2_table(159) := 'F825D3C4E09F537AE6A3490342C3843206EE02A001FA9E057BB28785903D561A1ADCA2BAA0480C288486854183B9580575214DD725FFEB1D42C3606E38718BEC7B859E53FF8CEA8FDE8F2A6F70DCFE101A067749F40A33E813B8CE011A203D01A72CFF70';
wwv_flow_api.g_varchar2_table(160) := '4C0BC44768E80A3638A98FB7B69414B8FBCC6933432134F4840629820640830894FC54426818126CB8BBCD6BD4FFEDB30BE6FFF6E86FDFFBEDC926CECD4668182B31A194A60575C979534086C2A409A114B9E06221648F0C45040DE2CEB6C26996080D08';
wwv_flow_api.g_varchar2_table(161) := '0D0B8106A1644B8916744F5868E0FA4A765A5D3568183743E1FF71402F29BD64EC37D5C4C0CEFCEA2FCF3FA3B80F22348C117800FFF686604D1ED425375545A68B49D0BBDBFE94886181D0306DFE2052FF3AC6F34AFCB91F04989BC8EA6686AF4F06D720';
wwv_flow_api.g_varchar2_table(162) := '4A180D1A9AD1EAFC54358D35648DB335C2A28B9531A38370A9C80F347893AE1EC440883DB07ED221407CADB073C62E183DA3B07EFBBE5EBF7C5EE34303D2080DA8303121202B217893ABBAE010EDD3D82E644BB23FF6BB6A1A101A8469B9D4D000BD97AF';
wwv_flow_api.g_varchar2_table(163) := '0F111A101A101AA6070D238419FA4083B4D05017AC584C4143B861F39584868A53E88606D7F57E789A18343784D000DC4035346874D02F276E88080D43CA1A6C624213032C0D0C800ED072A91F552D29FE3BA10E990A312C0D34843E0D047E23F5CF3142';
wwv_flow_api.g_varchar2_table(164) := '03420342C3F58CA265CF350634C8041AA490FCCE66FA9AB3B2D050090F888506FB88776F3B0C339CD3041ACE001A2C4C28859D14080D833B269A92D7790C0D429F7222CC118267C3854FDD224243D7B23E0D000D5FCA080DD9DDE4F0F5CC3A2EF4850639';
wwv_flow_api.g_varchar2_table(165) := '22345CA107FD0DF9A31D7A050B5633D290D43410136FD0DFFFE53EAFF1101A2C379803DF2429BC9F9EDE08705B44681858FFD810000D46519801E6D3070D639CD212F4DE364243CF78037348F0ABAAB0DF12A101A161AAD020C78206D9090DFA9AF6E7F3';
wwv_flow_api.g_varchar2_table(166) := '2E4AA0B92A849C0934ACC141C971E987630D0D1614C2B286143D6868D00760F7844268E857FF1886192C3408B075323EEE023A994CDF337B7580D0900CEA74526D1484A84B1FA101A101A1611C5C9053F08DEE8286143A0034BC3DF00B84A72E59080D16';
wwv_flow_api.g_varchar2_table(167) := '1ACAC50DF6A3CA2E99258624DE1071830D367457442234A0C2C484946198210D0DC24043D3FEAF82B2862F25848638C060A081841591EB45251842437637B3656D31CD3731C811275F0F87862BF10661A041FE73A4A1417442035DDD9A062887D40B9E70';
wwv_flow_api.g_varchar2_table(168) := '6F875DD2181AE88561858B30CCA089C11637E8A57702DC22111AAE2426448A18ECC766020D5CFF6F2B504DA5CE7D8486ABD020F5417143498ED080D080D0301A34C8E9438365057BD0324152FDFD3E1E5B6860080DE6F10A31D50C05429F3C670D06D070';
wwv_flow_api.g_varchar2_table(169) := '41C330C3452A4961220DC623D2D307D87289D0D0A11EC460830DCDCE34A111BBBFED9368D734C6D26C6061D11243034F0DBAD42F4BD096AA85D0B02CD090979D382F3FBF1CB594211E40355E4D43B347D4011AC84F2B349D9570169C9E98A9ADD3A82E4F';
wwv_flow_api.g_varchar2_table(170) := 'A6E5D2FF7CC22F001A6C6EA25F86A2B76D0342C34A87195AAA2B31D10D0D2974D04FE67F3CA74EB265D261D5C8AB020D0F0D3428840684068486C98B1F6527344C4E0C1134C81F55EA14782734D0D58606E30549E8B732B44E5C7670439A18126EB0B60D';
wwv_flow_api.g_varchar2_table(171) := '2BEF2D8DD010D63FDA3043DC34D19B1852D020FF3DA666CBA4A3B530AD0834F027BB412003840684068486F1A041F68306796D6800FDF268CA149216101A4CAAE2E626FFE50D8286181D6C45E40F4F7F7A75FB406858C5FAC79018FAE526AE42C34F4DEE';
wwv_flow_api.g_varchar2_table(172) := 'AEDE32FD2831613314AB090D8935E41F7BA638244038C0856B3268184FFD40A10B1AF4CEB7EEA6A181AD3034D8CA86B2FEF868575CD2ABD0D01D6C48DB3DFDF4F44E81918695AF7FEC4A4C34FA10431A1AEA8CDED8E4080D9DC7F2E53E00430BA10117C2';
wwv_flow_api.g_varchar2_table(173) := 'C1586B7C62181C5DE8FAF482D2D0499AF011BA2E97171A48080D0E4083F7FA40D6398BA1A17F86C2B651E8A5A141A3C32A7B44AE3C345C316618949B48E7085B923DDEEB38F19C9536770A7D21DF1C2034E0C23501344C0717FA41438DD19B1B080D3134';
wwv_flow_api.g_varchar2_table(174) := 'C07288FFF1446868B8EC010D5D490A5BD3102729F433C3AC441BD3139898680C8706505BF1B7EFA843E24248E6AC624D4357BC41BE3D5C1268C06D0FD71CA1619AC4D06B6C956C707A6B8322341488176728D68AF447455FFC691A1A2E87F450C4498AC4';
wwv_flow_api.g_varchar2_table(175) := 'B601A161E9430BDD6D96B568CC44B460287617345CB55DD3FFED7F279484ADCF7E61455B2EE32997F67797FF4368C0856B66D0D09C101AF4758EDEDE4468484383B7BEC1CE7DDE959EE80A3644DD139621C2DECBDF2B3DC8AA8061869E9D96834EC5C89A';
wwv_flow_api.g_varchar2_table(176) := '55E8371329D242DCC844AEEFF5943B986091BF531869F8EB08CA44DAAB6716342DDA90B8E32E771A624A7E0C6331042CC16E6FC58E32F44A1BC59CD7B4A06144A448738317FB3B3DD96582F1AE30C340C386AE8AC8EE41566D8486A5AF7F8CDB2C3BB312';
wwv_flow_api.g_varchar2_table(177) := '23420354D0DCDA4A43034368787F146473C4E57CA0A185D080D03036314CE2C7301E31C04268484303AC17FBFC7AD0A01F5CC14156AB0B0DB6FE11568D8F5E029948BF57A4E44FF652D050584168E01DD040E4FBE3158586E96E42B8192F510BE580354D';
wwv_flow_api.g_varchar2_table(178) := '3F8661090B7E671BA1A11A3D02B64E7F1FB106E7B589A0C1D4457A3F56B1FD7255A1A11D84B8909A823D1E344819B49578FBCE9FA89401A1016B1486EF3DB8252F3534C8E9764C20348C6CD5A01F2913C2BF958742C3606EB00329562DD85058DD30438D';
wwv_flow_api.g_varchar2_table(179) := 'F774731A071A02F15FC977C88823EA97191A0A080D93E62006C4B1714BCEBFEFC21488A1399D85D0902E6828DF288ADF1EABB31ED030801BBA820D71FB2542C3EA8419C25E89510A1A3AA141D929F5BF3C7FADB8CAD0C0BA230D47080DD7BE31457458B6';
wwv_flow_api.g_varchar2_table(180) := '34C46271010B217B5441DEDF16350A7D13FAEE717C68086D1BECF4CB5FAB156C58C596CB8E3043AF48C348D0D084B206D1E0ECE666BCCD63F744D83D81E98631F69E9E5B0B7243BEA1610A9A2631400F39BB85D0902A6B78B6C71BCCF65BF2DA1068E8CD';
wwv_flow_api.g_varchar2_table(181) := '0DBFFCB8B221F17A426858CAA6890E62E855D3302234889692ED30E8C7A65DD9906768C01A85B1369E8E9DA63737E09EBD6AD0D09C363434101A92E51788FFEA800BBD118809A1C178364003C519041BF4C1EA041B560E1AC28E897AA7A1D388D0D0890E';
wwv_flow_api.g_varchar2_table(182) := 'AAA9545B79AF0FC40C220D79810CD639EB52BE3636D273185895D7FCF7D0F0B59ACEC26D7E26FE0AD3F65D983143C0E5AC29AC8D34C4449DD0868E2D941816090DE615A86868F8AF24EA820A28681017628CB286D8553A72870CDB2FCF5665FAE56A4183';
wwv_flow_api.g_varchar2_table(183) := 'BE58F48006312934488006FAFE5DCA618DAC2C34D81F43BEDA0F561C1AE435F3DF080DB98386497D17661F75D0C420EC25EB92D2A29D3D51E0080D0E615F2B000D4DCE6A8C8F0F0DF108ABB01CD24CB14A8CA531D2B004750C563619314D685001FF5266';
wwv_flow_api.g_varchar2_table(184) := 'B3E9BACC1D34C0C18BE7C17C6CA4F3B11BC96B16CD4D0E138805F3ED8698C4776146F908D10B1ACE7DBA8ED0105541BA45FED3D3D0C004E4267AF83B0DCE505C81065BD900C186F632C718562ED2A0AF14FAAD309418468586A600C7F89692677E3CB68A';
wwv_flow_api.g_varchar2_table(185) := 'AD76A4010E9EED85D0B0EAFBD0D5CD7EA4903542437EA1212B450C22E186041A7E7B74ADC8165DCA901547C85B9BE282F29A303E0DD38006D37BA957B7B1344243AEEB1F21CC50E35386067D3569707F7D63164ED2F92A9C0C7F86473B415B2E27344CB8';
wwv_flow_api.g_varchar2_table(186) := 'C1A8B1F6154C5B64350D314B629825348497AC9F554A5C8486703DD8161A17342B804F431F68B81C0F1A6C6503783D2DFB14AB558186B8CD725AD0A02C3434956C097A771BA1216CA3B8B71DB4C4B241C3947617792D6898523A03A1610AA9A22CF82E0C';
wwv_flow_api.g_varchar2_table(187) := '8606D1050DE25BC5CEB74468A8E8FFE48F3DFDCA24D0509B041ABA3C1BECAA7EAF2EBDB1746175C20C716E625AD060AE1801745D3EDD5B6CEB04CB00313007A081DEDE0CE41241C318DBCCD016CA6B696A9B1C42C344D020B3D745D9B79AE12A34B424FF';
wwv_flow_api.g_varchar2_table(188) := '7C124283B3D2D0E015888606F6E6804B1B7866FC12A0215E636528AE72C32A184BAF043480EF7A2D9934D173ACE5C4D02002255F1CAC2C34884E68F06F6C044DBE24D03049ABE4AC5AEF101AF20D0D730A30D80361A121ECB734D0C03E1E87A3F52C3438';
wwv_flow_api.g_varchar2_table(189) := '70C2AE28343805FEFE1D4043DD6C071A0E268086B32443117660A6820DCB5DD950588530434C0CDD4B4CDE3A015712F07782CB0FFF78CCA76D239D9715553310FDBB4B7D4CDCE092CA2058B5DCF69C35BFD6CDA55DE3FD1D73400F061A447CDC10F0A9E5';
wwv_flow_api.g_varchar2_table(190) := '06FDEBBE3EF0D6DCB069C2C92E1CCC081AE2A589417303FF5A8112487DF778C9B9296EE80D0DA30DA1B85AD9005E4FCB5BD9B0FCD0105633D4867B3A4D0A0D4A7E29318486101A883AF397021A667927DA9C033720164C1F1AB29BA41057A04144D02000';
wwv_flow_api.g_varchar2_table(191) := '1AC4CB7D8F1084860AD11F5DF1BD1A4303AB4F1B1A8C416438C5AA8DD0904737A7B8FEB136BC9A613C6890666895D6CF2A33B32E57191A223F69A24E2BB982868C85A91792B3C8137CCCF6F71DF052CB0CD63C5E8186E85311BB47C3354D3FF074CF8BAE';
wwv_flow_api.g_varchar2_table(192) := '51161AD84A424395147C7743FCF6B885867060D5F8D070DE171A626E58D660C39243038C6989EB1F6BC3C30C634083C9144ABB215D52E6BA2B0B0D3C0D0D8582FC78A2101A26DE45E697BF58696898B9E650F078951844641D6DAF63229CE20BD1D6FBDB';
wwv_flow_api.g_varchar2_table(193) := '7E2728AC28343805FFD616983434040BA1A17F21E4D05AC8ABDCF00BAA1CAADFAB30C5EA822134E430CC50E7BD3B2DA7050D4D63D52038BBB5B99AD0C0BAA0C129C8B7EFE6010D59AB5198D67E80D080D0307A44A18B18E2FAC74678A0FF1FE6F1D605BB';
wwv_flow_api.g_varchar2_table(194) := 'B5918606B6AAD000FD96F77744DDCCB7B4BBC375A0E1BC57B0E17758D6B0AC53AC96171ADA1066E84B0CD78606D514A265CF5EB06AE00F7756181A8835A808075D3EDBCF2434CC78539943083A73998B1CAF1C8413061083E8850BD1B2D0005E90113470';
wwv_flow_api.g_varchar2_table(195) := 'BDDBADBB7174C15F6D68A04FF760BE65CD4203F834A4830D43A1A11F37A4AD216383C8A50C362C2D34409B659DF7F66698163448A1205D1888B6147F3C5F4D68A010600068489A301FECCD6336C4A2368FE6425716DB3472B8D9E79118BA29A1373488A4';
wwv_flow_api.g_varchar2_table(196) := 'D9D2461AA4BE46B19F3E25E109EBAF363454F54FF5729F4BC307C6BC47D86DA21F348CC20D57CB1A52C106D821101AF251CD602C19C277C3C8B989F1A141EF5E81D088F2EA6065230D22F2C10CB9E1CE8E6C498486E5E00684861C1143A74383B457330D';
wwv_flow_api.g_varchar2_table(197) := '0DFEA9179FAD2B0E0D9EBE58BD39E42D31756888B9417FD5061BAADFAB7A856D14080D194C46F4F466E84D0C53EA9E10616503DC57B30F27CCB41DAE66F7048B7C63E0D3B50D55F7655B85AD250058D2CCE9300F64AC954EE6911B161A7B58512D8A12FA';
wwv_flow_api.g_varchar2_table(198) := 'D52E74AEE4F2A56F96A4E9BD141CF2B3A62D5CFE75941713A771A161F400433CADCAFF7402D7FFBAF59036164FB581D0306E39642AD2001591711B451BA121DB4D1369629826343493B9D8C26C87C24003FF540268705631D290D08385065294BFAB000D';
wwv_flow_api.g_varchar2_table(199) := '36DE6037F2968186564E0ADF9AF959A8A58486EE16CA41D020064203545CBD3C406848A0E14B095EA95A040D7A5D4E151AEC20AB5FA1D1D3F2051B960B1ADA238719AE030D4D9B9E9022FED80EC46985155CB6F2D060FCA45DF1F944B5234A6885D010CD';
wwv_flow_api.g_varchar2_table(200) := '62C85801637E7101216389FFD07D0B1E078519A212C8F061D9D4E0008954FA6817A121B69166DF2BF0FA5CC6D0C0AF1B6938EF0B0DD655DAFBB1546D1485A50C33E83FEAC4D030223784B860AE3E1A1A605C3D29AE2634F0CE3C051445FEEF50039C8C86';
wwv_flow_api.g_varchar2_table(201) := '1D84AC101E6435E7DD5C8D85CAE09F5B8C58BE208610038847D0C0C19EA129831AF36F6D223484D0405CF6CBD3AF0FBF8C5B2E47808691275EA60D1B6052B6317A82D197358ED090DD6043579861E6D000FFA3E425A5EB1BAB5808E9744303D7D0F06C2F';
wwv_flow_api.g_varchar2_table(202) := '505163642BDCCA27838655B9B34468584D6818EABB305A56A2031AF48E18CD9EE052067A03735D8486101AD68BFCC2E7161A1A3C8C34D4A70A0DBF3AA1E1A7B7640691CB060DFAAC833043FD5AD0300A3728FDB66B4527B9DE0E1B8CDDDC5C4D68105718';
wwv_flow_api.g_varchar2_table(203) := '82DFD9D2AF4FD04A8841A6321478678990817FDF917D1746C705A326970D0830186810708DFA52F61D82D01042C3AD4D5E033B486E4755D99A86F1A161444BE9B8F1B27A5AD53B114243E604D50C9DDE0C338606D3D1D4D4877A37E4FCDEF62AFA34F482';
wwv_flow_api.g_varchar2_table(204) := '06E6BAE29207B2131AF4A74DDC3C101A56F8EF2E26E8A21C87184268102134E8AB9C92ECFD518E4660CF1A1AFCBBDB42DFE0E95746B34223BEB71C011A2E47B578EAC90DD5EF55FDE9725436149630CCD0999B98193408AEE020689ADECB96E00F76D9CA';
wwv_flow_api.g_varchar2_table(205) := '43038DB315BF69020DADA8E37F59A1418CBF101A560D1A06A52106D42EC83188C14083AA430385D2D0500768A091850C4203383BDDDFD1576E1A43831955C56A9340433F8B27FBD1E626E21E0ACB0DFAEFB304BD974B040DA69A41FFF1C0D669686E621A';
wwv_flow_api.g_varchar2_table(206) := '350D263D2154533018901DB03FF6696175BB27BA967C7FACA15A3694686BA812819081505C2DEFE6313637885C3204AE69BE1FC4D0359E1AA6A2A1691A2FA1AC41A303E7B7B7720407338286643DDB178D880F6002052C919A7239F50C45C20DC658BA83';
wwv_flow_api.g_varchar2_table(207) := '18DA080D0B0F33983FED48050D538106194203B7D0F0E200A121B1897C7120DBFAB2685D9DC06F1BA0A1B5BCE9866B420372C3CA4183980534D87913000DA610529EF9ECC6264243B2FE3C10A2031AD8BCA0C1F65EEABF11A627321466B0C490B68E9E0C';
wwv_flow_api.g_varchar2_table(208) := '1A46E406114303A4EB03FEFA10A121C953DCDB9682CBA863C2385B983C4EDEC3CB535B02B901A161123218400CA6F8D11EB086804AABCF654A5C8486C476FAD52140437863B90068D00F22346423CC20A19A218186FA5CA141984883300547880BA1C5BD';
wwv_flow_api.g_varchar2_table(209) := '5B546760266DCB4485EDA05CC550F38879EB65A981403858102E84D0101D3021544BB2B7877E812034C48BBE7D279A7A5F30350D1134F0A940431FB786AEF444F534AA6C406858AC125618B10AB231FC4C1CC94C1A8E053849B702F1E104A1213DFD527E';
wwv_flow_api.g_varchar2_table(210) := '2EA9181A20E4A03460E5C989AF39463CB9EFBB68A485D0B07CD030EDD4C3A8D060AF7892EBFB19C1D9E3BD7C153CCE1A1AD8DFC7BCC99986061839C1C309149342C3E8C186B4D193FE2A42C3A23B2D5BCAA62484995A3652BFE5B5A101C6C084B7CEC6E4';
wwv_flow_api.g_varchar2_table(211) := '496F8A9F4A3EE242BAACE1F5A1BED7090C60D94843A6A16136056B039E3F1E3AE0F6BC5CD030755C8816B76F2EB82E5DF8D63C863A080D11347C389921349C0FCA505868B0C1865CCFCB5E06680859A1C6BB4A20AF090D83B941B4E2630B0D81FC56F11D';
wwv_flow_api.g_varchar2_table(212) := '648594B7F4FD1D297860A6E798174AC96C42C368A63A9369F09E3149C80161223785AE338686461F683036D2E0ECF4BDCCCCD87A1FA1215AFCBF120368E02968E820866941C3D50C45D27B795AD5FF2142C3224B20E369E83D3314D7818601DCC0ED6C6C';
wwv_flow_api.g_varchar2_table(213) := '7D7E46D0A04E111A3AA0C15FDF1035A65AFAB512327EAD725397309DDCF3D03DE3BAD0809091D172D7858419A2D9130D3077A29F8E6DC2D4C3F4440C0D9FCA09345CCE051A7E7710435C1189D0B0B8308399821D7A3AD579D27539141AAE1D6CB097602E';
wwv_flow_api.g_varchar2_table(214) := '436810BF3D3A7ECDD1D2D634101842213E9DC84029883198160A21B29C639E6B1EFA5A3510232CDCFE97E3FDD31873D59926065107F339FA64979BDCC414230D7981836AE74168EEA45F8AD3AAAC1B5B27C30AD03771C9797DC6D0F03B959E30D090EB11';
wwv_flow_api.g_varchar2_table(215) := '56B9878604146A7CBC42C8E9408348A0E1CCA70E4243DA1A92B0B7873280ABA5B2D0D0CC1C34644D080DCB010D62A6E184418B0334E81FE19C7A773659B4D323345868A0DF3D8086FA02A0218E34D872C8FCF65EE61B1A6C09E442A04144D020226890E7';
wwv_flow_api.g_varchar2_table(216) := '3E5B73111A3A3214F777602A07A47294684ED58F614AE1E2BC687C6EC074C63CD20D33D724D0604A1ABE54AA337068C8353478A4407F78E07C55EF0005569B1334A42DA5F5822904080DF3CF4D84F60CE9BF7A7D01D02034345C52E616111A3AA0C12D8A';
wwv_flow_api.g_varchar2_table(217) := '334FB4A5AAC32B1655442E6344E17AA533AB0B0DB3FE77F3020D8DE92CB8E8E98396E06FDEF9264BC8561B1ABC0E6820EC97AFA181CD1F1A7E5F8186D3AA7E3E42C37CC30C4A2531869941433F6E10E125C95C9E9B0A7C086A9415111A52DD13F6E0C391';
wwv_flow_api.g_varchar2_table(218) := '0AA4AC43F7C4A042C8A5BDF39B0E4CC8852D99F335DBD76761EF9FBED060C64F3418BDBFC30AC49666233484D0B046F86F3A5B6838EF0B0D1DC1861F61B041EF62080D7374816CCA1E618669A727FAA18388665DDABB6721956A30767323EFD030EECFD9';
wwv_flow_api.g_varchar2_table(219) := 'FFF950DEA1D1813FDB534DB88E990C85C87DA1D982A0213F90312D28C9D6CF999FF79589E7FDAC7A6E9147D50C3E42430C0D6730D110C65A3692CD6246D0302843612A222BDF2A791C45915B6888874D5C25863942836D8836FF87D0D0B54268603736D4';
wwv_flow_api.g_varchar2_table(220) := '990FA6990D2596A1D02C1FD0901FF8C81644E61D1A6403AE46FCEF232F75867A0E594168A85EF9D477236830499C041AEA538586F3410D144945A471798272C83642C3DC4A204D9B65471564AF35CD1071F7E00988344873F7CC353408C66E213424D0E0';
wwv_flow_api.g_varchar2_table(221) := '93C81AF25B85EB3F594D5A6F4884068406848659AD9AE482D33F9FDBE8820D3654111AAE4283982F34D830C3EF9018F4A79A18ACD193DECB101AE6D269D933CC30476830D3B185088BB6848D3AB0BB5BF3717ACFFE32560DC00D106CF8735729251B4AF4';
wwv_flow_api.g_varchar2_table(222) := 'BF10CFFC629D850B7A062063D69BF1A2D20459F3DB98F9FBC15ED9E2EB5B8DCB3A9735E85412671EB5B90962B6CC81650D7EC69637D555ED6AA3B851D4DBBCA8F3DEF1E9B95835A4230D36D890BB5114F984069B9BB89837347471430F68B887D0908206';
wwv_flow_api.g_varchar2_table(223) := '87D8611CDEDD4DA9CF5521C51C2EDC43FFD68D958686BC472672A3794183B9C4A5AE7252B08F27BEE35AF768CF38A62034640A1ABA865EEAE37C9543E6121AA0D3D2FEFD06365BCE031A9A2968682234742E87D8F444758DC8CF65D1B2859033BEF43796';
wwv_flow_api.g_varchar2_table(224) := '74E55C4B0B070B7B1F46D0500BA1819B51555270FAF4B9976202B6D074C38A4343DFC955299727CD0DF97287CC2534D830438F7ECB71A161D26B71173444F60382DDDF465648AE568EC94D98DB1DFEE7816CD9313A080708190801A347147AAFF0E26657';
wwv_flow_api.g_varchar2_table(225) := '836B6280C4BC86F2DF9E5FDCF4537D13080DF38686313314956F15FD488ECA21F3070D60CFD09318E6080D2043090934981A3F8486E462E4446E0DC6F7DEBFB1212F7CD1EC7F39CEC9C5BAEF4298400898E7FBB0114143233C86484353F07F8EFC829B6E';
wwv_flow_api.g_varchar2_table(226) := 'B364035B2E111A160E0DD5530836E8B72442C3ACAA19F48BABFF2A43ED194685866B5C4613686846D0F000A1A1031A58E4D9A04F5AF9DF89EA8A34E4F1629D77685856F858D6D7390E2774ADB8A04184510748EBD4397BB4D3E9CD60FA261C84868541C3';
wwv_flow_api.g_varchar2_table(227) := 'A00CC58F841B72342CBB90BF3043CF6A8645438319AC80D0D0999E88EF75CC358B3FD95339BAC4D767BC101A101A467ABFF1018BDBD64173ACEA827DF7A8EBC6ED1266B825F1313D317F681831D8908206FD312FBD9779838696D27F034B0CD3494F5CAB';
wwv_flow_api.g_varchar2_table(228) := 'B20158016A8F9A1CA1A14FD765F2A9475C714E73737D1F78B1EEB5101A101AE6080D9750CA60FD06F44751E3EA927BFF96E0445B0BCF3E4D0F761BC6F444D6A1E17BB5F2AD9297F955398306FD67D37F8F98184629849C5D5983143C8A3458689019AC69';
wwv_flow_api.g_varchar2_table(229) := '18DF94696AFFAE1FC545435B3A97A837FBBCAD545DCA1A586AF23AE34DA8DE52FAD3AC440B52F770E3ACB161024B35718DF75EED08308089535DF01A53A69A411FC806A537B7FCEC71C01CE0605473A775979F3391DA2C4203E9CB1170E11AD0D03343D1';
wwv_flow_api.g_varchar2_table(230) := 'D14061A0417F8AD0301317C8E94343E31AD020D2D0808590DDD0E03BA12D1D35C3ECD9832D7D7BA49A122E82200ED02004CCC05C3C34F0898981630402D76CD35BDD6F4E5113AC113D5283F3887D3EF1D78A080D03A0C1735D164343AFA9130B818638D2';
wwv_flow_api.g_varchar2_table(231) := 'A00FF42E82D030557B868688FB26A60C0D8D694003FA3474E5260C34F8516CC3B30363BE56F48901E55B75AE5F312E605B05C3FC195EB247CA2FF0EB2D4C67E0BA1E348CF716D53B9F86065917E1B627B9FF742F2FC4B05068A0D98286740FC5F77C9443';
wwv_flow_api.g_varchar2_table(232) := 'E6071ADA4157982183D040D146BA1734249FEA8F7FEECB06E32D212EB969A5B0A5E0723617E599B3024620100EA61E4B18E55D2AEA0CB27B75C12F81C0D9EFAA5FDCA0080D57A0A1DA050D6734A969A88F53CD306D68B81A6CB0E590D9376CC80D34E8DB';
wwv_flow_api.g_varchar2_table(233) := '5378F53BA1619442C8B941834068B80A0D51868245490AAFB8217E568492A2161ADB4930B39BFA4579522C18F65ECA1C4C2064E41002A601AF1066A70D216B5091EDFFEF9016084368E80F0D1513E964BF43686031345CCE171A7E0F82865C9443E6061A';
wwv_flow_api.g_varchar2_table(234) := 'F4F90C7D135D932DA7080D13CCAF6A1868D077C9A622120C24EE6C222E7415665FC508FEFE9D32BC15EE6DC238E04EB5156DF228426DD235359840685886B4C20C89337CBF85D0A0F4F5E7CCF7EF6C65B31B220BD0508DA0A14A08FDED47D0C0160E0D3D';
wwv_flow_api.g_varchar2_table(235) := '2B1BB29FA1C80734581748EBE994AE6998323434C6878646040DC62F9FDE4668E84D0C1D8FDCDB923F3DD33D216C452440C38CC3B9F9818619472096153E16F5FACC131A3ADE6F0C6A21EB8237050317483071F2101A8642C32FDF9A70C30E1242035B38';
wwv_flow_api.g_varchar2_table(236) := '34685C882DA5C1B021DBF3ABF2000DEDC89EE1A2FB4F387D68685C031A1A1CA1A10B11984368CA069F9A6914FA04169FCA425A6830F6B783A081CF3ED23B256E98064C88A92D848679A41516050DE1A8AA4BE14BE63DD94D1B332034789DF60C398286EA';
wwv_flow_api.g_varchar2_table(237) := '69B5FCA59C7197A7423629A1A73D43F8471A1069E87FB19EBA7D0D37B64E129EC63537F0A612354A6F6E202E8CE01449E89D2D2EA9BCE4AA267903EC6F1755A8381350A865A13662CC35F35909F9304DCACB3B0DCC9D2E39D3179FFF4A7E81C415C7CB0A';
wwv_flow_api.g_varchar2_table(238) := '01D70C39C48B7FADB006334D13C2BC8CFA98B16B10435F6818BFAC21EEA1D04F1EBC2122348C9C9BB86043D213D38586C6C8D0202268B881D030123754D75DF6E1182C352F051F787B97635CC81734D4C58AAD9C4343CD1841D699FF648F1A68F0101A46';
wwv_flow_api.g_varchar2_table(239) := '8286326BF04C4383EDA1C048C3B54A20CD84AAC540437F7400686818686872D340A1C4854F8B456482215D15E696A8EA14E8DD1D3077D22F60CD744F4CEB225ECBC95A5A68C81A942C298CEA1D4EDFB67C2957891B9AA010848611A0E17399094B0C9984';
wwv_flow_api.g_varchar2_table(240) := '06530B093D14197679CA0134E8BFE5D5DCC4B8D0C0AF1F80ED820661A18103343434362871E65317A161F42445917D2931C94D8A51E4E8629D8B08C4E2E0235B6B612FE9AC89417F148C3E49193A11E29BF154080D03A0817D2C710D0DE0C00D933BB206';
wwv_flow_api.g_varchar2_table(241) := '0D36D850F96A7A28DA080DD7F3745A3C34F40839A4A0A1A9F8AF2A252E02C1505C88DA2F89FF70870B0A3E0D35B1B470B0A490B1722B6BEF87A6E05FCBBE138619C2F12E0E42C31068A0FF1CA7A1812F1C1A7E78E92114694BE9B087A28DD03081A7534C';
wwv_flow_api.g_varchar2_table(242) := '0CD7838659C41B848106785C2AFEA34A4DB300AEC161D27832855720E25B4983D7A048C39CAFC597C316C204424006966C30FFE95E343F3684862AC1F4C41068F0FF7724CC0587A5A0812F34D2101FD8C9557D5D9EDA080D23E626EABC6741C3C4D030C5';
wwv_flow_api.g_varchar2_table(243) := 'FA067D8B2C2368901A1ABE579015864243F2253B96E2C9AE3CF7B9908BBFB85F8EB9101A100E16B8BE963C930C8D4D57E9425B2EF3020DDEEB4380869A609730BC63E19186F4108A2E68E876794268182B37315D68980E37344268E031349C22340C8706';
wwv_flow_api.g_varchar2_table(244) := '664F5D7B9923449FD5FA7563422CF2FADB0D04CCAC1C461DB20C31F8CA4C75555F3EF76C05831306EDE852FB2E4C0D1A5E1D1A8B8B4E68B85C2834D86A86CE1E8A2C67280A99C585B06FE2AC776E6231350D1DC106689D80F45853F0BA0468F854F21017';
wwv_flow_api.g_varchar2_table(245) := '86A6274CDAD59ECC14AE74C47BB8ABFFCEAC4E659DD30B06E3772E18142835984D3D4E87068620C2E82B9F01098483792F36DEEAF3FEF11B26FB7E41E18CA873AFCE5443B0AFE5958580C14C3074D1C77B5C82FDB67E6D4D7AC25695D221B830EB42C8AE';
wwv_flow_api.g_varchar2_table(246) := '2114D99E4391E94883CD4D640E1A2C3734429386041AFE3B4168180A0D71377952BD7563837E38122DC1352BD4A1FBDCEC3DF4BA3B501719F47C709A0BA101A161FAD00037C43560E8F85658D698FFE43942C384D0F06857DFE951331D94671C1ABE56F4';
wwv_flow_api.g_varchar2_table(247) := '3F8AD030A6A753DA08721AE989A99ACD99D609309016BC219586867F8FFDA528549CF5C5A8AB8D020CF3EF6E09B86E6A6890D4F8DCE9CBA848E51AAF9D6B60FD70818DB9101A70CD131AC439BCEB442D040851E7EC93BE392922344C060DFEFD1DDE6057';
wwv_flow_api.g_varchar2_table(248) := 'A08165131AF483D83D314EDF445326D50C538286A9A2831D3901DFCD408364FF3B4468187E318A1A4CBAEA22E9FB23FD8252A86A36C1060D0DFA2FDEB84EDDE2A0C0009B74613A032160340898CE126651FD0D2F6CC881EA6D6F0E7E0C4B0B0D77B6788D';
wwv_flow_api.g_varchar2_table(249) := 'B2A4E5929B820696CDF444365D9E0A99CE4D9CCD041AA6830E75C90D3498CA06A934E2BCDAA7080D4397A969A091875D5CF85DBDB9C57F7BB4698C9EC0575F5F250D344CC40457E1E03AA0301B98C08845AEE0E07241CBEC6750EBA33739C1E8BF47F371';
wwv_flow_api.g_varchar2_table(250) := '705A5A68B8B9C12F7C0D0D30B9A30EA71BBB5864A4A1831B3AA1C10EAFD27F772C841CA76FE28C76041BA60A0DD7E586BA644D030D75030D42F8CFF69679B39F1A3424079E933489C125E0CD01D4886862B830D060D3139342C3A89780CCC1049FCEC2ED';
wwv_flow_api.g_varchar2_table(251) := '7FC20EDBD942C0D86FA11AF521EA06D72B76EE556F6FFA76F3436898081A3CB7C87E7B70F1B7D00045A623FF5D66030D5DBE9009347C870C857E72D6865E66141AC0D3E92C79F5330D0DE0E72A5543788F76111A46BC1EF9A972C8384F512D16C1193EBE';
wwv_flow_api.g_varchar2_table(252) := 'B1AB99C8E12CAECB17D758598B402C6A2134CC051A688D51C850087EEED3D7FB9EA1EDEAF42060D5A0A1EA10F6B3CA2303E9101A6AD980869F296888820D7A652D43915568684AFDCA769834CC001AAEC50D7549BBA0E1C13642C368650D8554F107745D';
wwv_flow_api.g_varchar2_table(253) := '261188A7CF799DD17AC80D03A061F2BBFF8BB942C3CC0B2DB3060DD3828C59C34A4EA0C1AF3179C1A9BE589D563D52B4793DDF416898141A0A05F6A362DE003134F04C4143CC0D956F151B6C081B2FD1DC69B07AE4267A5DAF17080D909568685C100A42';
wwv_flow_api.g_varchar2_table(254) := '0E02FAA06E6EFACE326CEA8B0A3FB042A1A23F7E38E2C29CC997DCAFD16B5142D7667F31CB7599AD353E07E43CF231B535E37443DF8802E7E750FCAB89D9AB53AADFF91750D6237E0B0A953D7EF5D1366C78C60F8DE66753CF1A34541C423F1C336172A0';
wwv_flow_api.g_varchar2_table(255) := '3501F727FAE4AD4F7EA7D1971826A869E8CA5044C106FD7C8C344C54D0301B6898981B626880030D0D17D42F6EE0DE3FF1A2D17D4FF5CE16FF598599F7E7CCF4444D831832B8725398896B3ED06010E1223ABE34C7FA3278C16583FBEFDF55D78B7E2A3C';
wwv_flow_api.g_varchar2_table(256) := '80B8302134E84BCDDFEFC094CFDC96D8973DEBD0F0CBCF542D6416A141B554F842CF051A26E306030DC6E5A926B81452FFEDD78AB8F75F071A1274F8735FD4E1DE4BDF0DE49509F2060D08257CF62D36435E52135A801F43DF049F43E081EA3D4930A9B7';
wwv_flow_api.g_varchar2_table(257) := '8D5B5B707638B0E7790E42C3B5A0C17F7B08F77B161A321069B89A9E08B9E1346CBCD4C7992A6BC8223458F7686B203D1F6898041D1268E0424A715AF50A2EEEFD13AF6A34FA121671D9A7129382FFE64B880B4B92FE4068986A002CFA2AA448F47E7606';
wwv_flow_api.g_varchar2_table(258) := 'C7BEBEB6D47C33CD321C815DB53D47880BD7818617FB1A1A98799D99AD9DAA65151A6C65C329546E22340C2C68B8645388344C3A00706C68D0FF494B8A4F65E89FC69A8689A1C109C7F4D9946DF5DE363BF3BB47C85CE0CA2B64ACDC1AF3EFC52F28BBA4';
wwv_flow_api.g_varchar2_table(259) := 'F422740EA0E73069027C4AFE3DAAACB9A65ED8344D38392B54CC6021A4FF6457D4E1E5E5A604320BD0D0D5759986061B6CD0DF0DA161504143F8729F5F1B1AE61272E0061AD83FC714A1E19A7DE1C43452478107FA625FD667830BE7232C840C5C732C9D';
wwv_flow_api.g_varchar2_table(260) := '0168B80068D077C09095D09B599DF19F9EFF7FF6CE18B46DAE0BC31E3468C8A02183870C3174A8A143051D62E85243871A3AC49021860CC16428A643311D8AE9524C86623A149321880C0165082843401902CA1250068332049421E00C1D3C7C43867FF0';
wwv_flow_api.g_varchar2_table(261) := '9021FF3DF74AB2244BB6644B966CDF72BE7C8EEBA4896CEB3C3AE73DEF7993B7DE1164372C858629A1417957E8213E231D0A638CA29B366820BB2EEDB20663E32585064F41033AA683839E6E68E8E2E83DF5B46F0D7D264E6DF3040161022EA4568C0174';
wwv_flow_api.g_varchar2_table(262) := 'E32CB9C2750F5A91F181072E6838283450C84843354B23AF4F94C9345868A9F71031ECD6C880A56296194C771396E2C2C4D020AFE5C0F462AEA02155B286D441033A34E8081A4F4624D01017373CA100410D860675AFA68F9C7BA6D0301E1AB0C934CC5E';
wwv_flow_api.g_varchar2_table(263) := '32E6A5D5DB426C15056D0C345098A0D0306368402734D03F12BB21AD77D09618DBC4C4A08AC9526898061A242EDBBD51547380020B21D30A0DE70365437AD66467126F46B86E388EB59D18A681862900C21F1ABAB07BE2A1A7830CB2AB7D282C67B20F1B';
wwv_flow_api.g_varchar2_table(264) := 'A1A72A762A4F771A7A7BABF75DF511C42E2079B91F97D47D1161B2D0270F8A1793C1C702FFBE9EB9E75E576127820E12C8FBAE7EA5C8AF726A74EFA345AE1C841342B228F45301F422B0E6067B633C4CFE3A8C5808E9397579610E5E526818256808060D';
wwv_flow_api.g_varchar2_table(265) := '937043E4D0F0EFE9E95157DFE52934C4010D22C7E9BF9AE864AADD817303B8EADE6A417509017061C47B3E1A6EA0584023A0AC015058531EB4DE9DA67E2C4B0CAB506888051A32FA610B9C60706F024343376DD0E05A42813EA6674D76BAA061E0D0303C';
wwv_flow_api.g_varchar2_table(266) := '3A1155B121864A037A932BEB398D42433C2711653DAF9F81F36BAF036F517443BBD642E1823645445975A09041C3BF95D6ED6063867FBAF6AD8E7B10CB28789C0D34A83FC1AA412306A07723350DE981864B2525B286744143AFD7031564C7677A220968';
wwv_flow_api.g_varchar2_table(267) := 'F00D5033747B8F181AAE1499E368A521A6CA047CDC2876EF34D8DC33684068D35411A64687E95B1B3E8FA7E97339CB0CB7BA8A5E694FBDEE9120B3ACB9329EA5D01003376494DD4A8F40C303492BDD897B64B3810662F1046BB22934B87A13E8A018D070';
wwv_flow_api.g_varchar2_table(268) := 'EB030D7709C81AFCA0A1F788F762FFF7D43B111586A5D01057A5017E304EFE5205E336F42EBDC1B286489920BE880C3268665D948A824FEE5141B273AD10F3479925AF7F0A0DF1C4C7E2D303141888134CF77E7213B999551A50A06F42A1C1D99BE8F7D1';
wwv_flow_api.g_varchar2_table(269) := '810E0B0D1372C3D4E8A09BD0D07B7AD2FFB49676EA6116C506062C1C4486D50E5ADAA3D6BB45DCA0064DDB9D49236668080D1934DD2E3434E80FE8D957D44F650005C6B42D61687B22FA3203DC789DEFA1F7144E0478FD445AA1E1DC010DE86FD3E0D690';
wwv_flow_api.g_varchar2_table(270) := '2668200E0D43A7EC2072EB24A0011B483F767BFFF5700F9226FB18A141C233996236D73D977AB83711232EC4430F7155206865621EB961E809EADDAADA8F3A220695C54D776CE524534D433CD02065B3DD4B45C7D313AA2734DCA5061AECF58674B835A4';
wwv_flow_api.g_varchar2_table(271) := '081AD0E140876C94A0215A687888021AD037F9AFA7EC56CD258D2C8586A84F22F65DC0ACFCB6A88F2D3374A20E0A0D7167D0F4FCFC3310BA7AFE9A8782C470868913A00347859071091AD0C7154E3F9375BC44577DD47B77BDB44383890EE0D6F04CA1C1';
wwv_flow_api.g_varchar2_table(272) := '346980052D632B0DF79142C33400F10F7FD57F3DFD9FAEBF29586AE7791F714C1B9410972779C558EE2733ACFCB9D4BF5355B2D2AC43CC7735B5A3924C1C3D31245A90884289999C47C53410709B54C47B3CBBB7A0E755C06EA4A7E2567A0FDD7321AA2B';
wwv_flow_api.g_varchar2_table(273) := 'ACE5FC48937DBCDC00251CB6FBA7A5F560EA92CC50846D4F84AD743A8821944F83131AD03F4D2B0D833F0341C36CDA13D3571DD057F510A2AAEA7A5E9D3443536818F7F3B372C668EE12801057B3EA5E154CDC3A5AF706B29A8A5E3904203A0B0B0DC941';
wwv_flow_api.g_varchar2_table(274) := '0685862843EBA83A2879BB5A87CC586ADD2B59DA28AA0CAD10CC141AB4EF751D0F50E8C41432C249CB28A0C19B1BD2A1854C0B34F4FB7D723427838608B8619226450FA0E14A56B86C6AA161FE83959DE397125E4BA1FC69F5EEE0E5A19215EA37181AAC';
wwv_flow_api.g_varchar2_table(275) := 'D74F7A8242C39C45CCD0804F68DD1B5DEF74D1EDDE8DA26E96E5F99F9298276820E59CAD72F7519F3B68488316322DD0F0F41FAC9C98276878E892D5D8DD6341C6F396141A620FC658DE838E9BB49AD78E05F59F0695DE6B5DBF21EBD4D3070D73529948';
wwv_flow_api.g_varchar2_table(276) := '5F5B249988FD90DE632BF41BF08DEEDE6BFA6E4DC5E312328586D94283F496875D970FD8A4E12E527B86F8A0816821935E429116684039181DAF40D010ABB221384CDC03343CF5BADD5F4DD954EA516888F5AC24E1D2A2799C59F4B6D72E24F55E43EF3A';
wwv_flow_api.g_varchar2_table(277) := 'A8F4A2B79F9FA6E1C63F2864D0986D746F34F541D3FE69FAAFA692E1542F1D834CA121366220D02066734FD78A86CFE48E9C721705347462838673B9F7AF47A1C15041A6141AFC02A0A1FBF4AFABEF540D686016D9133EF9B3123378C3CBA6BE417D5FD4';
wwv_flow_api.g_varchar2_table(278) := '2F2570DEBD51F56B4D0D080A734D0F1432E69C186091CAA3AA1DB424B3AD297B25600A0D31FA34A01B2CD73B11D1A903FC9DEE42EF484B101A12D742A6657AC2388ED341C32CB901B64E3C767BE8FDFFBEA860CF579942439CE723FB6D898130B861ABD2';
wwv_flow_api.g_varchar2_table(279) := 'BD94D41BC507145433960C1D68864E2734DC76D55B15BCA257B3B2A5D4613254D330D3DE049EE5D6F79BFA3F6C0779D70D2BD40D3BF21D2134C0BACBE7A5870650415EAB418590298186470C0DF79AF28AA7D0301B68308F180B4D0A5C78303E6E56F43B';
wwv_flow_api.g_varchar2_table(280) := '55BED3B46B3F62181D141A68CC289447BD77264BEB79E23E2263C7683543A121016850BFD535020DF7F142839B18A68306F457C96A2153010DB0A7EADA5969183AEB05848699D183FEEF09940D57928A2D59146AE234DB938E51D4658CCD75DA76A57B25';
wwv_flow_api.g_varchar2_table(281) := '2B8FE8FDA92B37E8A3A65FAB58E5A08285C3B5EAF1BE25901A842496B0BB4163EA5089B8126A60AA0EA1AB8FDD9723417ECB4BA62583CC18BDB625142446A851081E666F22236632FA4659EF7541917A1B6F6F62F2C513A9D442A6021A50F69D3F6878EC';
wwv_flow_api.g_varchar2_table(282) := 'F51EBBFA89A066283424060DE60D565CCDCA7BD5DEB5A2C0AB45D7AE35E51AE7FE4B454571A7C50E0D1426683889A177A7AB572AE8F389ADD39DA6A1CBC48D8298198082CC526848021A188006F55541C7BB73A38486CE2CA021592D642AA001BC204341';
wwv_flow_api.g_varchar2_table(283) := '430AB8417BE83DFDEBA9BF1AD6263ADA6B480A1A50A05380C865B5ED8A7EABAA58518BE801BDA2F42BF0D2516E94F0D010362834D018848E8941BFEFAA1DD0E7AA77AA7E21C91B45EC2C048D09D5F962A6D0306368804FB99C7629EB0FE1A061320FFB28';
wwv_flow_api.g_varchar2_table(284) := 'A1E15C46D96DD9A161701C23858658D1417FE8F5FF7595EDB2F55EA5D030CB939755DD951C3399ACF2B58ECECEE81C2D5FA3D712CCC42386808DC3376AA8880C1A686562392B0DE823BAB4B8D6A12B71AFE960FB5890CCAB0BCDF60226B6A7141A66060D';
wwv_flow_api.g_varchar2_table(285) := 'D66D589C7BD8862E733021E4342B6FA28506F0857C5E6668787E315490F140434CDCA03FF6FA0FBAF28EB7EC8D2928CC1E1AC818859D1B047422F856EB5EA3F795AADCA8F28DAA5C2BFAB51A161AA2830C6D3E8266FAA8DB131A2CD381C5285DF43A7C5B';
wwv_flow_api.g_varchar2_table(286) := '0001EF10F2CA2C4BDB13B38706D221421FB51FF5EEA3AECF0F3490BF425F95A016327968787A7A529DE7744F6E083543310B6EF8D7830E7A36AB526848EEE465408369E1408629449655F7AADD6B45BD056E8077ECB5EA1B89C1C49C4006258089A27B85';
wwv_flow_api.g_varchar2_table(287) := '67251E54FD52525F17141BE6CA8360697B222968203D4D75B3DC7DD0C64E4F84F57F8C151A48F4FFB7C4D0D0FBD7739DBEE7051AB4534165585A69486AC5ADCC38DD5A9CDCA0EC56D0F95AEFC07B521DC10D73030D6ACC41A121524DC31536A5BE10E50D';
wwv_flow_api.g_varchar2_table(288) := '9E281824D6FDBEB0FBA35368980D34B8E8417E95D73ACA686808344CDB995D7B02FEF63CC9018AE4A1811848C399FD3A4668889E1B1E7BCA41CB1A6AA0D0306B6860CCC533AE86852974105856DEABAAD7B27AA72997EAA862439C30A1CD7D2C688523E6';
wwv_flow_api.g_varchar2_table(289) := '7F5781D12A497D53906DDEE7A2BF3F3A8586D94303A8A75738748A881B1A225C3C01D070A5486752AFD74B4AD6903C34D8050DE1A021243D44BC8DE2BFAEF6B1ACDB16375308489B7F0BF8376C55F47349B9472F3028366828109E02A12AA13162269091';
wwv_flow_api.g_varchar2_table(290) := '54CC0D7C848580903FA7EAFB93AB3E3F037A51295D18D251955B3877E92849DCEBFDC3A6FC362F9235AD0C6B57DED0643F4DB29F3E44E7EDEEAF96DAEB7A5242386E98C8D9C9410C23A1C1FE57E863823BB2D3010D01DA135171C364F4308C1DFA83A6BC';
wwv_flow_api.g_varchar2_table(291) := '2B6A58F64CA1215DC4C00C3A1702CB495B65FD4C523AA08834262930316080A0D0306FD0103A424383FF01F1FAFEE8D4845E48385BE8970A9EFBD7B423517C9D135C05B09182470A0D490184F6057C21A7D534045C6E191D34A0EFB3A495867EBF6F3426';
wwv_flow_api.g_varchar2_table(292) := '3CA1213837DCC7DBAD30BEE4D1B88D6EE8D7B2BC96579766DE72EE4E46F0A430AC08F3149CFCA1A89C8B3A2CCE5607AF3744EBD1161B960932E6A54D13F78F0D93BDB7BA8EE8010128C2853B55FDD590D6F2A68313AB9AC54899561A52030DB20D1AE40F';
wwv_flow_api.g_varchar2_table(293) := '25FD5EF3638570D0D0891D1AEC4D8AA4640D094303FAB5E158588286EBD88B0D93A1830B1A7AFF7AFA515B6239D57432A61090C2396CDB751E2BBC2FEA876D585171ADC8800BF07E96236F524C0F0D144AD20D3DEEBFBAC5B6E557AA76AFAB0FAAF4A326';
wwv_flow_api.g_varchar2_table(294) := 'AF64B1B69175A916E4A58483344303E95308EBB92EC81A7CA1611A4D43B8AD13C1A0C17A0CCA47CB080DE8D70E050DD1161B26000BF269AFD7D3BFD7A479D850B76C2717C53A1D38959202BAF3755EDB6F42EFB9A34A081D6E146504345C9971BD1C41C9';
wwv_flow_api.g_varchar2_table(295) := '60F89C3E040DC30FD66EC0CD5679D0948EA2EED514362B9B233CC3A25D95E2425AA081B5DC1A0496D38FDBC695A1ADBA304D81216099C14F0519101A92F2854C181AD01303ED99C0B286388A0DC1A161F0E96357FB54949DD0309B796B0A0D01AF21C48C';
wwv_flow_api.g_varchar2_table(296) := 'C3C2C1F856D99CF6A3A1DD28F29D225DC9DA950D0EDC81F59257CB470F298792442A37232A10D7AA7EAF691792F2B9AC648CD223B98485BD12A68F08A584B441039C2218D3E2E97BCD0E0DE1BA129D84A0E14A41FFFAF241C333184887858619171BECDA';
wwv_flow_api.g_varchar2_table(297) := '49EB068C54ADE75C0E0D141AD270B2104D21A44B268D2D1CE0F24258E194DDAA7E2EE937AA1B0B3CA04119F998004811F6F134E60A7A60D7C9515BDD2812ED82C40EAF6036DFB9CEF2C39240403AA727ECD000777E2AC461EB140461C342C320AE12D342';
wwv_flow_api.g_varchar2_table(298) := '260D0DD72A1182A61A1AEE6CF4F0081FD1132633ACE5D0A05268480D34A0CBBBE1B395641AC049064CB0CAC78A762AC9779A5F52571CD0A0440F0D1426E61C1A0C21E4414B7ACD1B5D3006F290E41439A98CD1325BCECA41FAA1013A14AF737E99254A7B';
wwv_flow_api.g_varchar2_table(299) := '8688A0C15E6C48C44C3A496880D1894BC5E5EC14901B66880E78E13ABAF1806F3F74BBBD6EF75B936A14E6AF2CC90C6E0BE8E306DFFBDD506E1102AAEAA5595AB8043E50AE55E3F6A58D1BC8D6ABAB398FB9C9D38A4FC4FBEF6A972A790128378AD25160';
wwv_flow_api.g_varchar2_table(300) := '3F2AFE77F52B45BB52B56B5D85ADEBB05142BF90941F35DA3E588CD08E05584271ABAB388974C16C036F1D8B53D0101C1A3C880157E89F9E9E960C1AFEE78486EB88A021526EE8DE2150C0D080014287010A5DDBAA526898AF9311D1A389B68E661BA1C3';
wwv_flow_api.g_varchar2_table(301) := '5A56FDD1D42E65E55685918A2B0D52026605C56E0085A1C178A1868E654BF6F3020DDEDF5FBBD18CFA10B9C7E045B368843EC21949554F4579BB22B21C8586C508E567437FD4B55B08C820181AB4744343525397494283356F193D3444470FDDDBAEF608';
wwv_flow_api.g_varchar2_table(302) := '6586EE1D0084FEAFAB7714D9DC4043A161EE4E46B874CC2AA67C5A5861E5ADB2762E29B79A74A92A972A366F70BE8DAF8CFCA15C4E000D0941C6D2551A9470E173FCC9400D2864811DD18B011C9CD07193709149EBA8EAADA21EB694B7054B7E4FA16111';
wwv_flow_api.g_varchar2_table(303) := 'E26349BF5735A83140BD4123265D310B1A1CD07019081A5CB20630935E2A68E8FDEB11938AC9A02128374C870E3D0C0DDA03BA01D0D0ED75F5335122A3D81402E6F61C61A1038C6232ACB45150FEB620255CABF2B92C5F43F250AE2DA235D3CCA5E29EAB';
wwv_flow_api.g_varchar2_table(304) := '1E1773031369830FBFE3101202C2867C2543BDE10AF729F0CA1268555C811F83DC51F56BB9FBBD2E7359F08766598542C3A28498CD691D19CEF39D2E3429C0A72B467B86D1650617347813033E172562D5902434741FBA5342C30CD0A177674143B77BDF';
wwv_flow_api.g_varchar2_table(305) := 'EDFEEBEAFB4D29C3D24532737A7211AD814C1C2A2E39B4D1EDF5ACF6BDAE5D4832B6F9532EF12BD3A207F4E985AC5E858686E42063CE2B2209FD5EA06340372E801B102E48801158CB8288E15C523F9589C8515C01598C4ADFD70B030D0CAB9D08E8548F';
wwv_flow_api.g_varchar2_table(306) := 'CEF37AC780062839CC666E620268C05F9588554392D08012792068E80472D888091DBA77D09B0059C32D9EB744F8B95596E9F6B9F93DB930199105E1B4681BA097D80C51532B9F4BDA89A8A057D425E947C8F2A5F1120568F043FE117195AE881F1AA27A';
wwv_flow_api.g_varchar2_table(307) := '7C42D0702DE392124C75C960F8A8EA370A681EF71B329E92C08BD73D262AE9FB7ABEA10121E0B79AF680F248B77BA3AB7723A121AC3743486808586680B55549583524090DE8108F808650C58658EB0D5D327279ABEBFF7A5DF4D3BECAD3D1C7793C29D8';
wwv_flow_api.g_varchar2_table(308) := 'AD9F04B321EDF29405747895577F37B5335907B5BC2A5B25874BB8008D1D1A960E3ED215F2A5441047BE84275DBB56F4C3B6BA57955956B04DEDE2E15E569EAB7E1C3D3F8C39441B05581D824EF537BA7607DCE00D0D9D08A061F232C395ED6C90D0AECB';
wwv_flow_api.g_varchar2_table(309) := '24A101CCFFC94189021A4270432898C035066366F75F573F932486A5D0307721D8EB0AE60221E2072732836E85C8B0225E73D5FE52578E44A851A3F7F0A52C9B2A48E572CE23666888FBF1B1C70D3E4A17B82571A3C87F5BE287623B33E003DB0D96B811';
wwv_flow_api.g_varchar2_table(310) := '53685890E0B26A4791D109FF1A58C11B1A3AB143C3584F273B3480BFD31241C3F38B314072A5CCBA4311061A7A775D9DF83B3D747BFF74ED6B4DA65BE996E1B2037D7C9D977ED5D56B59EDA89045CE15F542958D77B88C49020234F617EABC43C0A25626';
wwv_flow_api.g_varchar2_table(311) := 'FC8E9B7C89D79C5E29D08782B390AC5CC3938B9E6270E9E828DA89A06E956596254585B425757A1E9852D2E40EB87260D5DF4D325AAFA26CD2D1F41B359A32C35868B80AFFAE37AD1AFAFFEB2F0B341067A7D1D030D362835FA501FE0A24900010F79AFC';
wwv_flow_api.g_varchar2_table(312) := 'B9249B9B2D29342C7230B885C170D2A7B272D8C63E3F800EDA397C44D945264398E7E86A409117A00291506522296820654EF95C3214AFB8BAA09CC3FDDAB9A4FE68486F0B22C3DA7B5B141A16191A48BF72B7AADF6B2A716B40D0D051E3208668A161F6';
wwv_flow_api.g_varchar2_table(313) := 'FE4E894103FA555D27A631D010ED2445E0D030371068E85EC9225E39B1C0D020D1B079CD121B28E1555EFA5653CE45E55691007361184F399321C760C36909728F42638E423D839693D401F853CE100BC2F947EEA8EA514BDA2C012CDAC42EF2FCB415E8';
wwv_flow_api.g_varchar2_table(314) := 'FB7A1A68105FF3FA8D026506A331A146AE6608A26908070DFF2D0D34F47A3DBB87F6001AAE4742C30CFA142E68C0DEA220A97DD0B58396C8B22A8580D9BF99A78E097FA481F48115360AF27E43EEE051FE73283940291B4B23B5516F7B3986A0597F6A68';
wwv_flow_api.g_varchar2_table(315) := 'C073950817A0507483A50CC782F4B526BCCA8AA42541348FACB14882A6DB858706EC2ECFA9C702EC0DE8801052BD53D35866B06B1AAED5DEBFDEB24043F7B1EB0B0D69E206ED11A813C5D383AEEC56A4791BCEA6D0301934E0DE84EB2744B98413B6CA60';
wwv_flow_api.g_varchar2_table(316) := '0385CD1BE473306F007D03FA78A178875FE2BF98222840048733BF6378AEC867B2D9A790A45F75F11D2F5A268F782257C838C4B334161E1AE0D9FF5A45D787FA8D0D1A3A91E91FA3293338A1A1FBD05D1668D0EFF551D030353744D79ED0F0C865F7E946';
wwv_flow_api.g_varchar2_table(317) := '95DEE4E74E05B96C701055C8366210599C3FB013144207713D27ED55951341B991E56B420CC9C5A226FBB011F2B8C997B8317125AB7F5ACA87928CFB11A2B9C09A8C565A0BD65DF8486331A1813CCB1B7C17F48F640F853A1531843782F45830310E1A66';
wwv_flow_api.g_varchar2_table(318) := 'EFEF941C34DCE970A1160C1A26AE3744400FB72A1EBCECEA47A2B8C291A2A5427B8D8B0E0DE60426E002B9E2945C93996FF3D2F79A7A2E9A72C870111D3728E1226DD090106CA937B272D09237CBD26A4E72DA7558F9C31ACA15589A6E97E0FC83DFE0E8';
wwv_flow_api.g_varchar2_table(319) := '24AF1F8BEA7D578325146AE46586B1D030C6D3E9D2F9B55709F83B25060DE85725D0400628C62EB09F181AA6E4866E07A0417BE82ADF1BC43D5A64A9F070F1A18154173025B0D6E5A6C040FE70081DDE16C45F4D8948F193818679818C18DA34D3C4E792';
wwv_flow_api.g_varchar2_table(320) := 'B89E6B3BFD9AACA79BC6329F7FD45F2DE51141039E9E98796F2234347496041A9E5F8CCD40A6B9D368598337348444874901A2ABDDC2B0A5F29A57D1CB6EC5610D44DB0D730F07D30514215658F5554E3C682AA7221EFA07AD0309E55C922F25E9429251';
wwv_flow_api.g_varchar2_table(321) := '9004792629A7927A862BE4F018C9C008F225D60DE3CB0761DC73B1F4611D8D4B3CF87A89958C785AD2409C0B988C80E37C8EA1046B172478BCAC5EC9EA715BDE298BAFB23310D2D298C1F924BAF30FB6745B21062D7CF74E534893A213B304F26A123583';
wwv_flow_api.g_varchar2_table(322) := 'DDAA60692A0D41A0E13A1DD070DBD51E74FD4C945773B2B36E49A18142836072431B9D74C878C58508A64F38FD4B673067A19C29783E1383C2852C5D42C86712C4B98D1E06B73DD0C171CF52820209D5DED1B08E0F71CE0026C3879D1C6174FF311C6463';
wwv_flow_api.g_varchar2_table(323) := '4FE99120EF56C557BCC0B0ED994CDFD0982B6818B8CB8BAB39ED4C82F5133380864925900368589E4A03E0D2B91C5C0B398A1BA26855F87F89AEF7BAEAF7BA849D5E14535C4DA181420369825AA207B8CD2074E0E59F75E54C845735628553453E55A453';
wwv_flow_api.g_varchar2_table(324) := '0008C9282A48D2A9688300486CD2294E6F1703989820D29CF843FFCC435516FBE13200E21C2881041C340264E44EFC9DD1A7EAA5ACFC6D4BDB15E155BE8D37A1E377314BA1814283CFD4257A1773F2F786F64F8F5C0519EDB0E5001A9E97181A467728A2';
wwv_flow_api.g_varchar2_table(325) := '2D39040E5D7FD464741169EAE7278306AA5158586E3070C1D0D8638C60C10FEA4B4D3D16C52B4522557494D810199CCA70E36C90FF1C712EBBEF19FCD58424E1CACD4901C7343FBCF3E7C493AE67261990FBCFCC037B8EA0015A42F285A49C8ACA615BFC';
wwv_flow_api.g_varchar2_table(326) := '5C42CF85605282A5664DD0FF83463ACF2764BCD66855BC2F6AF75ABA7A13CEAFB2BE21AC9F580668303CA4C742431AB8E14ED32F2489CC4D98362F54F048A16150CCB4F5291C9FAE70E27A5EFA5A537EB79433116532F14212011D64E544C10031600565';
wwv_flow_api.g_varchar2_table(327) := '042E78D08315F2128571046C25073881806404858A7B4058EB202917A2F2A7217D2AB6394EC2D505C196E0D1ED364BA1819E4F3CDECBB23530B59A55CFC578974D5C4D61E8EE6A4F2C093490A6AFE711190B0DB3E406FD41D77F362C87387959A141A4E1';
wwv_flow_api.g_varchar2_table(328) := '2368307212DE8D39F075600C6B077864362B6D96A4DF0DF94CC017C1B26487003B3D9C3A3F9D8A21A40502057B188A51E95C22417E775CCF9088ABA3F8266F3C2F36A3059175B493D239E24BE120F167C19CB266D5EF75FD7E225C886943D5B243C3FF1C';
wwv_flow_api.g_varchar2_table(329) := 'D060D7824EDBA4E8445F69D0364ACA80185869296D65D3909883C42C0B0CD6BF68F181FDA2163E5D31E801DFC9496F7879AF2A1FB6E42BD10E0AD2898862400CAE98841E46C3C4D8C7CC327C7E1EBF5FF314BA3C88BAC4332006E54C524F25ED5814FFD4';
wwv_flow_api.g_varchar2_table(330) := '85ED92B09613CD4E0439EC2DDBB3D3C6215A2BD1293450681892284966214A795BD43A4A24C4102B34A07F0E5D842F3E343C3D3D616DB9343134CCACD8205FCB0A9355CC3504B0F88EA1FE0ACB0B0DA429EEA00753D360FD0C6DC6F894242AC15E18CFB0';
wwv_flow_api.g_varchar2_table(331) := 'C27A4E7C5F10FEB6A5239168FA1C3586A8D0C1B70E113734848480B1E13E140634C0490341C38120EED55AEF4B12E3D521626C611881B3A2890E141A283438DECB8CA1936D1BEF714EB9902621861940C395A96948623B7642D0F0DFD360307D48D630A1';
wwv_flow_api.g_varchar2_table(332) := 'D7D3B4DC800728EEB52E7A5974D0ED6EF74AD3FEE9DD2F15619513CDB909C33C8EA16FDA944243DC11D5CF0F7FBB9693B7CAF2EF867C2240A5FD4C9650463C11E513C90CA84048A72404E90C6EC8A7A2BBAF718A872F06391547D8DC7C1E3246E4786F82';
wwv_flow_api.g_varchar2_table(333) := '3114A0F06B9E49F6B01EEFF8ED062C657D151C1F3C4B29A98782F2AD2EBD2F0AABD9D93C8FF31EB44D19AAE4D002CF0656DF2E831CF21A32827CA3EAD7AA4EB2CF8D36B99B5314C4E0AE34FC6F692A0D6E68B80C010DE3B9212C3A002868EA9DA61B00A1';
wwv_flow_api.g_varchar2_table(334) := '7761B9A5A66CF002337099B53BCE5268584268882AD0D54C9B141E5638E1352F6E55E45F4DE5484049513C97C45351B4F72C4EA01A4F4222F39928B99ED8E2D4E877480010982DBC32BA743AC5157FF8C2C0E09F3BF72F1E1CC3CFAF9C42A3C11C30C1A0';
wwv_flow_api.g_varchar2_table(335) := '80B109DA10E7D81DEB4C84651F4782FCB52E7E2EB7D6734DD36E416252DAC6A2D03077FA24EBD3366E6CC96FF21A62858EA6A0B8D134C005927DA683864B0A0D134183442E267CA021C818459021DA102B2A3ABA8AA0012F50D76FBB082DF5475D4327EE';
wwv_flow_api.g_varchar2_table(336) := '15A366250F7DA4D0402160CAA2858D2158219B15D673C24E55FADE500EDAEA09E4519477C553493893946319857C8CB2AC249D1832085C8730280138E30C423A17A50B511A6A704823233E7A30FF09D11518746CF7C02F45EA2B881864E3473AC793937F';
wwv_flow_api.g_varchar2_table(337) := '5BF2D7AAF8BED05ECFBA462166F6A2A2D0B054D02062A61758563D6C6B778418001A14D8A2EE030DD7338206F89E4E6840F97429DA13766898B8D830093AF83C80EC42D53AAA4A0002DDF9A8297B3557694166520A0DB4723077C44094106DC6A83A981A';
wwv_flow_api.g_varchar2_table(338) := '087401CD096B79F14351FA5293FFB4E463413A15444C0F062EA0AB73B840979413493C12C56323E30E48C21E2E3EF07CCCF0C3260EF3BB3990E544924FCD7288ED4EF8994F6589FC5E58A960CC449C49EAB120EF37C5ED4AFB2DDF5ECD0AB8DFECDA62EC';
wwv_flow_api.g_varchar2_table(339) := '102E5068A011213458A66D5B15ED56555082B80250503A5ED0701D8618A25233D83E45F974F1A1A1D7EB4996EDDD85B7B2C1FB69B8990E1D3A23A041533155C0C71B308ED43AB2F486579C3393A9AD34503898B3F6048BF592433D0BEBE8B53299269369';
wwv_flow_api.g_varchar2_table(340) := '65B3C23B5EFA5C16F61BE2DFA674D4964F055257104E44017041C697E65081908F5088E8A372648383631C2793C66838181BC74628C64F284A47E4E72124210B67B2882B13B092E350507E35A4BDAAB85982BA0BC7D9594120E30F2660D971A13D3F1A17';
wwv_flow_api.g_varchar2_table(341) := '1AF3020D469F622DA75D4A9014AE20D128B721B659CE001AC8BFB21CD0F0AF6768A0FCA161F6DC00E880A0A103DCD07DD0B58316D9852DA749CA402B0A8B112DA7865F30DBA856166C9B79B16DFE557B9513DFF2D25659FA5697FE34A5634C0F2758FD60';
wwv_flow_api.g_varchar2_table(342) := '7528D0A7464DC291B3C7C7494471662285F99D651CF8A71249E0F73EFE814F04F94090F69BC25E4DF8546ABFC9B757B36D66D0BB69DB6270DC18477501CF58B2141A68C4C10DE8C5A6EE37747C25090586DBA0B810D3D0842734A08BF0458786E797EE63';
wwv_flow_api.g_varchar2_table(343) := 'D7171AC6161BE2E306AC7941AF0CE55E47AF12E573D90205D1E6E924253A2245E16091040DAEA428DA58C1F5B7F6C7B718162AF6AFF3E2BB82F0A5227EAF49BF9B60FF70DC964E0423311F09C635BD3D8EC260C44461408C19B2090D12516E1E0BF2615B';
wwv_flow_api.g_varchar2_table(344) := 'FEDD14BFD5DADBA5D6A782B89215580E37650008201808A3A8C038E657452F8C4873FB89C6BC9CAF46FDD587A27EA9900AB4060948999C18A2989BF080867FCB000D0F366808DBA188071AE035710DE258F451BED7D12B43226B2D6D7EF503866028342C';
wwv_flow_api.g_varchar2_table(345) := '2934B443C6F8EFC6384AEE7E5FDBB615E7DD81EE4417E8AFF2EDF70561B32C7EA949DF1BE2415B3C14001D8E9D9D8223C13BFC38E0C827FC1E6F081B71B1E148140F04E14F4BD86F493B55F173B9FDAED05ECBB55738BBAAC333D1B6190F357B8B1D3A74';
wwv_flow_api.g_varchar2_table(346) := 'E60D0A0D34A61D8176BEDD2C766FB21CA892EF744810283DCD0C1AAE2834D8FE00349CBA2B0D41C728C6A1C3A400A1EA1D5DBBD2D5FBAEFAA0E93FEA92B9089BB61B16181A264BF6D3C344ECB1CAB6D7B2C21B3092123F17C59DB2F4B52AE39A84F4A725';
wwv_flow_api.g_varchar2_table(347) := 'FD6D49876D68709C08221427F047872D8435D4E0BC131712C463413CB651C8411BBEE77E53FCD990762BD27619FEC58D82F03A2764B9F60A3B83A41ED5F3486182C6F0F94DD92EEB3037A1A9579A72838B0D3328338CEB50181F6F96031AF47B7D000DE7';
wwv_flow_api.g_varchar2_table(348) := 'A98006F546D1AE35EDA6ABC00E7555DCE067D386A0D0309B2BFE682B0473000DB6686558144D8645D74CAD956C8BCBB6B239A84CBCE185B705E15D41D8280A9F4A109F51BE77C6A6199FCBE86F8D877D2CC157BDE5D17780EFB386BE27D764D13F91C11F';
wwv_flow_api.g_varchar2_table(349) := 'D9160A53B7319BE44DA181467C9EF1ED5739FD4C0268E8E8CA358586744243406EB81EEFE819141A3A2A387FDDEACAADA61F0B2D6646B68F140ED2090D0B1AACDF6174E5F87114322225B382972C316D8782C2046D4F047D6A3001AB3F1A1A7679C24947';
wwv_flow_api.g_varchar2_table(350) := '499018DCD070AD761FBB4B000D77E1A061E27A431880007350190F50285B1521EADE04AD2850689865C0453F8E96196DC6541A7AC544050C8F107C1E332FC78D4203850677908DB51B05ED5A913B24EF28F10E4D506818FEA3DD6A86974B24C586F0F4E0';
wwv_flow_api.g_varchar2_table(351) := 'C11344D872A7E9A792B89A95A3EE4D5038A0103036E346187EFFE2E84FC37F7FD67603C2F130C6390D31CF412B13CB7CBEC2AB2F39E56F0B462EAF46414364B8E04F0CCB0A0D1DCDB08809536C08840ED7134303285CF47B5DF95A3796E7328B6F9B4AE1';
wwv_flow_api.g_varchar2_table(352) := '605E2060B2A43E015B4C7F10DA73555AA03041CF4B411DDF3F97BA1DD5330D8D48F0D1E2820B1A48741F96001A50927643C3B917344CCC0DE1D14147D070A769578AF4A620999396B4ADB0B4D0D09AF7C057F94D1CE45ADFB8ED7A0C336125202C85CCBE';
wwv_flow_api.g_varchar2_table(353) := 'B232D9CF39EFD090144C2CF088F5C0906D35AB1E098A53D03026C1C7400C141AD2020DDA95AADC6BF2DF96C07092D3DF9E42038586B98B66C68B127C1ED3B4341099A1F0B97F6C0276FD2B141A2834CC313430C66B49FC52830E05858604A0E1DA171A82';
wwv_flow_api.g_varchar2_table(354) := '342942A0C33043E076947203DB2CC9F7017FD04B55863D558AF416964D48D8848EB621281C2C0034048C160D0A13F42267B4091BFA98E5BA27224A160A367AD2AE14F91A02840E57AA6C678818A40C9EC4B02C9A86E9A161726EC03788AB173CF1D8379A';
wwv_flow_api.g_varchar2_table(355) := '4820D583B698CD2ED806580A078B0D07141A2834506898CD590E6EACB0CAB7BADA81DCA15E022B2837181A2E21E498F58FCB0D0D37AA4816E8790D5004EC534C850EE40BD18D0EE81FA1F0D051A5CDB2402B07730E0DF39EBCE73D28342C064CD0F0EC53';
wwv_flow_api.g_varchar2_table(356) := 'C019E62DAF9DC9F28D59542029DC8006396E62585E6840D7F7766808C40DC18EE678A32E526CC0D52415E302706247D54E44319B2766F892B960829278E2D0B06C57FC1426680582467A2B0D994C83E594EF0D72A9295FE192038106C841F2E4B81020CD';
wwv_flow_api.g_varchar2_table(357) := 'B9262DAD580A4748EDD6848650C58660E8301A20083468388C3EC5B5A2A3A77FAF2A66583963A819249B8728850381560E280450F8A030B1C40506A269108983D9BBA27A21AB70C1A9CA506350A381860019CD031A96C546FA4E3756E8862A3644810E16';
wwv_flow_api.g_varchar2_table(358) := '34C0ED6B58598688413B9584F59C80ED192C370F0A07CB00078B9A5C1B3E412183C2048D50E73D173490BD97CA7E4B4329E6C68006232B5DCE081A5C0DF75E6F39764FF842C3685164786E701D65031AA03D41969C2ADD4B45FC522786F9F115181675F5';
wwv_flow_api.g_varchar2_table(359) := 'F3BC40C3B2254B0A0D8B5199A0E93C25D0408C4FC8C91CBDAE84F745ED4444E943867C04E8806F78672BDF2C1692185CD0A098CA3C0A0DC1A061526E90AF4C41039E96D16E14FD546A60432781CD102F488131940D141A68E52025C93E6D41618242C332';
wwv_flow_api.g_varchar2_table(360) := '41036BAD5611F08D06C3AA7F5A366850659F3C35268B516808F8A7FBD01D4043006E087ADC031C7DD91A9DC0E8A07554F95B55A26D08AA39588E644F61623630416DAD171B26E0AFDEE6F54B59B952E50B55BD800E857C2D0FE342B4D0E01803346FF4FF';
wwv_flow_api.g_varchar2_table(361) := 'D75F0E6838B641C3A917344CC30D63EB1064C4F65AD5CE24F4DC5393250A0D140E286434E77FA49342C6CCCE93AD6C56FED9C0DA3895241DE952A2D0101B343C7A43C3D86243386EF074A1BEC41E5E44D0D051E5AFF5365633D07603D5225068A0D0B0A8';
wwv_flow_api.g_varchar2_table(362) := '15080A0DD14303FAF8AEA09ECB2087BC50940B45BE8CE512D7D770C8FCF8F4F4B4F8D0D0FBD723D03041B1611274B03D31DA850A05A56B45E928DAB9D45ECF8B081A180A0D4BAA5158D4645C0F19143E96B302417161B2F324D9F1D66239F967035D7F22';
wwv_flow_api.g_varchar2_table(363) := '5C5070560A91A4EC3650141AC643430F43834FB12148BDC17A4A4263C485A29E2BF20D820659FE526D2FCAC2155A5148271CD4972C284C2C763B236DF091E0B4972190DC2828A7224CEFE3E43209344CE358B83CD0807E490B1A86E590C1B96144F83F5B';
wwv_flow_api.g_varchar2_table(364) := '2A8206586F7A260A6B3969DE709BC20185030A0DE9878C658386650B6B92A2C9B2F28FBA7A2543CBFB3C30344CED5268DF8AB0149A066F6818516C88901BAEA03DA15E2AD22E94196473F329858668A161513507140B686562963041D373CAB901AE39DF';
wwv_flow_api.g_varchar2_table(365) := 'F1F2B120C5000D015729F5FBCB010DC291100E1A22430755BA519513A9B59A235D098919602385065A51A0D0402B13B40241636C344D8F48F4F2107E35A44B59BD54670F0D5A477B797E597468787E416484B000B8E144B40258617493626CD871E11C8A';
wwv_flow_api.g_varchar2_table(366) := '0AE84E70E9BA429F4A2054B990C54B45BB56C54FE536F67F244F3FF551585A38A0699BC2C42C61226E68A0903163075B81C14FEB5A5E3D14602E8F649C0BFC110F53609964A4BD891B2734DC6A334EE0C9541ABCA1C14BD9109A1B06E8A018714EA0CFB8';
wwv_flow_api.g_varchar2_table(367) := '1FB68CFC69B55FE507ACC02CB8608742430AE1A036274161229DD0402B138943439B191CD806CB093B550D6519C3495A362DA571DE89131AF43B7D29A001FD41875238F4828648B8E11C43C399AC98D0809E36E91CB42AFAB9247C28B6B037836B951985';
wwv_flow_api.g_varchar2_table(368) := '8605D6285068580C68481B64D0298CA58606B3B50D2F86B5ACF6A7A55C1B7B28E44BDB3CC555A4BD891B87B3937EBF34D0808E1D4083A71CF274EA3EC5B92C9DC39728E453440C178A082E1C9AF2BDD65AE1A0CCC0188BA9C04B9C612934CC061AE6BDDD';
wwv_flow_api.g_varchar2_table(369) := '50A331573041A181C2448CE74FB3D8D0C21207E97D41C1B8205D0CA001EEB1AFCC8E6862C2F269E83E7497051AD06F6B87063731F8941C8601C28F27001A2E64E50CC40DE82994C813762A096F72566382DCC01E1D2C8583F982060A071426284C509848';
wwv_flow_api.g_varchar2_table(370) := 'EABCDAF63A568821C49F4D0D938104B8A04E000D012726ACE8FDEB2D0B3468B79AABD2E08D0E67E162000D1712881F313488676009AE9DCBC25EAD65630501D71BAC5DE98B4CC43387060A0734D20C19740A8342C634E74FFB57D9BF49F32DAF1D09DA35';
wwv_flow_api.g_varchar2_table(371) := '820619CFF61BDC106599C1C90D4FFF3D2D0B34E8F73A99BAB4CF5E8E6D5284880BCC106746D541BD90D5FD6613EB1F1D2E66CC6063FA52BDE8A9168142038589D943065DF9BD30175D6DAF7BD0532CED54D43351BE82B638AC450C030D81CA0C3668D03A';
wwv_flow_api.g_varchar2_table(372) := 'DA8CED20938486EE4317E10289688B0D2E6890CE40D1AA9E8AE266A9C9100503BCBB88A081E85984E5AB282C9B4681A6610A13B49DB13C3031ABDF8E25E7D216C35ABF6F33CB29072DF506171BEC9586AB58A061C67690494203F83B1D9AC46083065F74';
wwv_flow_api.g_varchar2_table(373) := '18119E7D8A5351BA94D1DFCAE7B0E65CFAD540CFABB8C4ED86145614E6B17250A581836A23268389B0EFA3798786A42023C19F192E413778E54294AF550941C38D6A8E5F46010D439A8619DB4126090D888F06BD090B1A8EA3E38673C40DE8860C4313C7';
wwv_flow_api.g_varchar2_table(374) := '62F32DDFCC2C6345212A62485B1521A92B5D8A0BB38106EA1B41A1611EA1412077AEB0E26E45BB511137C8178A1A557B6248D0009586E5818697E71794EC49B161800EC753D41B5CE87021CB279208260D92B8556966D8A5858605C38568A181A67F0A0D';
wwv_flow_api.g_varchar2_table(375) := 'CBD0B658B67646B2D0003756B3EA411BCA0C648C22C2494BDBC8A576BB64D040FC9D4640C324DC60A1C3A92CA28F57B2F4A7D55AC95A761C54A3305FAD070A071432E6113E284C2C4FB8CFEA2BAC31D5FFBEA89D492AD83DC5050DE0ECF4FCB234D0F0F2';
wwv_flow_api.g_varchar2_table(376) := '820E1340C3E1286898181DE42349B8443784F6DB82C180CC220B7392C285B44D37D0F44CA161190495141AD20B0D58684F6ECB5F6BB07BE25A8D9E183034741FBBB34FDC494283D6D13CA0C11F1D46C430342827927C25B5772BAD0CDBB64DC82C866A77';
wwv_flow_api.g_varchar2_table(377) := '917C14E64B7350892828342CE774069DC2587068C097A64D160C224177BF9695FE36B54E3CD070A3F67ABDE58206FD4EB7A0C1DDA4981E1DCE4579BFD95ACD3A978BB0B4A2301934A46DD2615EE0804203D54C2C520582C2C7D84A034E372CD954002587';
wwv_flow_api.g_varchar2_table(378) := '0F05ED44888C189276764A181A0CAB061B34B8B9E164726E685F0AAD370501EB1F8943380E36AA55B3F3525188041AEA8B0B0D9584826201858645D2405068B085B194C0B06DC864A4BD4A5CD0F0B46CD0F0D86D1FB4C7141BC6A143FB4C124F24E94882';
wwv_flow_api.g_varchar2_table(379) := '4FD16DF4F82341BA94E54FC526C7365D04C02C2C04A44ACC589B1F8D4265C98242C662B7339A731E8B3A1D2AFF6DAB97B2DA512544091D55C12A0775A2DE84D6D150C0E84412F396094343AFD7332A0D366E080B0DC2A924A23812A51309BEFC5454CE24';
wwv_flow_api.g_varchar2_table(380) := 'E167A3B5CAD53303418A95A12934C40D0DE9D42854682C34645068580C9858546868BDE6D51351E928800BE70A1EA9980E1A6E9299B74C181AC0DFE9448462C3E826C5B8104E45E158948E7199E15C920FDACDD73C79ABB41807312C1534CC172ED08A02';
wwv_flow_api.g_varchar2_table(381) := '850C0A0D141A16D7878A153E16F54B59BD56D44B55BD503573A422AC04D28206FD2E8179CB84A101FC9DCE24020DC3E810181AC8838118C09EE158687F2A193A066733A2C9402C0334CC7E0882561468A4B33241618242461AA0016F3060E59D2A4C52A0';
wwv_flow_api.g_varchar2_table(382) := 'C48FA0E152956F422FC2B64343F7A1BB7CD0F0F2A25C2AEDBF206B18163704458713513C14C423A8374827A2B0576DAC70EE2798319654351657C0382FB840E180C20485065A99580098083B5827A1AF623969BFA9DEAAC4555AEEA8134C5A12628079CB';
wwv_flow_api.g_varchar2_table(383) := '7FBD44B276C2D0807E7F040D8818FCA0612C3708C7827484C58FA7A2F8A3D15CCBD9C7259A43397BA9A61E22618564350A34DD52C8A0FE10B402B100D080472AD8D65A4E3D141037C828F15F4D050D89CC5B260F0DDD87AE1B1AC2A2C321081AC41341DC';
wwv_flow_api.g_varchar2_table(384) := '6FB6DF159A6627025717D896B908DB2289A85E6449BD19526EBB643F59D38A020D5A99A0DA8845858970C480B38F88B9A1FD86D72E25E5068B1BC21B3A192AC8249662A7021A7ABD1E10C35F27317841835F488752EB44689F0ACDCD52C36C4634188F97';
wwv_flow_api.g_varchar2_table(385) := '4B9B89F2C594E6A98746723E0A7327602CA72C282E5068A0D0B078D0D0C2950609730398147F2EEBD730781996181CD0D05F4A6840BF36541A5CB2062F74681B750541449F9EE0386A4B8742F358948F44F15399ECB1246AC72633372FE2B8774836E687';
wwv_flow_api.g_varchar2_table(386) := '122804A430D2F67B511BECF96A672C92D994DBF6315C63C2309926375A2B9CB853EDDEA8CAA5AA5D6BCAA5823840B951E42B9978308C8506FD4E5F526878797E4128E0DDA170718379BB0DB7DBE231342CD097C07EEDAFB5463667BC10595C66A0D030AB';
wwv_flow_api.g_varchar2_table(387) := '0988B45514CA4B16CB060D49C10485060A0D114083FDF6EBBCFCB5A6DD69CA05CC50C0126D0404379A7AA52A9D31D0802291FD96E980861758906D41833737605C900EE0630B8778042507B8FF44147FD41BAFF3C4C7A9891B13F08A64D8E58486796C43';
wwv_flow_api.g_varchar2_table(388) := '2C76BB81C20A85063AD249A1C17E5B32263033ED6C563E68EB1DA004E50A1183AE5D03346823A181704352A313A98006F4FBB7FEB446151B708807F0B10D7D0AFC29B9E7A0DD7C93AF9157036B42036300C4C257141A53204252B840E180C204F587A015';
wwv_flow_api.g_varchar2_table(389) := '88795CF91D55A541C4DC20984E91DA090C53206850AF34503974342D800A32A9D189544043F7A18BA001B8E1A06D8F216E00E903F8311C892DB82148BF5B8D0FA5066B383F92C4DC5C619B2CBB0C6D88943720964DC04863392B10545049A1212034080C';
wwv_flow_api.g_varchar2_table(390) := 'DB6606DC609184F0AEA09D88DAAD262356B8D586B7527940C3AD96C8AAAAB440032226031AFEB65DDC604787F621BEFD57100EF0F825FA924FA51AC336CDBA02BCE6D06D76704F93F1C8D6735A5198D85F212C2E24D574A0E9964206F587A03011374C24';
wwv_flow_api.g_varchar2_table(391) := 'D89E10B01072703F0341FA14D2C7927A2EA9F79A7EA369978A9FA621F1AD1369114292010ACF6283931B4CB7E90341428FFF5CAAB1ACF17A624C5CB0DDE3490C4B020DF3584E58D4A4588A282834506D04858605D0340CFB3710876969ABAC9D4B1A5945';
wwv_flow_api.g_varchar2_table(392) := '61DA370D1383313A71AF2798B4938706F407A1C0086820212250F8DB6E9F88081D9ADB95DA0A2CB16C658C0203BC6A4D68B04F5DC6F7A24CAAE7971E6B67DA6EA0D040B511141A2834046A4F300E5F48C1D69E6831C69DF27645EB28CA9D0672487F6840';
wwv_flow_api.g_varchar2_table(393) := '015B2796171AF01FE94CB23A142D4004015A157F5AC2DFB660BA38B40EC4369846B7DBBBE506562DA0635D670DE5A319AC450C8DCCDC47A84E44706248D67C69D9923D8586C5F6B7A0303117A65233F38AF65633F887C4B0A4DE20E07F4ED9A9EAD78A74';
wwv_flow_api.g_varchar2_table(394) := 'AF69379A02A16A377898E24E556F55FD5A252E0E497941A6081AD05168FD36A181281B001A302EE03203BAB3856D9D5ABBD5DA2A47062CE145C9B8A0C130696830CB450CB5848881420385060A0D141A28344C0C0D6EFF86D5ACB45743DCA0DC82704125';
wwv_flow_api.g_varchar2_table(395) := 'E60DB7789EE252D1EE8CF644828286B44043F7B1DBDC6F926283A188FC8BEB0DA4EA40E2A8DDDEAB36B18913E454961003DBF0E28639828699D93C2FC9A86454C998420385060A0D141AE28686B6D9B9207398F02F725975AFAADDA9EA8D02E2863B5DBD';
wwv_flow_api.g_varchar2_table(396) := 'D1BAD75AB7A32192207D8AA46C9D52040DFDFFF52D68680F262984162E3C08E0C720B4BF54EA6B59BC5D02840B3522625856688809171640A3505AD0A0D0407764CC12322834CCACD220B2467B62E0DFC0B2CA8FBA7E25ABF7E0DC00A64FB73AE81F6F4D';
wwv_flow_api.g_varchar2_table(397) := '15248506F40788E1B7010DC00D304F0101B286FD56EB5BBDC17175C67C21E23203DC40D0C06670B01029868619AF8F9A591581C20185060A0D141A28344CD39E006830B9412492C9154E45DC70A3E07E84A16FD0716F22412FC8744183742A19C586DFF8';
wwv_flow_api.g_varchar2_table(398) := 'E35F83182444123B95EA2BA32B5163F00B9A35B1806507C4900E6888A3C4172D2ED84F76B4A240A18142039DC2880F262834040DC67DBBCD72EA975AF74655EF34B5639419C00B32395BA77441033A16000D0811C8473234F1ABD9DAAED4D7B355331FD7';
wwv_flow_api.g_varchar2_table(399) := 'D84C7D85355E8B2C5B5FB11103CB7A7628627A11D767150111A1462B0A141A2834D00A048586B96B4F301EDC2091DB2C277FA9EAD7B27E074313306F69B7757A5E6E68E8FDEB012BE00E45133EC2F44473AF5A59CB56AC1A03B424103180A6A18EE72D6B';
wwv_flow_api.g_varchar2_table(400) := 'F30F0D23DE9CB40D31036828FA0485060A0D141A2834CC021A6CAED2D6A7A2C90D6D9693BE54B58EA23DE8DA1540C38015961C1AD0EFDFFCD56CFF6ED5102E1C0AE27EB3F5A9585F613D5EAC0C09168235C2840608328759CFA42BC6BE09A3B5715C5A38';
wwv_flow_api.g_varchar2_table(401) := '28860C5A99A090411765C5010DAE8BAB54B93CC5C40AC2648D092F8690B0CF34F9B4C564E4ED52F752561FBBDDC76EB22AC8A4A1E1D9715B3814801B0E84D68F46E353B196E5C87BC0A40467B0AC2B08311068481B318C8586C88D9F29345068A0D040A1';
wwv_flow_api.g_varchar2_table(402) := '21D94A432386AAC3B241838CEF6CB11971B3AC9FCBBD5E2FF10BFCA4A1E179800E6A476DEE37DBDFEAF50FC5CA0A5B71E6D420D0504F2B31D4A77EAFCE6C6C7251DB0DCB060DCB061FB43DB12453154B050D6D7CC3E8536458F973D9C3D6E97909DB13E6';
wwv_flow_api.g_varchar2_table(403) := 'EFFCD4EB35BED6EAAFF355CE4D0CE3A181B122335F9586A870816A142834D08A05AD40C40D13141A66030D82B1CB8A259FCA841E5EE7C714EC171B1ADCBCF4DCEF3F76CB8818CC97B823D7B22C1142D686A161B87331CF9586B973714E5B92A3D040E183';
wwv_flow_api.g_varchar2_table(404) := '56202834CC3B3488C660054B6E106850B74A69D01FA6061AD09FC76E89CB7ABF5819F3E3303724040D91D7FDE674E9C3BCC00185065AB1A02BB91760AA6259DA13AC711B0F5EE26E4526A3FF6952687056579E9E1AEF8B8EF469524235E380861A9EB7F4';
wwv_flow_api.g_varchar2_table(405) := '8686712B9D66060131E915AA212961510B0C141A2834506898DF0A048586D1D0D036BA12B8D2C0E27B56B8A78EBAD4D03010425A00F1DC17BFD40697D10C40439571BEB2DDDC602B3CF840432DDDD010536961E10D9728345068A01A8854552028344409';
wwv_flow_api.g_varchar2_table(406) := '0DCCA02B21327827C57AFEA5FFB4F4D030C410F2855C66066506CBE89000446D6C64E623AA299E86A010408332C7EC216369B50EC3A67971A083450361A1A1354368106D21136E6006FA0675B79692449D26687879E93E742B1C6B2FC59357A455755800';
wwv_flow_api.g_varchar2_table(407) := '68888918A8468142C3620B4229342CAA409242C330344883010AE376FF58A4D0E05D6CA8BFE30922586FA41A031398D520DCB010AC90ACC29142C3724243D8E399B6E3BFA8ED8C456D4F8C80863A8506FB00058186D5ECCB63974283F71FE16BAD0488C0';
wwv_flow_api.g_varchar2_table(408) := '566CC5868AD5B06086E8619E0B09291C8898976436EFD050A43193E7915620663955313D37506830708131A0410241032B7F2CA544D0902834F85852686762D114429687DF3FCC50C43C5014D37BB532C58AEAA5F251A0D040E9815620E2838954594652';
wwv_flow_api.g_varchar2_table(409) := '68704183556FD0F75B9E3605CB5A6970D2C3D3835ECE66CB1634300640545C2315CC98F74035AD316377E7654B8A34D9538648034CCCCB14463AADA629348819966CCD16F1A2CB7E474B70AD65DADB132FCF4F8D4F25F2AE2B33100E6820B799F16F8385';
wwv_flow_api.g_varchar2_table(410) := 'C185CA726B1428344C16858822ECF7A73041A1A146A1210221246B2C9E40F1BEF8F2BFA7F4A4E8F441C3CB8BF8B55ECEB00634CC8FBB7B3AD74E5268A0D040A161792A10E9718A8C951B96011A841563F652FF5E4F55824E1D34F45F5EBAD76AC17C8395';
wwv_flow_api.g_varchar2_table(411) := '8D7A035B9E1362A82C6845615121206D341022A333384626EFE034102D524C0F318B0713F3651295068088CFF4297268986A3195D7DC449BB56C9DD8FEADD6A7D030861BFEF5AAAFF2F67438F68D472B0A141A16A37E103A7333D33E98C7E1F9783EBA8A';
wwv_flow_api.g_varchar2_table(412) := 'C50838085BE148E475155599615EA62DD2507858666810B00B24BAA1BC2DBCFCD7A3D030BEDAD0DEAD16CDF76A2995DC5099B957236D372CD2EF157732E6195B648682198A8C4F303EE1F760E717169831159142FC458EB918CAA0D040A1C133F49F0D63';
wwv_flow_api.g_varchar2_table(413) := '6EE29942831F30E08514DAB158F08186F26CC79AE32821A6A1A2B06C6AF94582037B9E0EF2986922ECF72F84FC3EC9A2431CAFB7C43122B5BE0E141A824383647CE47AD78A3566D8A7D030EA4FAF57CC668BFE6FC5CA1C46283288BBB440A1219D1582B1';
wwv_flow_api.g_varchar2_table(414) := 'B860EF1AF04CC23F8F33D89111B42D320D64A4F04598860A447ACCA0EC0B0229348C800619DFAFBC2EF489A7D3336D4F04F193DE2C1746BE03E79D0C66D37DA073F9F3050D7CD411FCFB47F28345F57B2D582982B62D5CE810A4FCB0E4ED098161B5EF8D';
wwv_flow_api.g_varchar2_table(415) := 'D15E88141A1C7F9463B1C0B001DF7EF30B0D7444309DD090602D61741275DD9F37033404AC1185954C61154736535C638BEB6CE915577A0D517E9B255179472257D9C0F13E57B5E2832D6CF757EC41BEEA5D0EBEDB1B14C6F72FAD43C03F9A65E107E032';
wwv_flow_api.g_varchar2_table(416) := 'FCCAE007B3AB228C1F3B3C7CCC75ED814243F09EC5520B2133196935F7D45183D8285368308FCE7F4F452E5B1AE28672BAB9216E5C886AB1108586B9AB28C017B299E20A5B5CE54A6BD9F23A4485A4FF8D2C4AEAB58FF9DAA77CFD330FB1332E76FD636F';
wwv_flow_api.g_varchar2_table(417) := '28DC8FC90F7F87C66E0162A75087E0EBDB7C7D8BAF41E46B9BF9DA47BEF681AFBECF5736F295B739C419A5D7598432450E058B7E29F4AB1598E84B11697B7D26A578482D34D4283478561AD88CF2A60012C8670A0DC15CA541F1D1EF3776AA05DB493F55';
wwv_flow_api.g_varchar2_table(418) := 'F490540382DA0647721C22172186FE9E0C74FABD071058B8402F64D9E22BAE842EE2DF65CB1BB9EA6708C8BE5B79C8C76373FF4EBAC2408AA1301EB06DB045F553AEF2215B7ECF555E67CB0829D041E070E18435CA2A9134328A030586F793383398F094';
wwv_flow_api.g_varchar2_table(419) := '31CDA60E31192B4C890E764D43288D64B4E8101C1ADA314083E78E89C12E6C86DC667B2762FFC5296878EE536818F3473D910A2C5B0C090DE5D83640CE1214E89681F8A061AA220113BA6CEE79A14C1A0A281D165733A5750E5D7957DEE5AA1BB9FA275C';
wwv_flow_api.g_varchar2_table(420) := '27D884CBF4C636CEAC7B10698380D081F8C033869082104F937CBA5DA86F41D43EF3D58F7CF5431E5A21AFB9D21A8B8E1B3A7A7EC39F96F9D558B0283210A34B148538D1A1EC332396B6210B973DFF94DC40A1C1BEFCDA1A97102C1524977BB9D3DC17D2';
wwv_flow_api.g_varchar2_table(421) := '141A46FB42E2ED554FE557F9823349A461851DC585A585067F75216B868FE600D70F50B62BBF064941F563AEF62957FB9C477080AEB31B56E2DCE149E06C9A8746801109151276E38DC6AE9D186CBF9AFD1747CC84B1A9B6CD0F8ECF3642AB7CED63AEFA';
wwv_flow_api.g_varchar2_table(422) := '1EF116C6882C9650B0064990C34E202F604DA2E86FAC99E616C6700534BE7A4354B397134C632E24340C8271CC5BCA5BD597BE69CFF09CAEEC9CE24AC333B473DA5FEBFCC87720C5051A7113835F31DC7E8F9D18AC2A42613543B4872038F8CCA32B6628';
wwv_flow_api.g_varchar2_table(423) := '1EE070A5E4DA4E1E623BE7CCD99035E17EA2210895CE77E24EF63EED86881EEFD0520CD415052FE6801BCDBD6263A70835894FF9EA875CE55D161DF9E23A6B6788899B1A8928215CA791B08E9333903BD49C6D8BD958382C1A3430AC604203BA2193DE04';
wwv_flow_api.g_varchar2_table(424) := '9379BA905F0C6AA0D01052DCD0EBA88515B610E02D977E26F044048A0BB34184E2148E08FC58F52293C93370995B5C63A1D1B091AD7DCCD737F9065C19634480E08DC029BF86C3B84DB801871F1358D971BA6BFA317F1B22F6220A8FEF6C746448DDA5BE';
wwv_flow_api.g_varchar2_table(425) := '632BC320C8700B33A108613CD815D0DAE0EB9B082378046D20BD5CE710C6218CC84737E13963916FDA3A17B588DA1651993ECD61A581B58B1B883D83F826F782ED19FA29F3829C034D03A9CC54DF17F8C06F365A48A011C9F883A7C561DEA5585C2194C0';
wwv_flow_api.g_varchar2_table(426) := '553672E802D7DE6B18940A0C4A28D8DB0AB56D7C8F2D6ABBFE5D7F1C7EB9D61702DCE9D9CCC4BEF9BB9070B8D061A760042680A619836EC59E5D1551F0EE778036A2D8802818F4B6C5D73EF308E92A6F72E55759980BB50923F2494C670C5F4244480F95';
wwv_flow_api.g_varchar2_table(427) := '59A1C3941316519945CEA3A641C2DC00CB267099A19D61B55F756FAF640A0DA3596160D87028141836A9E587490D3BCC605110C58571FE861E5B180A0414409490C71D07DED2FF3B861A069F1AF387B5ED3C0A5242C0C2462B5CA5050B14BCDB0DEE04EF';
wwv_flow_api.g_varchar2_table(428) := '5B098828977F8939FCFEADA1DF911C0443166A1E1022146D5A3034741CCC8799C7C4548D34C974E8260FED0C5C87404F2BD421BC04954526BD158880DC30CB414D0A0DC1A1A16D49203131406F623DFF72AF7A3426283404E94DBC9872C812B6949E3B68';
wwv_flow_api.g_varchar2_table(429) := '48B357312586A0230F2867706C793D5B7D9BAFBD877237881276882101D412881CC12938186282E14A8051751F4A72B8FCEEAE28ECD98B07AE9A41C8DC1F111C347D621268F06005BEF16528BEE220BFF517BEB9678477BBC43AA45F8C7B2C65A5F957F9';
wwv_flow_api.g_varchar2_table(430) := '86791B31073004282BF9DA065F7D932FAF658B2B6C61BAA9CE940827A7818699714354EBACE674E4523285907286533E9551CEEB9324F83F632C806EB90C0C0D64D4E47FFDD6EF164C4659C918837F89654B73BBF531F14D01894F434C79F4223F9EEE61';
wwv_flow_api.g_varchar2_table(431) := 'C8D54CE955A6B2C1194D8789870E466A1486BB0CFE2810A0AD104325A0F935647C8928827D431F180AA09CB08D6C34BC9E97FA1698469437B8E22BB6B03618CAE07DDE47F1BDEF52E232695FE097E6624324F410133478CF4DB06CDBC60DBD1B256D2286';
wwv_flow_api.g_varchar2_table(432) := '39AC34BCBCE8F77A911DBC85ACB71F8586398586626CD05064D880C5642301D807FDD16B6C9DC5020562936074D649EEB74B17A799513472952F13846C1944C40AEE549DB6F812981EBC496218205CC249AB0392AFEFD81EB0634CBB800CE25DAEB4C612';
wwv_flow_api.g_varchar2_table(433) := '9B297EA469471CEFBB684DA226E686F8A0A1B69CD0C00C6EC0A4E587C2CB538F424334F4D0D82CF3F69CC124DCA7985F5C481C1AA29A8698EC783AEC13C8D4C36AA6FC06CF3B6CE13107DC5668D89A0B04176A93CD2C84551A7E8914024273407110DF48';
wwv_flow_api.g_varchar2_table(434) := '14E28D3849C24115C13498F6FA106E2199624C4B98895E249FF295B7D962167B6FB00E83A9B1EFB569DE8FE9D13A54E2349C5E2A68105853CA806FE8872DB775348586B03506EB9EEE9542DC218BA689DB6CFA85F35E51986B4D43213A8B05874C81351D';
wwv_flow_api.g_varchar2_table(435) := '14DE656B5BBC63C0C1A964ACB988612FD058A3B3CB1E251C4C985C03E5EF6224D10A19B3E78931CF8B638263602465DD36490217A2B6F8CA062CEB2200E1E406D6CF276ACAF7637A463493D5452E0634B4F1982599BD945FE5FB3D3D85339673E6D3609B';
wwv_flow_api.g_varchar2_table(436) := '38E9D73E95D07BB264D69F9743C3BFA4D0307145811FA9542866C190B142AC96768B8D2F257BCAAF399C850A4331D2CF2060396162B1616838089FEFBF2711D350C5B7C9E961BC32D48C2699B918E12AB153A86D82C575E54DB6B4C659FD8BC94494F15D';
wwv_flow_api.g_varchar2_table(437) := '0585A287726C8E0E517143240691C9571AB0A113FE2B56FBDD4C99E471BE462E3D57519C4A7C6630FE44596151A121F8F599A746A1606B4040E9182F7F82CD0EEFF330FBB0630CEE9B7D0763FC614CF761CF9A6BF0CB2E3EDC1047092140B520B2A4FE23';
wwv_flow_api.g_varchar2_table(438) := '64C4481805777C1B44508C08A88718AE3A7C713ECBF66D9F86F714B6A4DCC4EA878D1C38407043DA49669ED02160F921296E20583065C9217168B0E62DC595EC53AF4BD25F9F4243541D8A97A7A7DAFB62C1A969985F388864F3EF3240C384479245AC90';
wwv_flow_api.g_varchar2_table(439) := '29BFE5AA9FF28301C8DD827B7183DF7EC83DA75F509011C7502584885A09B124FE54C574158BF12411701CC3A697B44183F9C2B06410A6750400C467BEF20EDB3FAC784F5E84DA85114A30146DD521AA92C304B6D341A0611A6E48033408D84C5AFB56EF';
wwv_flow_api.g_varchar2_table(440) := '9B1E45FD746343E6654EFE9003AA1E0A7679FC02180E526888763704D4A256D9CA5B3C01B16DCE3E40EB81D412F21E25049B7B92A57AB3EC950CFBA02F96895038626806E9328C6B2BCCA242F0D388B633C27E9FF6CF70312B98B0552346A2839BEA4C19';
wwv_flow_api.g_varchar2_table(441) := '4473AF08EB2DFC34106605A26E194298EED7CD9D6263B350DDC897B2D0B998D97B36E5DC509D9A1BECD0509F5B68006E603232C3BEFCD3FB78DD12AD3444CE0EFDEA46A1600E5EF2E3CADAE96937F051C7826917FC7E60ABA2EBA7321B382B6441DB58DD';
wwv_flow_api.g_varchar2_table(442) := 'CA8349F36EA1BE672B2AEC061A896C0C0F3B4C6C7634B6B9300E1AA60482B65FFC9C3E4A2363BA6FEEF53347C610A30513A1DA19AEB694A713A5CDBFCB94D6E66193D62BDCB970BE8BC79C6D98D0EFEBA41CA923F480AAC7BF327B7A97A780A020901E04';
wwv_flow_api.g_varchar2_table(443) := '63D415ACFB890A52FDDEE8A7CF2E7A51A0E1B9AF1C0905962DB1ACAB4951A0D030CF6D8840C118B60A793B46AC644AAFB8EAFB1CEC90DC2D5A56CDE65682D1A050F09531865521042106AF5E83D1951FB4EA2701052F2C28451FBF6C11FA6B8B83088120';
wwv_flow_api.g_varchar2_table(444) := 'E340642C5804D149B85411DFC6F7327C7D201CE651B6DBE6488EB102033A17B952962D30319A4ECE3B37D467B2327B36D0E0DA6C69393480A6612DD7BF56FBF39384E70D1AD09FFFF56B1F8A7CFA14887C405B620A0DC19E32D763DC6B2058D80151D9C8';
wwv_flow_api.g_varchar2_table(445) := '81B671B7D8D8C3DAC66D1B22F80917F61C114297F015228A71475248F0418491ED83088A01BF521CC33FA7073A842089F1158B71D5085F8CF0F581B001A857F9C1F27B68EE149BDBC5FA47BEF23A5B5C35AB658CA3A8E03149C4842EA9065F88954275E4';
wwv_flow_api.g_varchar2_table(446) := '6CBC9E66000D92575782542094AF3574316C17F3D1F644F47F9453314F662FD3840B338E25D12E14CD4E84D18660616C12DA10E0EE0CB8002B22611DD490FF920B173C29E14B0051C2B4D60813B61B82B51522C30221D1184607C18F277CEB1C3100840D';
wwv_flow_api.g_varchar2_table(447) := '237CEB10DE2610BCEF3A31A2A1D936AB0E36C7C9F21B8E5F31366DDA5C4DD9D1E3C7F1994B46E8EB30036E486AF63274A5C12C30C8C40B723DF774A7BA96275068885AD5F00CCA86FA16184496961217E61D1A263CB696C7F3268F07268D6D9096F912C4';
wwv_flow_api.g_varchar2_table(448) := '4EDEAFA8E00B077B6158E15BC08E83ED6A356C9721602D6150ED0F99F8F743C6345F1BE47B86640B5FD4F0EE7D8CC788C07D8D82AD9D513471D0AB7331121AEAF8254AFEAA6ED9469996D5F54D9E8C6B8E9EB628CE64A545295253EAE9A731A7E186C4A1';
wwv_flow_api.g_varchar2_table(449) := '41B0C91A242C6520B507FD4703E5B3279B688F561A229E9F186CA3B85179661665063EAD31A7D030C1FAA8C22AACA2AE7DE2ED160B86CB022E30587C50731243947E09E3C6207D450941B40841BA0C4110617FA1C3F53B8E0288B1DA8B30DA08FBF3E835';
wwv_flow_api.g_varchar2_table(450) := '97E1890E4DCBD7C1B3D280D0613B5F77AA2649F302A62D48E1E11557E01CBB5146482647B8A2A567D4A21A333AA41D1A98C14E4B892CC57E9D7F79D4496EEBF72934C4090DE45673AFEA6796C25368481A1AA63DE00C281C6178F263BEB6C91B7505A084';
wwv_flow_api.g_varchar2_table(451) := 'BC4DEAE86C4660C599770F62028D828F62D18B12865861624542C0E2419014FB3B9A10F76DF1DB1E65CFF0FD3EF687ED973C2346D4F0C08B7195895075081F7AF0B0FFF2D96E5A7799556F1B011ED56B6E8FEA982A1033283C4CCF0D730A0D129E98B0A0';
wwv_flow_api.g_varchar2_table(452) := '01DD6EAD66F5FD66DFEC4AF4E743CF3077D04028CC528B3C768B596E8ED23C8586A03ED06CA6BC9EADBDE71B5BC5C1F607FB9E496B866DC7B5E3189F9A8DBE83D95D0E0E0D230A0983318790EA84D1B8309612C625C5A892BA7FB2F78A3F65BFEF2FFA7D';
wwv_flow_api.g_varchar2_table(453) := 'C9EF72E018FA5AD7EFE8C919D6CF1C0C23DAC1BB1B563568182346A3C3D88D59FEAEE478D926F83D34778B8D2DBEFA3E575AE7C0246AD2098BC20CA1A19C50B121D5D0E0D437B419B6FDBEF0F25FAF47A0E17F2F43F440A12116CB86BE782C169CE6C1C3';
wwv_flow_api.g_varchar2_table(454) := '530C33CEE5799F981925A40126828F9B3B9E26F4B71C2C9C049123AE19D476F241164FBB374D7B53023F5EAFE03DE610081148528192C30F0C013F4AADEFE86319E267D9EC2F18857194BA488A9AA48AE048EAFEA9F78F4FC4FDF8B0DF67C4F70FF7F812';
wwv_flow_api.g_varchar2_table(455) := '04505159D8C778B45F0608DB2F0F8EAA71C3BC077F84475A45088758646429C20F1D5C152977DB82772CE9DEE3477083BD1431503CBCCB16F0A84531FC5BAC38DB9EC5344287C8A1213E97A7E012489961255C6C20DE0CDD4BB93F9F9977EE7C1A1C9F3D';
wwv_flow_api.g_varchar2_table(456) := '3D3DD5360A8E861F6364E8A4AA0E141AACDDE5A19A3EC535AE6CDA38929DD483BA82172E0C0A0C0166269B63E720BC350AE3A509835EF8F7A2A1F9B7B5CC1DD908B302C105F485E11B0D65216CD24D22249F88EC9FF0FF956D5830386EE84B845F70E4A5';
wwv_flow_api.g_varchar2_table(457) := 'BF657CBB8491A23278B0F944881E3A093B3A0C492286059563150F5F3DE72C460A27C9ABDD9CD544DC50FB98AFBECF15570CB943F0FD6DC5998F5A4CA38E8CBC433199CB5354D02098A31312035FA57DADBEFCD7A3D0305368E81BBA9117FD42E657D802';
wwv_flow_api.g_varchar2_table(458) := 'C39239255275C8C74F0CF990B1A8D030E10F607934AD644AEB5CE51DCC4498B800760BB5ED71A64CC1EC9C3D0C97DCC390AEC1C8C2F84948AF4B4FE1174A48B8A2F0039710F607F906DD363E25DCF01B5FEC8EAB22C405017FBDC32FD9A35CEB1D611F3F';
wwv_flow_api.g_varchar2_table(459) := '365C9061FFF182FC5EFB169DE092C35F08E10F3AAA457C8F8114043B849FC561D410F747629C5B15314E4A393CB119C8E661A87F6108274D536A331A5B85EA46AEB4C6C2524D668C9C6BCA95DCA538AB0E292936C40E0DD80B5258C1B75FE57BF75AFA47';
wwv_flow_api.g_varchar2_table(460) := '2BE71F1A9E3D2A0DC4A9BBF5BD0EF53AD61CE847D0C0245651A0D0E0AFF166C9D0B9DDC9B1F23E872E9EE0126AAF40662641EAE85D602818E6D03846571702D41282EA124C4A1816DE3B05F9E6230108706D5C30333D2912186164A0E218A9E094D7F77F';
wwv_flow_api.g_varchar2_table(461) := '238C8A4F94630EE31F72C3CD5F9F02C66FE30B4D68288B0715F1A02AC277A84A0710041DB026C3684C180C61A9435C9A8F71003134A331247DF02C3CF80384D7D2545B1763C716A4D8B65DA87EC815D7583E63193CC015D4ECFD25E3103ACC5211398B4A';
wwv_flow_api.g_varchar2_table(462) := '03E10686D5FEB6E71417E65ED330F8F3DF53F91D9F7776C793828379878642606176283F477BE1875417AAEF73F6B1882A2CA776EDA72E58D310C1AD1B836C840ACA0A3FBC06209D0609362D02A9225484DFD5F6AF4AE36BA9BAC5973FE650A01BE85374';
wwv_flow_api.g_varchar2_table(463) := '27FA5B9CC3D0157071F2B6823B894694D40F2ADEE1F7FD0F628840B0E2F50B228038C0B8F0BB2461564047BBBE57AC6CF2A50FB9F2877C75936F7E43AC50950EAB1EC7DFEC7A487FBCC4989EC31DDE43193E8587306D8B51E840E861278FA23EA840E08D';
wwv_flow_api.g_varchar2_table(464) := '9A1F7984E03C33EDB962CA9EC5C432C9C88729D2060DA2090DEA56F9E5E9C9E3029842C34CBD9E5E5EF44B253F5D57221F73CC3B344C320441940D8C638AB2F41A5717B6F099CE6EE6681A34F9CA1BF7C2182D8C7253F06785D16609C3D30DF62C822E5E';
wwv_flow_api.g_varchar2_table(465) := 'FF545A3FCB95CF7C2ECBB219F8C3DA22B79AA97CE25B3FD0C3CAC2DFD254AD8420C9DE37CA3E51493AC2FC3C43D023FE29CA4715E9B086F8ACF82E9B5DC990A7C07A1638F4F27BC3D5760B028283235CC3F85316AD7AC39F80EA4BFFD150D73CA7B304E5';
wwv_flow_api.g_varchar2_table(466) := '356A5118870EFC88A8EFE56D7ED5D859720B565A94D638B20D2B1F405A5488A76D112D375417021A883183B89AEB5F2BBE85730A0DB174289E7DFF4AF8D5C03D72369F281C506818A607F8F5312E543FE40CD582732602F723CC3B4D56302EA402AE97F4';
wwv_flow_api.g_varchar2_table(467) := 'DF18196430D2C76CB1D80E36D700B9E7A056DB29E4D74D5C6032EC0A0B9F30196E8563199664AF7C96AD6EF3D251DD0F0E2629062411F2612C31F8270E7104FF794E6AED5FE5F2C73CC2050314D0D167F02D06EEB0300E2145F33B69676074F86DF47706';
wwv_flow_api.g_varchar2_table(468) := 'DCE029BDF49061421DC2BB9731DCB6F0534D0EA6798BBEA207CFAA031EC42026518D1DBE69A003DFDC29D63EE66191E64A34E78D98D021AA56C51C551ADA2B9CFAAB69AC99A0ED8954583EFDEFA9F6A998C3E2060A0D698006F716CA4D1E5AB0DB44B590';
wwv_flow_api.g_varchar2_table(469) := '77FA2E40E1011B3EDA6622C2E2C2D722841F2EFC18CD0A2517318C6605A72F02A490D2468E5CDDB2283F311CFCDFCA580C4E610CA003BA851E56F9CCFBB618624EEA924FC8698D113FA7FDF715FE544A1FB226B171F01430669161053D17F8F8670C7443';
wwv_flow_api.g_varchar2_table(470) := '4F01CAD30802E4C32A29390C8EBFCFD0C7B084C2E53FE146077BDBC22585B14DDC782ECA72D24311018173BB2626869D7C730FB182D9B318342FF8262E3CD43EE44B6B11342C62E28608F50DF3526990DF15FAFD27E2C7D0371D20293424DCA4E8FFEB15';
wwv_flow_api.g_varchar2_table(471) := '56B383F23863EC8ECB671CFB94F349477AD0617AF2F0EE4A64A0DE5360092EC06629E844ECF055B319E1AB73DCB5891CEDDB87032B1CBD973E78EC7F1A12368EAE2BFCB68DF0ED97A4DF1569BF4C6C8E84BFB5E2FB9C510A67E0921607CB9160E023FC61';
wwv_flow_api.g_varchar2_table(472) := '70F9C1B8F0CD54B778F9A42E1DA27455920FD0F52E4A57A3A0212D59FCC88CB10F98324632847C5445074DC6474639ADA17BF877398E234F01CBE2408CC0AD98CF023C0119F214987FB8FAD7B2748CBE5B090341151FFF9234426BE9598418DC761852F9';
wwv_flow_api.g_varchar2_table(473) := 'DA5D8F9EB6F81644326994196CCBDC79870C62D7DC67B10376D4C57543183ED639974F4DBD61044004E48608D75D866285D68A89082B600129B2788F25FA91D6724F57EA6062624E7C9C16171A6CFD21F544E2B14A9FB7A56748600C9B867AC30240C3E8';
wwv_flow_api.g_varchar2_table(474) := 'CA84F5738276612357FF8C072911286CE129CADDC2102E14EC63112106227CB73F78392F79B0827DA7834DACE03D06692B4AFF2D0FCC954176572D7DCC714645C120068E63B3AB5C6E3D9B7F95CBAF67D10DF4294A6046D2C2792B9F65D1EF2B1D552151';
wwv_flow_api.g_varchar2_table(475) := '1DC095AEFC1725C26A4A5921421A980E2080188ED1512A93FBA5C3AA7C52AB6EE52C0983816B2B6C2ECBE5D638E32958339F82013AB0592ED3FC51140F70BDE1774539AA6168F0535C0E4A1101CC244A965BB6BBF0E063F6E0A97808306DC17B4C699AB3';
wwv_flow_api.g_varchar2_table(476) := '1546C9E173BEFA21575AB50D2E31639CA0F891D2E6B0B315D14E63D6A6E386B8A1C15163C0CA4789057AD0FEB488FEB1FF32C76A8685AA34D801A2F5B596F35144E6D3C10D0B536918F65D802D626BACE1BBB05518EC8CF0F6731C1A9EDC1BB279FE1206';
wwv_flow_api.g_varchar2_table(477) := '14BE8F9E961C481AC79B30BAC6200729C1D0304AB8B3D0FC5AE458DB052E4A571C8B5214FF2657DCC8973EF0A58F7CF13D5F789B0774E0083AB0A4C55E78CD8988120E41F70719115F3ACF4FE5A0EA13F133C471553E2CCBC704206AED5F951C6723068E';
wwv_flow_api.g_varchar2_table(478) := '43079A7F4D8E7F1E1D7FF42C14DEE5D13D08233037B04471821E5F789715F048057A360141FE94034D8EFCF554628E30A172CA27BDCD1E4A23A72DC66EC61AB6A6363A7DCDDD2278516F16C04D9233BDEF18371CF0014A0E63176295926B55D4A3E086E9';
wwv_flow_api.g_varchar2_table(479) := 'A141CEB06DC6D19B1032ACBC597EF9AF4780A13F569F47A161A61E914463F2F4547A5FB04F521459D63361536888A0F0C0B0D6986B319B29BFCBD63EC33A4A6CBA809B11DBB675D58ED5D523ED16BE3A774338B48D638620DAC3B8F06BDCEC83ADA8208C';
wwv_flow_api.g_varchar2_table(480) := '1E80C44E0090270E2BC27E995FC77D7343B5802E5E39745D8B5254E953A1B255ACEE946ABB25F4B1B25944E880F356965BE1B0CA218368A3FEA588122DE206C885B3292DC49CD19588622431549453F4BB94F03D75440644F648880191012236C40AF8F8';
wwv_flow_api.g_varchar2_table(481) := 'C35300C77FAB58FA5040F7239E036EC0D406E88092D07601CA15C7D09B80F98BF173A1E3475B47D083EFC0C5F8690BAFB685073AF08E26C58EE926498CA83FE7CBAF3D76584C707A99CCD12192918AF8C40DD3438384A1A16DAEB214D1A7EBF9FEADE650';
wwv_flow_api.g_varchar2_table(482) := 'E03DD34A438AC4908653A47AA31657B339DC9570ED4E4C832E7211A081715B2FA09351F5639E0C47185394D608E5B082C16EBD307A9594DB62C1C28582E77628F7B4E4302EEC4F810BF87A147725D02569B5BAC51B1395B8C600C4F00A5DE0F208116A7B';
wwv_flow_api.g_varchar2_table(483) := 'E5C6B74AF347B5F9BDD2F85EA97FAD54B74BA58F286FE5B3AB46871D7103FF8A858C0517FA65888399A5F96AE0B001C17175C6E10525181A4E408BA09CD6DAFB15A26F0411C30AD4780A6FF3E5CF05C46A8DAF1574F09B3FABE859687CAB227440C71F4A';
wwv_flow_api.g_varchar2_table(484) := '3EC06D2C294B10746BFD2CCBF00DCBCA9187C4721C378C32B81C4607CF510BB764D2D31E6AB86DE15975B02B817607AE5088D7D10DD0541A1A49D6BD749B895823399919541CC314C1B9617A68689B5BB0452C6510584E3B125E7C5A1254D3909A9203BE';
wwv_flow_api.g_varchar2_table(485) := '211FB473199B049271B72712E486058086C1C104B5230BB8B065D83F9BBE0BD8A98918380EADAEF625060B174618388E67052F5CF05FE8208C3656720D43621321944DA12A9ECD58FA47DC95E00AEFF28818EA5F2AAD9F35E14F433C68087F21DAFB75C8';
wwv_flow_api.g_varchar2_table(486) := '5B881B3EF0F957D9EC2A4B3216FA0F7D1FE5A426116898A4BC1FB64DE0785880CC5D0919F10284827F66D29E50CF1B952D1EA77F74F841C4C06362A87F29235068FFAE8B074DF414A08FED3F8DE677831BA0DE90E5D815DC5162A1B1517C9F938F6B26BA';
wwv_flow_api.g_varchar2_table(487) := '059B080DE61E31A2F01068DA62D46E0B1F7AF86A551D4029099440AA0E580041B6C236F78A8D2DE8561457A73DB7442E908CA3D8109C1B22808695C14E4BB072FA527FF11F94A0D09086F684E36F9A5F6B7986CDFB681A12E486798706DE5C605DCC7295';
wwv_flow_api.g_varchar2_table(488) := 'F77829E576C1EED4E4B261304628B1E0D1AF19E1215CF80EE1DB86F8E967AE606305BF09886094E064053331FC01CF419463AADB858C6906C07199DC1ACBBFCD41C6FA5A4188201DB5943341BD1051A01BD2711B3144E37BB5B25D2A6CE4F3EB1CBBCAB1';
wwv_flow_api.g_varchar2_table(489) := 'B84E5EF9CC9B19ABE295ECAB9147C86C1D92064E220ABFEF7F54554F6AB8D850130F6BF9752C2C85320F9B7F95434C86C80011033ADAD2714B3D17C953209FB6113A2092ABED02B7F1AFB359F4050C6E6AE0398BF66FF48FA267A13C46E1118A219C18E1';
wwv_flow_api.g_varchar2_table(490) := 'E70031CAE661C862B2E52D7A70CB848DD5F08E390B1B37ECF0CD2F45B042D9CA975F71800ED34D664E63411D44DF100937D467020D226B4203CB8A9F4A2F8FBA172ACCB755C3C20921ED4FCE7F4FA5B73C3429B0A6A1C08C4AD8141A423426182086F2AB';
wwv_flow_api.g_varchar2_table(491) := '5CFD53912042CDAC3158DE4DA4998AA1C11064E1298962A0D2C2778B180A8171C1BFAE108E1586CACEAE71062C5A14FF56F9D79CA1BD5B61B9D54CFE3557FA90AFED95D105AE7CD2562FA56E47E9DDA9DD5B45BF91D54B117103FA2B74115CFAC8F36FB2';
wwv_flow_api.g_varchar2_table(492) := '6C96255ABCDC6A46FC5B23AD7A27345453400CBE4CA0FA841253983F807A5C036E38ADA11CDFFC51C2924678127259AEF0365FD92A36BE5584838672D6D6AEA4EE2D1C7F780A3A0A4207F1A8D5FC59AD6E158B1BB9DC7A96E358AB4351DD2A28A7750C0D';
wwv_flow_api.g_varchar2_table(493) := '7E751A7CFF640C614787E1155C964994A7C56490690B2F6E304A0E5F48BD8177D84359A6AB7B7C6BA7547B9F2F66599EF11EA0E023428780DC105C1419D54E8A88A1C15233ACE59EEED43EE283E7BEAF88813A42A650E7A05FAB852C1137784C605A4BB4';
wwv_flow_api.g_varchar2_table(494) := 'E7C8523A79C1239B29BE622B9FF2461BC2E603ED2830EC16ACFD11CEEA02EF1EA11CBD4ACA771AC2E1AF30121706BBA33C563DF9DA2FFA591A97E4935AE37B192BE970CA81C6045B7C9745D9085DE3A20B5CED5AEADEA9BD47FDA9D77DFAD7ED3D68286F';
wwv_flow_api.g_varchar2_table(495) := '41D23A68367FD450622BBCCB65D738485A60F7C4367F5494B3AA7C626B4F1CBB62864A829354073A14EA29D43FD4B37AF913EE4DAC407322BF9E2DBE472FC252EB17409B762D77EFD5DE3FFC14F4C853A0AAE7A2F8B7D9F85AA9606ECB66C1008A5D214E';
wwv_flow_api.g_varchar2_table(496) := '9D9C7C54578ECB43B85689A0F6E0AF81F0D64BEEDBF6A0DAE5383F3D2C263DD6697AC81D789B58D2B57A1BECA8EBDB7C65234BFCA7C96E39DEC90DC14F3E13F84F4F238D9CC6B32188AC6184AD93486E30B0838AACA46AB144FC9869AF66B54BD9189678';
wwv_flow_api.g_varchar2_table(497) := '5EB4DCBAD09506DC4B524EA4FC90047274CF6299A1A1C8B8FDEA8B36CD6391CB9071CADA76C1565D70E1C2C080A1E1D58F18C285A26D3375E0E1493B2B786F971EA56AF4580819D060115F8C5636F98C69178D07FCB2E58FF9FA97B2F0A781E000A5ABA7';
wwv_flow_api.g_varchar2_table(498) := '7F7AFF7FBD97FF3DF59F7A2469E937324A66EDFD7A6DB75CFCC0E75E65B955020D99DA4E11A0E11843C3B177A4880F4E4785EA177EC509F301BEDFD3FD03D4E0F1D02EA915DFE50834645759FE4DAEFCA98080009E827311511A3C054FBD97FE130A7816';
wwv_flow_api.g_varchar2_table(499) := 'FEE97A4781A7E057BDB60DC506C419C4B901FDC9B2585C725A0937441A9C1E824C5B38B941DC2F7BA383DD246A58EE306E21969B1BBE988BAFD03BFA235F5AE7881B5EC1BE35C6AA2FC6C30DF3080D02334007D169CFD0E6D8EE611B5E78F3BC606249A1';
wwv_flow_api.g_varchar2_table(500) := 'C12A0109BF9A391B371446FA4C2F3B34F8F9351137E80F86BD63DDBBBAE05C3735821846EC8618B0420985A7B6B1ED0B0AA5D1BB229DA0E0EDC038E66AF2189628F2AF59C3FF7185CDE119CBEA56A1F5B3867212CA4C88125E10313CE3E625FA88D0E1BF';
wwv_flow_api.g_varchar2_table(501) := '6EEF5E25C586FAD70A4A6F28C9415B1DA7ACE246563EAD2168508EA24BFC1151822BB5271E06349CC0CEEBDC1AAEF4601F2722416DFEA849472DFD5A7E7AD40C62202D6474E37FBDDEA3A65D49E221141BCA9F78780A6092C5D84951DBE2D5B31A565C4E';
wwv_flow_api.g_varchar2_table(502) := 'E13FE17AB504D64BFA4E69FA2FD874881EBCE9C17BC8C2692239F07568EE16EB9B7CF96DB6B03AA8C2866D52CCB8D810B94164706868193396181418B07292E1AF38F557E3E51913C3FF5E061690141AE6AEE6D0D8A910C7A7FC50756158EB40A161A8C0';
wwv_flow_api.g_varchar2_table(503) := 'C09637B255BCC9BAB6CD57B7F2B5ADBC41093E86D0C3060CC38E0B7EABA4DA88157EB8ED9846CB1B47CF498A01F63F05753838AEB47F5788A11388EF57D9FC2B288CD7774BC29F3AC282DE83362006CB3EE47FBD279CB1504A6B7CAF96378BFCDB7C6E8D';
wwv_flow_api.g_varchar2_table(504) := '03CF864C2697CD4890D12B33EE17A827E30B00CEA8C519C1FFADAA765643AF0AECC90DDE0CF975AEB891AF6E1BBD09283300B73D0D96033D03372074437F851ED0FA59AD6E1761FC722D0BED093CB45978C3C92735DFA90DDF29501FAA082F7718D5B018';
wwv_flow_api.g_varchar2_table(505) := 'B42DBC6C1E5C839A437287D6103AB8FCA78D62C32EBC4F614FFDE75C71D598C974689F636B5284F26F98C0EB298EF644DB1CAD944CF34718B3DCA9BD3C190B260831E026459F42C31CFEE9F5AAEF8B569F6274F2A6D0303853C04465B6F681AFED14AA5B';
wwv_flow_api.g_varchar2_table(506) := '1817301FD476F28653D330310C8D537AD93F876E43B447CB1B47E182AD2C3CD94E077B3238A936BE150D6F06521887DE0414C6A5C3A67E233FF574B8CE78717A8EFDEF09CAE337B274DC0659C366115D19E7D6396E156FB142A79E039C29A36305356CF8';
wwv_flow_api.g_varchar2_table(507) := '52824F163FAB860AEDD43B1C0FB3FFD36735233CA1E1BC8E5E57B837C1655739C46D25103494DBFB75E54CE8DEA9880FCC32834DE6D47FEA3D6AEAA588F00E415E6983870E059721764FA0483DAC8D99DDF04007BF6A44D5533B396A33B8CDE36184B3E4';
wwv_flow_api.g_varchar2_table(508) := '303A0C4F693A4B0ECEC94CA71914DC20C460D103EE598083E49B2C7AFB0F971C22D437C4CA0DB589DC2183561A4C5706F071620C7D83F4B1F0F2EFC963A8F299561AE6A8C4605C6AC0C7DEAD567A03C314BCB9C5CAE5E240A1C13D5499652B1BB91ADE1F';
wwv_flow_api.g_varchar2_table(509) := '41348FB0A3D242846167E8F1F28582DBCFD16DE318AABA50222BA3C6AC99B64ECA4E496348F34433079CD62A9FF3191B3414DEE62A9BA5D6F72AB9C68574E52E4942BA22D0802F736B58C00FD0001D0A5C6C68FE2841823C8EAF5AE079416F87804168B6';
wwv_flow_api.g_varchar2_table(510) := '18BE2791B03304DC7351AF6C624183611A9D2D7F40AFC0B2F01B040DBD7B040D3D8FCBBBE7278474DAB5241E341B5FCA08F5F8D739F0CCC0DBB43926D3DAAFA8A73668080610431D0DFB0B6694FAC10D0D243CEDA18657727B7343C9B14533003A38BB15';
wwv_flow_api.g_varchar2_table(511) := '78DDF62EBA18C88397C376A1FA3E078315D39D8866000DD504A181356E48EF8BBD1BD98E087DB3CE4DDB1373E8DF607EAA5E2A058ECBD95FFD4C02F6D2298706E2C1505AE72A1FF2B5AD426D1B6A0CB52DA3EF60881F77CDED53F6D5945F46E182DF4229';
wwv_flow_api.g_varchar2_table(512) := 'DB66EA918B21468E4248011A10E359218009927C5C35ACA333AC3137B191AF6D97DB3FABCA69BB87AE719F7A5655BC3FE88F3D1942BC53A1F5AB5EDB29A12BE3FCAB013420144357CFDA718402829A1F13A8C151E0DCFC986078FD54EA79BDB881671F00';
wwv_flow_api.g_varchar2_table(513) := '1AB28537D9CA27F422345490BD7B0D4143DF7EB27E36A1E13F5DEBC8D271ABF5AD52FD5C2C80B1B4E1B34514A970ACC8ECE8B16D8EF438283D5800E1248900DB3BEDE81068A545C961F0F0CB850E438B3407E850B40B1DA0D8F0D5A8378065247AE7EEA1';
wwv_flow_api.g_varchar2_table(514) := 'F7352CAF271700B5CFF9D22B8E67A73A1145AE88AC46546C98121A2C7410DFF0DD536940089694A13FC7264E4B0A0DFD21CAD38E84023AD7DB70814E4FB8033C18385850895B12952DECEDB863183E5A3BA8203C57537A99409BC4E0F07E1E5E0FE1CF0A';
wwv_flow_api.g_varchar2_table(515) := '25BFB1C940AC30C92E06EF94201E5638D85900CB2C51CA47891FEC1976CAED5F28930986A0E1A5EF2A4EF6CDF6C4001A3E14001AD60C68287FCA01349C84D7109CF900C1A92D26B8B81F97CB759F88EAF1A300E21C7E41FEB5016EB9B56CF16D0E4143E3';
wwv_flow_api.g_varchar2_table(516) := '4B45F4838601BC75F53B846EADF6F74A751343C33AD9226658436AA421E2329F389EC887CA5184180B0DE5216818E90D6554DACA016D2547F83A18948F71017B4E636ED8C32DC85D6C03B55D2CBFC9928D15139F88A6544456A2E850D4238586B63531B1';
wwv_flow_api.g_varchar2_table(517) := 'C2E97F5AC6FBFDD9D995F81F858685F823FE69E7592E6FE9221963DFBC6B9B36EFB476583068B0BE9B7DC335DCB99E29BFCFD67069A1BA35706D724C579A1E0CA6E091777B3BFA3B40B77D3A1143D505326FE62CCC862C2D4CB8C7015B2390BEB5F591DC';
wwv_flow_api.g_varchar2_table(518) := '40E9A4F9A382050DA082CCAE723C7621ACED1685DF860A12F1C110BFF6FBFFC3237F37506968EFD7EBBBD8E2E97536670D50A07475D1D04E2B2E1A983CC7074EFF63D2FC45D8A8070BFBE3C77D4F2767742FEBF2491D2A04E0D09001F7EEB73CF1E214FE';
wwv_flow_api.g_varchar2_table(519) := '3614326FD9EBE227A2EF7E22FEEB756F55430BB95928BECBE5D738E349603288E1D4E32A861283D81478461037D4D5F01696B68959FCA2B22A5887249C431687B670081D6CB39AAE7D167FBC1669BA77700F971C30BB7B59503BEC23F70AD69ECC06BE48';
wwv_flow_api.g_varchar2_table(520) := 'A87CC8F259AFB390ED3C39193D04F7998E5C11397EFD049369331628B082E5CD600C58B22D86557F368C12C3F35224D0E583863E599F5D270ED305D691C85DD0C0330B0B0D2EE5A3650B5DFE98AB6E82EC1128618BB71C9C865D9BEA9E9BAC3DB6570F69';
wwv_flow_api.g_varchar2_table(521) := '176CB8E0D589C0B860AD84F09E99AC84EE41F82E62B09B29B97C112ACA89A3B78DB278FD6B99D83370041A5EC34245FBE8840734609F80DEA3AE114DC3AF1AA8F03E15083470E68E66F5BCA19D557C69600A02F0BECA0F9AFECD4F2F5D518F38824146F7';
wwv_flow_api.g_varchar2_table(522) := '02A0413AAA655771B5876373EB181A369DD0F00F43C3B31734DCA90A42B75F600D59024B6F6BF415BE1BCADF036838332520081A9C8613A18C2C1DF4606F7BD9D0C18B18BC8CA182708347B762400F66ABC2C60DDFECDC60A143C1355881A72AF2A535CE';
wwv_flow_api.g_varchar2_table(523) := 'D08139B9614A7564541BADA28706526F60C0169ADC165863D8124F5AB2CAB71A2E2E2E0B312C69A581D429F1660AF704A6ABB4C067161F1A6C53125CE57DDE00852D33B00F74CD410C432D099715F4F762F3BB6D1DA56733E2E728D582BDAEE07461B29D';
wwv_flow_api.g_varchar2_table(524) := '4023D22B8C354BB6DF40E9A4B25530A001DB032068282368D82B890E68E83BCB0C4F4FFF81BF93762DCBC76D630382131AF2AF59E5B4AE9F57BD13FFC5D0A76604BAFABF1C11E1527BF72AD2707EC3403F008286ABBAF8B74A6A0364E4B5F08EAF6C6267';
wwv_flow_api.g_varchar2_table(525) := '27040D6782DE5110A2619F86BE831B001A60EA52396D2368A86D174BEFF3C6FEB01563F198F0AB0C7DA273004474C39CE9A8FB8F86068089A1F5192486E92110378C9CB0F0DC83D5FE5572EFB018742B3C0492833D997B4699017B4EC36D2C716079C67B';
wwv_flow_api.g_varchar2_table(526) := 'B9F6E241431B7F6CDA4A0EC4D649641043B0EA5EEDA5D75DB6E4B994D0609E46EABB95FC502D61064398A98206B2D8BA048BAD1125E0B9CACD3C8A4199819838B93C18FCED1D3D7C179CDA05BFD2824F1BA232392BF8342002DA21189AC4C1240224ECD2';
wwv_flow_api.g_varchar2_table(527) := '07DE8006CE010DD09E3827C37E66AE22D1EF633BC26EF75E552F2590E02168D8C1D080D72D1268C8ADB3CA096444AF32C0703DDF16FEB9BF1B3C22E4806BEFE8D96242BC30A2D6BB69087F2AE829184003694F7CC18B3F4EDBFAB58C10CDE850D89F0B44';
wwv_flow_api.g_varchar2_table(528) := '6FBD6EB7635835D8A1013D9BB0F80AA587AF45EDB2AE5D8015848EE8019A44E876DD3DC731C264C2931E8E03A0C3D1487470D34365243AB8B50EC68A163F95C3F7A156C5DE1037EC80DB74638FAF6DE641E2C07A8C6246BB4D3B25D0D0C6FED02D9B8841';
wwv_flow_api.g_varchar2_table(529) := 'C08F94BF54FBFFBA564AE95368588A3FCFFDFA766578746219A061D09558CD94DE642B1F11289822862D6B59656160FB68B76118DE4EE9EFBE30B05EF0DC10610D440C37231C2E0B81DD1B4355148E470E313A2F2549C2E0DFE688D4DED885FD3A57F988';
wwv_flow_api.g_varchar2_table(530) := 'CEA4E857C00E016637BDDFC7E9AA8F13D57FD09B80DD0717A274D4827465DFD18CF764E6D6A0D28032E25079605697FE8E1CDFB0855FEE6FFCBFBDB3076D635BE2B80A172A52A8B8858A144F708B08525CC12D224893851411A488C08505298C70611617';
wwv_flow_api.g_varchar2_table(531) := '6671611637667161440A2352049122A01401B930C885416E0C7261900B835C049422858A5BA848A1C285DFF9DADD73CE9EB31FD2CAB19D19E6E5398EE3F86AED3DBF9DF9CF7FD479AE49E1C33880D0FC43230D5B8C11345C38AD7D0A0D59B73D51ACE2E9';
wwv_flow_api.g_varchar2_table(532) := '09ECD3D0FDD2C0ABAAAEFAE39FA3E964C2B8613A6566D23F881C15A1DBB60C0DB44381B87970620F4E685B87B0022DFF84CC822A2B10CA0D5E1A6E50A2832777E8CE840EC1CD99AD280749C979DAA623151E37B005F745AC917C57E2B9C148CFBC21F562';
wwv_flow_api.g_varchar2_table(533) := '432A958666961143C793402E576FFF1B93A9FE5BED3E2A8086C7470CF8D7C9C47A572DF03A06D501FF282B0DB4C650FD275F7F5BC2C4F0AEE82B1FDF8B3506DADAA49D4ECD884463537275F4048F86506010EC1634BB21785C486AC71473A3A3AEAE104C';
wwv_flow_api.g_varchar2_table(534) := 'F754C027C4D73A3A63880AD28586E7181AB0A661CFEC7D231ED278E50139AB7EE15FDD32C36078DEEB1D611B69765CBDC236C60562EE842578F90CAE349C6AEA04C9CFFE71AC8C71D8A79493441F7FA6858CF1A939B9729A7B55AA456557014303AEF734';
wwv_flow_api.g_varchar2_table(535) := '77B18D74FFA43DBCC41D0A846BD44C7A4AAF05A2B7EF83E159A7F3D9D14143F5557170EA0C4FA900D3A2551FB93D74146A26A1AA3D44AB2643B841E9481DC20D1F34DCE0951C2407C96D0537D8529F6295CE6496E94805B6775BC686D36C51C562A0A192';
wwv_flow_api.g_varchar2_table(536) := 'C624452AD040DFE8D0DF2E657BCBB5C97F7E8DE1113B460334B0988852B5E978527F572D67F11C66F14E5658DD2534847D2ADC95C8D7DF94A81303767BF4CA0C2E3A3062080C550AAC4053515D605B28953BA59475851056D0E242F205D0A14E88BEE321';
wwv_flow_api.g_varchar2_table(537) := '99BEABF39AC4DE971A51CD099506DC9E788FEEC275FC8C4B0BE3FF8DC871E56DAB1A0E2FFBFDD34EF76BB3F5C176366BF5E5B2F1B2449C85C861853EDB934CF7B31956BAE79EFEE31DF616C9A8B3FC22615EBA19F901525E244E0D7C58081A1ADB153CC3';
wwv_flow_api.g_varchar2_table(538) := '92C5CD9DC253ECAF85AE82B95A69ECD4DB1FEDDE516B78DE45A0868B0D841BF085F80F0FB08CAEFA8313846EB6B355AB1368283D23D0F084C91A1005F64F30348C4ECC1169008D4E49C94735D01132B4A20388307AE04B0EBE46929BB6F818BA07EB83C2';
wwv_flow_api.g_varchar2_table(539) := 'D4A125D939ECA904922237107430ECF592D4A72072C8122F71B010373CCF097BADEE041A1271C3FC42485C665862960C8818DAEFEBB73F0831FC9AFA05861BD57C3F40C363B673984CCC17656F91D51F010D4BD81F1A13C372D96B4C58EF452706A279A4';
wwv_flow_api.g_varchar2_table(540) := '6506C55025133C060A0CE2D26A891814C2056937C41CACD08DB1F049659BA81D71248EC5BEC7118206FA48CA4143BEF6AA64AD541A5BD846BA7FC20AE3139463440CA431713D185EF4FAC79DCE97666BDFB237AAF5B725E3057DC625EB27F096ED4CE753';
wwv_flow_api.g_varchar2_table(541) := '1D1D8A5A3540E4D3F98598336341C8C1BFE88CF1B54DD1875D39CE864194253E3460B78C15F40D89FD9DBADF9A83D30E02B5D1F721BE10FF8DBD05D9F8421CB5DA1F2C866E2F8A14DD08341045EAFFF2FD637B7886E596A3631B7103BA047E9F2838D011';
wwv_flow_api.g_varchar2_table(542) := '450F03A50642577B90B941CA907A833B5871A0B07368059CA0446EC0E8106855905FD7D940B54F0FAB06AD3710F7A712E68667F9BBF796BE3368687AD313644355F74DE5167D47F1DE0B37B2951340C39F334E31AD2F570B4B9CD77A563140C12CA1967E';
wwv_flow_api.g_varchar2_table(543) := '1B34CC0619C1F7575EE46B6F8ADC9404338A76D50C0173E8C0D2A9F0F90885DA51A95D886A43F0F3EBA9691B153D883A2D2D7075058B0E2B0EBE915F8FEBE811BF8345FB38D01993CF658B4FB18131DE7AB08CA1A17D60F7C933EE1871C38F01C205744A';
wwv_flow_api.g_varchar2_table(544) := '6162B8ECE132C361133DE0A247616BAD5A7B8B8F2B3CEC47B72C62B7A84C6BB736BD4AD62C48E1D4BF7253FAED953DFDBD79A9C92B6BFABD61D21916045B4F32857C9E5C85627DD9B0376AB843F1C9E91DB606675D0470A36B741586EC5A5CF506679DEE';
wwv_flow_api.g_varchar2_table(545) := 'D746EB8365AFD7EA6FB14F43E9EF7C816B4FE4F3D9DE21AE6760F14470CAC36D18A98645F50CC1A3C3A1507BD0151E14A6D4E28F03D53A7483F4F041A78E149DA074CBAE5C2F07476C55787D0A6BAD44924923B165E472D1F827CB6E9B4B59691453070D';
wwv_flow_api.g_varchar2_table(546) := 'F38B2267EB50E8A0A1E11103198B108881CC4AA03F6DBDAB4EFF1BFD397E0C000DB1C0C17C5725AB28B26C16392BE042E91E541A66E1862561491DAE31FC2F878801FB311007A73AE7C7C01143D96F4C78C410E6BE60681646881E4D41E1429C4E8442DE';
wwv_flow_api.g_varchar2_table(547) := 'A8C105E92EACB358565A290BF77A020DE83038A4E7018686F67E3D435BE92234A0E3CAD940FF9956EF6B7370D2418FB3F8B8228988019D5EBDE376879C55CE76DD5AADD4DE94CB3C3464396848DA3B88C202F1C4F5D20964C81FA9F23A615E254D1D4FC8';
wwv_flow_api.g_varchar2_table(548) := 'D090A7D0F0027D3FA3EFD22AEE501CE06243FFA43338EFE17AC315C2058C6E88E7F076F24F4E63D7B429BA5168C86368C0632C6428A6F7CDC2CD9153D35354840C7468E9E1382086909668F8F420161EB46E92941BEA11D0A01DC854DB472A5C1C980194';
wwv_flow_api.g_varchar2_table(549) := 'A1E086757FA995E5AEB942378AFABBA2F134578C576CB89FD0404724F07B96588DA1F584804296CD4A74566AB73F86786A773AFDC3CF498006511A79736BAFD50B1C259454C586D2D2038306BEDE60E4B3F5579C13C3B2302EC1BC9B445CE0440CCA714A';
wwv_flow_api.g_varchar2_table(550) := '713E42942F848D4524C385B8CE0AA25881EB2B2BCA092A4704CEA9109F0A47F46CC0D0D0DAADF2D05040D0F0373DAE0C74083115DE510BD7C62F7A341131A0830A9D61B8CC80CEAACD9AB952A9BE2E95FFA5D090F5A0A189A0E15A09040E490D13C8676A';
wwv_flow_api.g_varchar2_table(551) := '1A073C97B7F72E6D040D88777968283ECBA3E31F4100023267B386E8ADF3A9D13B6C316EA0D7E2BC8B78AE77D86C1DD80D846EEF31BA19FF08D04025AEDD2F267E6DCFAC894698E9CF7A9C86FB4CF87E97BAFE853CB4A92839F0945CE7540E11DC20EB22';
wwv_flow_api.g_varchar2_table(552) := '83EA48C13B92FD14377644692445870D83B37E2A7B0548DF4B7EB56CBE2E959EC8A64FA5CC43AA34D858BE906525872C2189255681E8AD9BB73F477042023428C40D141D9C75B3E8BA97F0358607596958129A14E55CA6F6B280D750D10203694CF8A395';
wwv_flow_api.g_varchar2_table(553) := 'AEDB6340F668A8E7237602E394DC64442B5CBE10B91B224E0F22382A29EB19232B0A923582E77F806FFAA4B14DCE83537374EE34B7AB6CDE5284067A5CA1A3A8FDD1E97E6D224A40DC807001FD4A89A1F3D969EE5BCE16EE4DD4978DEAAB52E99F42E1A9';
wwv_flow_api.g_varchar2_table(554) := 'EB45487E69EE206870C42281C3527EF24EA10C70FBFD7EA70E1ABEDBB73F1AB5371C34FC952FFE9D2BFF4BB4902B062B367CB03B5F5C6E38ED62743BE9209EEB7E69B4F08560E8A680062C2E31F16B48C59824D5AA4C1F206C19204E4486F0CB0FD64055';
wwv_flow_api.g_varchar2_table(555) := '7E18883D8B7E44C322742693EB53B43FA8F75D85D71B246E70A40557EB65CBF58BB438AF58FBBD51799E2F3D891637DC4F68B096045706DBFD6DE349AEB76DDD52EDFCCDED140E4A8006DD286673C72E6658A3CEDF84E9D5F9B3D907070DB4E4507D9EAF';
wwv_flow_api.g_varchar2_table(556) := 'BF2BD7574A1C3494FC0554C19595ACC6C04183A460D855091EF7A3048F223174F4A5851E62059D64E18B6E1F34C385C81D0D1A562089EFFE041A4E6C32BC80ED011A9B95203418FF166BAFCB5885879E71F7D1332EE106745C1DB5D1A1D5C3C4D0C04FB7';
wwv_flow_api.g_varchar2_table(557) := 'BB757BA36AA207DCB7E5CA0BB67822CF6495141AAAE8B09CC8AD04BE5C1F4D06091ED9BF3FD024D0F0BAC84143AEF8BF5CE9395E02527F67D0624373CF4200D7F9D2C497E0A88D70A1F70D1303919598082C4C826E1234640834B43FD6D1EB43A0C1518A';
wwv_flow_api.g_varchar2_table(558) := '34F5F420CEBECA150871D1867AE64263F310365E21961CC451CC506EA0EB5D5C7183971E376C29B881CA1A5C876966DE6062D327C37C5BAAFCED37294A0F4AD360333503F37C649A8627B9C141E3F6663295FC186EA6000D10E2F701F9E668EF378A4F72';
wwv_flow_api.g_varchar2_table(559) := '05266EC816C581CC87A869A8FC2F577F8359A1B622CE557A3A063A90BDC62DBE636506832F33F8060C04179A4AB326ADEF42952DF493448EDABA42CD4D4D1B229C1522F730052D1439C303D2CFA6CA446B7CD970D60D1F1AFE72A1E19F4215B77BF0336E';
wwv_flow_api.g_varchar2_table(560) := '73C76CA1675CC40D5F1A081DD0AFE8EDF681DDDC33D1D3ADB556C16586D765C419C5BF0568C8B8D0A06E376020B0B94C4809F31CD23F7E53867D3DCDEA2B011A0A4FB3A56705E3650901192B366CD711C0616EF88C2E04BE16E80DF45BF4CE06AEF75410';
wwv_flow_api.g_varchar2_table(561) := '5E545F16CBE8E1D885063C7249A0A1F5A176FBBD41D0CD1154A2975173A19CA5846C51252828B9194EB564B2AE2E3CC8E85053971C0EF4BAC80F9C6524070D2D111A9AFA6283276EA05D098A0EACDEB05AAEBD2CF04BB41F94A6218B7FFB8479456362F8';
wwv_flow_api.g_varchar2_table(562) := 'BB38FAD89437D64E69BD01A001C21DA0105A15881B3EB7CB7FE504FF8634E490BF051ACAB92C592D412C19F0C4546056628DF372F107250C5EC7D0148921E8EDA8B56912EB0A427521E6284498BF42A00711648563755141EB9E846EF7D4EA80CE325C60';
wwv_flow_api.g_varchar2_table(563) := '68B0DF53FD1D3E632468403460AD559DAD7A731771033AAEECCE478C0BED0F167A4F63AB869F6E578CDABB327A202E3F2FA087E3C25FB9FC13020D64D8AFB9AD828699E505693DD9FFB887D9ACBE2CF8D090CBA1539F6CA028565F97EAEFCAD6FB8AB351';
wwv_flow_api.g_varchar2_table(564) := '43DC80EB0DE8127CB429BA216240D702FD111534545E08D040DB13F842EC551934105C9B5CFBD31CE103A22A9F0CADBBA5547E086D5B98C2926ED9825A5AB1AD19C55472C37E143428B8014B1C5C45A49BEFD91E6D6BB95479962B853A37DC5B4D43239B';
wwv_flow_api.g_varchar2_table(565) := '653A86A56CF37969F4AD238CE57B6FFF02212444680C0F3B95BF0B0571537639F390462ED9C404F171AA2FE3DE0486068118B896844F0C864F0CDB5C8D41B26CDAE7164D299C9AE466449C15D5110D88AF826A61F04D5B5A708B0A5C533960CCAC3450C2';
wwv_flow_api.g_varchar2_table(566) := 'D566C91F894083B552E2A021E743037AC67D839EB72A880C3037EC98AD3D0B1D51AD3DB3858861BBEE6C54ADD50A7AF1F159F5B2547E5628FC2FC7EC017868F8E1F0B8100B08E644841F0D96F79A1214D09075A1219743AF64A6F03F0C0D08C858B1610D';
wwv_flow_api.g_varchar2_table(567) := '37291A3B2666B87D7C2D9A7B6673A78EE96DAD62E20B51C2D0F02C8FE98D947CE8B5C01762B78A5F902BDBAFF1487D22811E1C75FFE2C276BF792C85FD465038196C5B484AC9AF661C6EE8C4D445F2D0B0A7800675B1615318BFF47660E262C31ABAA514';
wwv_flow_api.g_varchar2_table(568) := 'ED55C37C5D62F6D26406ED01691A3CCFC7D68BD2F8ACC7404124843FCA8F01A061D6F203E286CB41F545990883B3DE83BBC0014B9962ECB6C55D97198832A39CCFD6DFD0ED124571BB4440C7B0E1291F83350671E91419A76C63BFA68ABC97F2405C4AE9';
wwv_flow_api.g_varchar2_table(569) := '11C3C79ADF8BF504E1742D75B0C6A054381EBAF92DAA07212E71187929ED32E03D95C527C5C9B9333967E7C1F4C29C5C3B5557B4EF551A8AE8AC7A5EC05AC8D76E437DBDD6D8C48FB9341143D8E8D176AD8A9002AB19681F9D0A1A3C4F21725835B6F059';
wwv_flow_api.g_varchar2_table(570) := '95ACB4F0B00B06B3E6B85179C9DA13B92572DEE73274FCD578418B0D0606B8B52AE6862D527240D762AB8E7E6B930B517F57469C47E72DD15F24D7C2AF3438DB95DB9F8D5B32264A6B3FB721B3A0DC44AB5C7B386729B630B8E68530BA29F84E4ADFCFBC';
wwv_flow_api.g_varchar2_table(571) := 'BB836238D34707D1008A6F521C049C1BF6B80E054951D95009D41B843DDAFE04261BC2A4626ADCAAA8FE9B2FCE6DF1642484865ACC9D554BBE8393BD94B1B2199B4C5AD28D12F652B6B55C1B5F0FE1E00368980B1AF0AF3FC76C45C592D0A7F0359259BC';
wwv_flow_api.g_varchar2_table(572) := '2EB6701FA181A8199EE5A9ED635D5233B8C460C9B312A28E612B400CBB9EE051D63C2A89A1FBD1F5C4E545E05FFCF4850B921D93D083A8BBD31075052E08ABA22DA9A8A05BCEE4438364BA7CE142C31585060B43C35B15343C2B18FF167187E26DD9A267';
wwv_flow_api.g_varchar2_table(573) := 'D5460D1F579BF857460CEF71139D95199E53F11D3AED046870B6F059953E2E3C3E6EF8A987065A6C7853C6DDA25552F8A1D7628B5C8B755CEF31978D3AE94D5015A4021AB61834DC7AD070ADF79060132E7A74B808A203577B504E6CAA7CA25C6B87BA1A';
wwv_flow_api.g_varchar2_table(574) := '1DBCAA83B4A8824183288A74A1A12D42436B766828FBD0F0BE5C7B55A06314F7111AF832C3922B6820DE4DF6936C77DDBCFD3EFAC3BD9B001AD2943C34B7ED7C265310873069158EE9259F64EFA3A6E14906AB1956C8D0842C65101D9C48C3921283A318';
wwv_flow_api.g_varchar2_table(575) := 'B0E4AC1EA58D53023104AB0B9C85BECE6E41EBDB18215618E8D74286814294C7E218838283DFA6D070694DAE1A95D70A68C067D53F7EB101F101A204743ED1C4A7D47BAC7F44271996EBFF5B449051C225F12C2B893FC93068D874CFAAC7A76A4C35A73F';
wwv_flow_api.g_varchar2_table(576) := '1BC60B011A3C7D09F6937E898B0DB84981B8015F8B8A702D560CC476E8032AFF6AA1C1DE34707BC27DB5A7D7041AD42E555AFF4AB513D7B96CF2AD747D90ACA27CAD83604ACD692485924360A422B89C825FA2CD73830C0D9580B2C1E7064111E971C32A';
wwv_flow_api.g_varchar2_table(577) := 'E1867725E369F68EA121CE766C860BD9ACBD44C6255CCF47DC9EC8E7FBFB8E375A4963022396000DF37343F773AB886E5241BBA77B2C6B309EE6CCB7F887D983066CE2F45EE1F968AB8801D718B62B61C4F021400C0701A7A6900D116A5CF0774B464F4B';
wwv_flow_api.g_varchar2_table(578) := '72ACA0D80CE95714140ECD9373ADD3A2070DE80CB8C52AFA86E13DE0FAD040CEAAE7850A2936A0B30AF1013A99D0F984F37D0517C31131D083EAA57F50E511343CC9E6B2CCA72116342C7494F1C14043430D0D797C2DD085C0C5869704E0083798EFF96B';
wwv_flow_api.g_varchar2_table(579) := '61E07ACFEB72955C08AC82FC9F021AACF572101ABCD41B5C0AF420587245CF5C040A0FB2D164001D747E509234D2AF375495DCA0ED5048D0E0171B9822D2D6171BAC55032FC0FC1DD010490C4E266BB1014B971896B28DA7F9C1D7362586299419001AD2';
wwv_flow_api.g_varchar2_table(580) := 'A1056F20F3663A3CEB57FE29916DDA59CF709A6F55DC2F6E58C2CBAFAD15DC6BACAF147D68708DA2C54D542E34F0C4B0A32406614D65C723069DB7A3870B3495C28518D310A2B382505A88D8132D761FA22D9959E5D9C6E2F94B874243F9DF82347259A4';
wwv_flow_api.g_varchar2_table(581) := '0FB8CFB123213EABDE943137E09E3AC9650311037BB47D49CA0CCFB5D080880DA0211E34388677217C6860AEDE6552F5A9D22685CB70EC5ABC23F4F68AD0DBF342F91982865C101AD0E3720834E8D1C10EB62D42A62D546E514AAD03670FC5692405236A';
wwv_flow_api.g_varchar2_table(582) := '911B04F727011AB87A830C0D8C1B9A7BE11D0ACF2392899FF8F14B171A4AF6AA517B592C2DDD4768406F38D9AC5B66C000D178511A9F74588181AF2CDCDC429F02A061C6EA82000DE49B69F2736CBEAD16B3B8E450CE6274B8BF9314B94CFD55D1226586';
wwv_flow_api.g_varchar2_table(583) := 'BAE715FDBEAC25862D9F181A5A6210658F1FAAB27CE163D0DB315063D039396A8C1602DA46AEB410C005B7AE60318B05420C13655D41DED4C0CE00C20A64EECE8386CB46E9795E3077CA1368C0B206D6A1C06715A98D6307AD77F8D0426FD3C6046DA293';
wwv_flow_api.g_varchar2_table(584) := '838A4103FA244CB14FA161CD58787BE27140C30F1E1AB2023490AA0F0638762DCAEEB5C0E8862FC4EB52F565B1829B44793A3AC1A02187002E43A101B1755C68B88E5AE1118E0E41AD83EBF4A098CF641340D640830E2237D4F83E85A88BD41B3628A0A1';
wwv_flow_api.g_varchar2_table(585) := 'D2541A4B8BC506EAEF62AD965C6359C37C53A2860D77030D91BD095EC760BB6E4ED652B6F3BE3EBD1AB0BBBC6BDFE42F97F805E71F40C39C211A813576ECE2936C417CACBF6FD050CE67DCDE44B18E7EAA6981E1BD2C7EB437543A0657F9D8D475250E64';
wwv_flow_api.g_varchar2_table(586) := '1103A760E0472BC33753B3B108352BF8039396961504BD82625164485161AA58E944FD946C76065CE3FBFE2D36786E14FF26D0B02441035E90ED151BD059857BEA6F7056DFE0B71931FC5B6065067450E5B1A64182067439BCE989DF800E0F0A1ACAFF04';
wwv_flow_api.g_varchar2_table(587) := 'A1015F0B2A3161DC205C0B820BDEB5A0F4F6B7000D590F1A96D38386AB68770755C3C2522ECAE27773FBBE0E87AAD98A2FBC77A464FA2434295A3E375462161BD4D0B0C63A9E4C0EF9AE5CCE65EF181AA2D50CB431F10417189888E1BFB15AFA0E01D030';
wwv_flow_api.g_varchar2_table(588) := '072804DEE0A2FFAD537D5E2A8A1287FB050D4F33D6B2DB9B5823D0407FBC15DB25DC1A835466E03D1FA50554EA29092A78E4ACA015BE0B26EFE1D80F315A90BC98221A10C97A1092EE5D18C75742C3FF720C1AB219191ADC62033AABA8168F1D51E8B72E';
wwv_flow_api.g_varchar2_table(589) := '317865063534AC96173872F9E74003ED16FD835526A4DEA0BF161E34FC2542C3BB820C0D577A68B8D62DE4F4A161AADB411A820ECAE5587CB7E2047183E5091D7425879E6B382D0E53F88DC55674B1416B10A9808635A2855C29A37B4EF9AF6CF1FE4183';
wwv_flow_api.g_varchar2_table(590) := '437EDB7E519A1CB56FBD9A82D489207D8A291642420034A4DCB9C0BF8C7F8CEACBD582A86C60BFCD469B412D5C05F92C47A1C1646506B28F6AD5776570F8898990C6C4AE62C3B5BCA932B03C42EE44882BAA0925D403A5053135BE8D82BFC299ED771F82';
wwv_flow_api.g_varchar2_table(591) := '3D08B9A2E008A9DFF9744BD1010FDD356EBFDBE30BA7F014571AC8A2CB0C7F56F9C5867F586DDCA307724AD1475B5A6670A1E1AF6C8EF4D149551C43037A3EC34684332C7EFCC3B40E081A4A7FBB7D22BC713443DB139E2E95141BB0B881D61BFCF488E1';
wwv_flow_api.g_varchar2_table(592) := '79DEBB16BEA0218B774FA0408471FBA3C988E13BA2460410B6F2954FB0F8FBD289543988DC60C98ED4921DF5B142E830D0B52A647D034EA149B1C7E5AE7EF692DE1F5CAD34B68694B981B843AE61E19491CF96636CCA2EC7337792D0C1C30593E002E506';
wwv_flow_api.g_varchar2_table(593) := '7389B0C21236633033597B296BBBDE0C963B2E515DCA75B7D0D584B94A8086DF5481F09CA7DB07CDF25F790A0105820BE8EDFC3D2836549EE7A80AD225063D3428CB0C3BBC8F5380180E024BA7985F535D4F0CB4BA50574816028E4CC49449595AB0257F';
wwv_flow_api.g_varchar2_table(594) := '8549585D01EBD8A7BA0C8186CB0034E4B5D0801F706961FC1F22E07FC19211C3736CE8C4D7C33134E4001A66848662383470D7C2BB109418E8D0845B66D040C32B570819131AAE66858688C10A7736383058210A24ADA1CA068AEB53D464DF270A0D074A';
wwv_flow_api.g_varchar2_table(595) := '6503E306B9D8B05D490C0D4F538686B032C3925C6CB0B339FA86937557523DC95AF9DCF05BE7F6E758260600088086BBAC347862C9E159BFFEDA284A3B3097B0EF53FEF77183070D1E31089BAF551313BE9A81337F0C2186AE600E2D4B1D393347AE0D11';
wwv_flow_api.g_varchar2_table(596) := '7459603D0853EFB2208915ACC89949A113A1AE1E4740C32D070DA3733BFF57CE83869C501527D0E016C669BD81E53F7E319C6AF5256820EB98B3447F57A2D070BFB8E1FE41C3E4BB83CE7B171A32081A72141AB86BC18A0D6402D34FF75A78D05010A021';
wwv_flow_api.g_varchar2_table(597) := '43A1A1F2AA18071A12104308342418AC502DE0E6D081B42A2CC13E92EF5304E629DA52B141B7C28ADE07B62B810E85021AECD574A0213E316068C8663D62F06C1F4D4A094CFC983533D9C66B637AD1E79CA0A7A05E0068F8AD8A072A93FC35696ED925AA';
wwv_flow_api.g_varchar2_table(598) := '8E74472AF0DB314C9F160C0D65060DCC98C10819B36C28EDA265A368060DD288044F0CD2F2C9FEA17E89D449BC3644B8BF82EA76CC5514ECB8F77777EB3483866B060DC353F4A092D54203EDA6FFED9E55FFB0F48921121A967D68B877E8707FF2071E6C';
wwv_flow_api.g_varchar2_table(599) := '29E23E51D6AB3428A08172C3B3BC77212462C0E292FFE5D4D0F0B238FDCE340D4A6898266A4C88D0A04587686EF0240EB6C247D213484AB6D39C2EB2C78D62BADC807E9C6B016E980F1AF01E0A3C4361FC2F971634E8D40CB831B1E4F6265C68A0BF5273';
wwv_flow_api.g_varchar2_table(600) := '68AA60A8E772DD5DE7F6BF092CA80468F8DDB8E07EFB4D6F3868BDB91D9CF66A2FCB85E4FE0D0B810666D2E04383ED4343C0FF91DC1A024313557E6282B764909C18540506557581EF44B8368E23CD4044A2510811173C6D63921A037F667BD0704DA0E1';
wwv_flow_api.g_varchar2_table(601) := 'C4CA3DE1A0810D506429076068F0B8813DE6E669255C8006BE3DF1448086DABB629AD070FD68A1617C65A3179041C31281067421388023DCE0D61B9E613509C10592EC42B80E0DAE0A928706E345616E68B0C3A1214E9F426703350EE5062A8D54EB223F';
wwv_flow_api.g_varchar2_table(602) := '0B160E72BDC11BA608BA4A1368703B14151F1A361134B0C70F6B5D8006EB7DA9822EC14CD0109F183C68606A0657BE40150C36794FE3A5313AE9C17905D070EFE3D7B4B5E350954331C960C56F83065666A8288841D43F0688012BAD7A9F8305066EA794';
wwv_flow_api.g_varchar2_table(603) := '7A3FB5A934701C9F89A96B43688B0A415650CEC2451043101AD0ED580D0D790E1AFE97F77BEA5CAA2B0D141A322E34BC2DDE5E37145FC66CE8F058CB0F081A2EEDC25F4A6860B20652F8C9292E844F0CDCB0E55F59191AFE2D782F3B82865B0C0D960217';
wwv_flow_api.g_varchar2_table(604) := '427C21A3A021CE248567673ED639482A9656F8A3981237F479EBA7CFC212ED0037A8A06147800651D6605068206E0D068386D5F26CD09088183C3503ED47900243D624EFC1C4F024D7DDB59933F4D4DD5879C3250440C39DEA197C8FC85B9DAC6674DE37';
wwv_flow_api.g_varchar2_table(605) := 'DF568AF116592D881BC2A0812B3304A1C16B4CB4545206AF25C13B3CF2FD08B576815F0C21B7216CB5C5422C5C90C626C3331934606B480C0D8E1A1A7C2D645EE206EFC4226FE78432433E1B8486EA9B02838654B8E1D14243637441C5250234E435D0A0';
wwv_flow_api.g_varchar2_table(606) := 'C818D030F18B0A3E344CE3D61822A021E6F8A5000D178A6E05AF721872E830E03CA7F93E45FFABE033DD11B841050D7B3234106E88010D443B5579964F171A748BB0A59554E84FAD5CD679658C4F7BA0760468785042074A1537B7DD8FCDF2D3FCEF326F';
wwv_flow_api.g_varchar2_table(607) := 'F0A0C19FB78C090D7BACCCD0D2D518A888412086E0B608CBF55AD0AA1612B6211CC1D53F192E843244F054B8B47D68F8310B347007153BCCBC3203CAEC938C161AAED28386EB47070DE7563EF7BBA1218218EC6442C819A021C80D27A1DC20151B74D0F0';
wwv_flow_api.g_varchar2_table(608) := '418086566C68B0EF101AEA1A68A0FD08FB697EB86D4DA763F7E9CE6D23A31BF28DA782640901D0704F19623299386B662997239BAEB2DE6005AE4064F11B8B0388CABF393C07B55296E6269CF5C00A6C4E02495D19DCC6440DABA56462707181764C2563';
wwv_flow_api.g_varchar2_table(609) := '47797E9203056527E2DCCF493CD5C2545B6070D24962EE448F8D295991DC3FB48809931A1AFCB34A0D0D64C04F9CB7C48642E4535173A7FA5BA269D043CCEDCCF9A88A0D8DF1A585F800BF6AE8D5CB90828D2B4AA5DB40C84BADA3B73CB9467E9F284F15';
wwv_flow_api.g_varchar2_table(610) := 'A9C4D9899A3B959FE727F4D2D36F03020DD3D9F48F716A0CE18AC8D06203278DB4457D83E95B38F00BAEB895989E7F03E106B6D15E766E90F75755745A48CB9BBA5C2D996B45F46BED454170994B2E68E08901FF7689A1833F63B99431B30414D8D044AE';
wwv_flow_api.g_varchar2_table(611) := 'BD668EAF874003000D8FA2F670733B38E999EFB00D9467E450F23A174B222570CB2CEE021AB642A1013F7F488B2BEBBC88A1274D540AF28590F51036BFA27A126F37448C02C3FD84861C7305880F0D57E941C3F52383061BBD922E34E4083410AB86BF3C';
wwv_flow_api.g_varchar2_table(612) := '68C8854343714E68B84A6F68621E683897A0C116459131A0C1173728A1A1120D0D9B3E34D87A6898616E425233D497B275AFD2B0E4161896D8B8446D29EBBCA98C4EBA304709D0F0F8A410D3EE97B6F1AC5870D591DE5A6D61D7767AC5060534905AA2E3';
wwv_flow_api.g_varchar2_table(613) := '0E5B06CB0C4168E87CE088C1AD31F4BF0446247C5CE08C9FC5998871FCF510E182472D2BD877090D79111AD8ECE5FFB407951A1AA8B9131DB9D44303141B687B6272657B7EDE6EA5C18506FF5AE48BFF533726A46B41A1219B3234D83312437268180BD0';
wwv_flow_api.g_varchar2_table(614) := '604BDBAD646EF8EA0F612AA1A1238C515483B3971E37080314D4529AF43DAD35ECD3807EF5A061CEA1899AC80A351117B0F3E3B362FF53F3F666E25B2F003900343C065AE0BE91273F478D4DABF424571441A1C431445A4D8A6868F0B660EF04040D4CCD';
wwv_flow_api.g_varchar2_table(615) := 'C0891F552286BE3C1F6129C6223423945A56D0ADA0F46D1C75A585944A0EFEEE09171A8E42A1412A36F0FA06DA98F00FAA6C9EB783F4A061A52C43835269F187A30382866BA7F48C6D0ECB2EE1D7104383DCA1708B0DDC55F08981BF16AEA04180866B0E';
wwv_flow_api.g_varchar2_table(616) := '1AAE1A531E1AA271C15F8D9D0C1722A121BA4361AB9C1B2C6EAF95E0F8247428DC26855C6C10950D3E34481D0A191ACAB59785F9BB12BEF831EBFB31589E2B4336DBC69ED043AA57A0328509300340C3632B35B8DFD2A38B81BD5A971A1321D60E694383';
wwv_flow_api.g_varchar2_table(617) := 'C1414385951976BDF554BCFE114383302EF1C55B3A2512C35140C12014182CE996171F17C41A434C68B0E785864B171A2E5D6878224003AD16606808E706B11E5EF84B848625060DD6AA81B731C519EBF8A35B158DE9777761550834F0CA86FF0588811B';
wwv_flow_api.g_varchar2_table(618) := '6349000D57B189E1CEA041D5A11869A021586CF0B8A1C3AFCFE6C72FF9318A1D8F1B5C68D812A161DDE0A1A1FEB23083F8513B2EB1E40B1E71BD219B6DADD6A6173D49E10801D0F048C1811BD71C12A1439E2CAA2865B34CF1B0949A2EB2F222AF80068F';
wwv_flow_api.g_varchar2_table(619) := '187C4F2769A125BFFCDAD73F4A6586C1B7A088C11C9E04ED9F2DD7F8D99A9918F4D0106C4FA4C10D6A68C82AA0415D6CF0D323062534645C6840F75C2D34003A7039FDE118FFFAD090D542032D36780C97E3CB0C64D128B91671A0E1CA4A460C2E3424C3';
wwv_flow_api.g_varchar2_table(620) := '8538D0904C0E493753580A6583B6D850EBA8C62F9BA1C506D6A1102B0DF597C5F2D2ECE312C10D965686C91A1A6F897C81F423D402324008808647A285BCD52CDABEB9ED1FF76AAF2B0577574521B3006878AF82067ED212DF17AACC9E812F337C943D1F';
wwv_flow_api.g_varchar2_table(621) := 'E9C34A80182C8118CE6625868BB05B2AF700A711425EDE153404B5901A6E504043CE8386AC070DCE4625021A401AE941C38B22DB511E8406B1D8205F08A1CCB0306820DFA8B310C30CD0709E1C1ABEF1D0A0E2067E7136BF2F3BBC4341A16135021A12D5';
wwv_flow_api.g_varchar2_table(622) := '18F8B9CA5A266BBF280FBEB63DA726DE8777AABCB54200343CD2C2838B0EDFBAB517E542AA160ED56868A8A8A1412833D47DFDA3DB98F0CD185C1D83D79870F7EBD85C5762DEDE84161A2474B84C891B528286220F0DF95068D88C010D577F7CB1E11A43';
wwv_flow_api.g_varchar2_table(623) := '43E5E51CD0F0341A1AA689A121F01DB83868B8D043C3594AD0702077285C68306468D892A0A11C0E0DC6ACD060FD5DEC1F346F7F4DA86A81C1C144E006B679D8FB00088086475E877001B97BD8A9BEAD28CDA7B14C92574A7A5D8CA5AC1E1A0AD67BC37C';
wwv_flow_api.g_varchar2_table(624) := '4FF65BAE95D8BCA53F6C498861DB7381E42726F832035EB0EBD518FADFA2472B4537E8D8CAC72868D0008493DAA4A5302FD74077FF0915425ED1DD13191A599D16D26DA58BE91E54BC9B101EF3CBA233CF8386E676153F4627DCAAA563881490E21E8205';
wwv_flow_api.g_varchar2_table(625) := 'FD7A7E36ABAF0AE432E044AF22DE8ECD5A458C0634D7422CF91045AAE4EC44CC9D72932BB66F22C1484E5C1183EC4EE68282433289B913973E349CC90691DE162BD7E8A9CE2FA4F066282445A467F7D4729B1462B1C1108A0DAEA6C15A35ACF5B2278414';
wwv_flow_api.g_varchar2_table(626) := '58614980060A0A4696E4127E5B922F98ACBA90B19E157B5BD6F4D7144A08000D106172C9C151B7FEC62866B31E19483410B302111F1AE4314BAA7F24D0D0FBC4E91F892583DC9808DF4E99141AEE921B2E35891F192568B0E341436E4668D849080DA1DC';
wwv_flow_api.g_varchar2_table(627) := 'F008A1C1FB7A7EB8D0B0C441C393F4A0E1457E4AA0611A1F1A2E934283AD82063B7D6838BE5368C0ED090F1A5E606830B26C41362203A1BAB0C4AA0B14149883D392BB868AA4FDA2DC3B684C7E0C71F9008801A00122BCDE406378DE3797AB45B2595B72';
wwv_flow_api.g_varchar2_table(628) := '7C2A8AEE0E5A68F817B7277C6858E7A1A1C24B2019344863961F7DFD63B0CC30E02C1962AEB44E860E17C9D1410B01334083E342838DA1E1D4CED1D5D84A68C8EBA1C12386003490D109091A92F75334D0307D34D0207D3D3C34E00B91F5A0C1EB50A8A0';
wwv_flow_api.g_varchar2_table(629) := '214C5CC24343E5657E7ADD98C6828619FC18E2EEB78C0F0DA3B3F4A1A123184BBBDC202FAFE2B590DEF484080D6EA50153C2920B0D4B5ACD632D93AD6573CE2B63F0B9753B1E43BB01A0012276AD8193F98CAF868D0DABFCB450E4B9612996C401EF9EA0';
wwv_flow_api.g_varchar2_table(630) := 'D0B0467C5EB117242768E07B13C1314B8F18B832832C65385638388D34658659B8E172A6AAC3DCD030E1A061E242033A931242434E2A338440436BB7E642833D3F3A3C12BDA4E24BB21134D4DE14597B221A1A04FD632C68785588010D738F565EC6FAFE';
wwv_flow_api.g_varchar2_table(631) := 'BF6368882E36C483061B41C3BF79AF1F4189A1C2551A240543DDAD31D8CBB5C151F7F697BC270202A0012271F961F263D43A681ACF0A45747F249399C5A580CA2190957F884FC3FBB20F0D4405D9D8142490740BB6641AED8E59D6C21B13B34143EAF586';
wwv_flow_api.g_varchar2_table(632) := '14AA114A68B8B2D05F47D080EEC8F97C4E0D0DD48B501CBC941F6D256878C24303FE9CAD3D091A6CC5436DC26EC534C53EC582206386CF8FA0E16D49D234E494D0F0544D0CD2BCA5040DD5D7081A9AF4124C2E952FBEFD80A0C1DB5C353F34F8C5866DD9';
wwv_flow_api.g_varchar2_table(633) := '1AD2DE0C40C33F79BEAEE0B3C2124ECFAC893623AA4FB28DF7B5D15997B2820F0A747E127A13000D1071AB0DDE9BDC4051EF6BBBFEB65224EBAF0A99887D57C6F31C1B9D90A081CC4DB86A069E18D0CDC26F4CF86396DFDC324360D5F528C4CD49D39E98';
wwv_flow_api.g_varchar2_table(634) := '851BD24087E8C5576EBA9CC141C3B953782A43432E1C1A9E06A0E1AF1C95ECE1738E4043D68386FD7A001AECC44E97BC71E16F4487F83091F853E14A43FD9D1E1AA46BA14C091AB2FE55C0D0F0B638FD2E42C3A59DB21F43ECEFF984D06005A0C10C8786';
wwv_flow_api.g_varchar2_table(635) := '38B206E62A4D262914D0B0C541C3BAC1EE33081A9EE715EB2496DC5D12AE94A1FEBF4267C79E5C0F78E33BF9A9E9171C06000D10B1650DE26F7D41D0F0AC6FADD64A4FF3056FEB95121A9E89D0B0C14183BF9E2AC4CD892B3328A0C15443835E08392F37';
wwv_flow_api.g_varchar2_table(636) := '5CDC21345C04A0E17F790534281F7095A794121ADC67DC368586CBF4A0E15E7143BAD0B05CF6A1816EC78E0F0D797A39B2790D34D42468B8D643C36CA395176942835C66B81B6808B835D85B0A68F0584122865A365BCD649D1746EF4373F263C44A0B81';
wwv_flow_api.g_varchar2_table(637) := '72C2140A0C000D108A6A82FE0763CA6F6CE37C52F9D1E4C9F5B0B56B1B7F176241C3BA0A1A486FA2ED4303BF69A2C6F93FFA6BAF1342839532345CFC366828FE1D808627E941C307171AD4DC6027E38645F83ADC0F6898FE68F8D0E09942268186423834';
wwv_flow_api.g_varchar2_table(638) := 'BC2B1168B054D090861FC3A2A0C1F2A1E1E41E40C3B35C7059254A33976BBE28778FDA93F188DEE67CE33BE5CD102CA2011A2016519CE81D75EBCBD5C213E626E9AD8A31FE269A86D5125D788FB2212EA9A26E4EAEFEB1CAF93F869A46BB9A869166F3B5';
wwv_flow_api.g_varchar2_table(639) := '6BEE642B775A86E72C1891364F4C2FAD095336D8D3737C5A8C2F9CF273060DAEBF93070DF810923D8C9F6A050D78BF25351462C48085909D833A3A1417E23F711D9DB7F73BF90ACAED4FC75C21424832B08ADB13C1AA8F3BAE22758BBC0BC18B4BB22234';
wwv_flow_api.g_varchar2_table(640) := 'A04F3EFD8E876CD1BF35B9747B1049FD18B4DFA28E66BA92BEDF190B196D07192C338C6415A4BB7E824183CA493A1C1A3E88D0A0DA946D6F96313AAC116E582F3BAB65F3599E6F4354B2D9DAF35263C31A9CF641A300D000713F3A1A37D3F1F751FB63B3';
wwv_flow_api.g_varchar2_table(641) := 'FAA2ECF52C4A7F65589961B5448C202B440559463FE74141836C1A2D4D5A268786D9B8E1BE40C385C34A11141A2E1DE31F0E1A9654D0C073437C6858C2FFDFF9C4A0217D6E78E0D020F45C2E113434D0377336C3A64ED8CEAA40ABC88786A78A19963068';
wwv_flow_api.g_varchar2_table(642) := '785FBAD541437CD9E34CD0305E28341C2E101A70BD61830921F12A8AB572EDEF5C95BA36E5F3CEEB4AEF43638AD75142DF01A001E2FE31C47432195E0E1A3B56E959A1FCBF5CFD6D89F526980AB2DC24DE2C12344816900ADF68C108D292B760CBD0A02A';
wwv_flow_api.g_varchar2_table(643) := '36DC41BD215D68B870FB14041A2A2F0A3C348855F104D090C39D09EEAC5AC27D8AEE67D38306EDC4C7C2D0E1BE1383FFA06FDFFE74D0B77136C38E79171AE4010A011A021702F78934D0807E5814D090744A223934CC400CB1A1C194A0A197141AF83D14';
wwv_flow_api.g_varchar2_table(644) := '4A68D8A4E6F4156BDDB037B19B5CE559AEF677A1B563E311CAC9C47BB0813B344003C4FD8DC9AF49EF5BDB5EAFA09F619BB427D8466CCC0DA23D83E41B4D8941B76CE2C8F416EF2A462E858555D6CC4D0A860E342FE6CEE45A077A739F7AD070C5561E28';
wwv_flow_api.g_varchar2_table(645) := 'A0816DA0C82ACFAA023F3AA183866CA6F7D592A0211E3ACCBD04FCFE8C6B4612830B0DE8B8CA7AE64EB1A1812B3364F3A24943D62506BC6E74C37015A93234A4215CD0D94587E2424C683855CE5B72BD091E1ABEC41DB98C030D74F612BD74E65AD944CF';
wwv_flow_api.g_varchar2_table(646) := '279B95EEE7C6E472A0566BC1AD19A001E29E362C08DA3B9BB5FA72916E942112C80AD79BA8FAD040E62684DE4448A521C4A721921B12B52AF8BCB8BB64D070E942C3A585A0A1FA3A000DD96CDE5B5B251E57720A2A48111A3278FD55FF1B95EB27B5CD0E';
wwv_flow_api.g_varchar2_table(647) := 'F17578C030A1C0054F7EF8C369EE56B90B4185900168C86BAE423E4BB793FB2A48CEA401053A0B6FBF377C3DEC5572B5E3C502A0217E9921041AA27A1389A081F9495362200A6BB2231B6B1A10348CBF0F70D513EEC6000D100F2C7E4D9DEDBAB95AC6FE';
wwv_flow_api.g_varchar2_table(648) := 'F06E87023B34ECF8D0D04E051A94DCC0EDC87E58E840A0A131A1EB3409344CAE1C660FC00F5064B3628722AB3FAB72E2D3AD080D4F32FD23764A2534AA9A7BDA22556898A6955A07467BFADD6EEDD7D855202397585F1298BA5470433E163434B1CB1682';
wwv_flow_api.g_varchar2_table(649) := '066B166888FED60A87860028242C3344393BC51534306838D040035F6C7055D5B4D260A35FD14D66AB3AFD6FAC7DA481006880B807D585A9BAD2707BDBDCB7CCD592B55642DCD0D8ACF846902A68086B4FF05B27FCFD966658B14184067F59B6E7DFE0A3';
wwv_flow_api.g_varchar2_table(650) := '83155C9F1D860E7701100D0610F81F3227D78EF9DE08404346010D79EE948A070DF95C6670E24C67F1B854ED0757E7C385065B8286F6C7BA0C0DA4D820EDBA94B9C1F5742AB872D49C30C3C2A285675F1BD38BBB8706556921FEBCA5470C4A6850AA2029';
wwv_flow_api.g_varchar2_table(651) := '3168A001DD0DDA922F248686AA121A88A681257A2C69EED6F1C838D419001A201E62343FD86472BA64636EC06506F44CA080067917B6080DDEAA2AB9D810050D72B1C1D2708315C90D93BBE686C698BE41A1E1BB63AD5542A04190434A27560434E0BF3B';
wwv_flow_api.g_varchar2_table(652) := '3C6D44B62754DC101F1AEC87090DE27F023ACB7FD8DD2F6696EF1379D0F044050DF91068C8482A486C9871302B345CA4070DE70B8486DE22A0814E5D6EE1B90967ADDCDEB7E0C60BD000F150A3FDA561E2E989127376DA64828640A581DD32F0E8043F3D';
wwv_flow_api.g_varchar2_table(653) := 'F1854283AC856472C81366F1340C81066108D3D73AA801E27CC64C9B18E89DDD9A60C3067CE39E5C369B5B5CA5219B235E8408023228396EC8290E2D2A81249A065F7C87FFC7E606CBCFB3F89F387766D26CA6EDEB70A53FB3BD5C6027422365606084DF';
wwv_flow_api.g_varchar2_table(654) := '3338B2F264DC129FF99CBF9342D6205E05F7420454901C3474BF9A741F3ABEF457F83B617A31B3E0313AC7B34D5A7AC93B429EDA3C340CFC794B8B8306D3EB4DA01FF02E4D9E1854ED09ECEFB4E7A66AEA926CA0C03D50F486B566B43F37605002A001E2';
wwv_flow_api.g_varchar2_table(655) := 'A146F7A86592AD131E343474D040B9411AB9D44303BFE83242D9A05047AA565BCD810EEC892D358070A18124FA9CD3AB667B87AB3464692B9D783BCE080DFEB6AACA8BDCF8D285867BC70DBF374568208FFEC313BBF857C6F7774A0E0D390D34E4B2D9DE';
wwv_flow_api.g_varchar2_table(656) := 'A1455C203968B85C1434C4228698D0702A42C3F19D4203ED50306858373A5F9B302401D000F1506370D133577D68C0B286504D83040DBD2F5E7B42EE503033698E1BA2D1E14C9DFAB6C52CD090063A306818D3449FEDAAD1F950E5DA13C404FA49667668';
wwv_flow_api.g_varchar2_table(657) := 'E0565CD6DE16F0F974EECC37269AAAAFC3BD24062C31B94217D7293FCB3168207254E52A10CD5570A121A02C21E292DCE084D45128325E39B342432C9888808673BD0432041A4E2468C00314EEBCA5A4824C171AE838B7616F547AC76DB8F10234403CD4';
wwv_flow_api.g_varchar2_table(658) := '18FF182268F0164F7806D2F2C8A5D4A1F82C151BEA82ACE15092430ADCE0A34364ED410D0D69B62DE66B6AF84A8BC96503BD14DEE9425BE959D214E7A1C155EF67D5C715B78B394B9E92990BE16A49010D0B4187546592BF091AD0B560465B4BB847910B';
wwv_flow_api.g_varchar2_table(659) := '561AFE0AED4DFC25D47B7868283ECD0DCF71D3040B5918162C0A1A22702134238881F6268E155E909CA0214D68A00BB2D900C5466570DE851B2F4003C4C30C6C1039B6362ADE5E6C1D3488B206C1499A379356281B025E4F6A7408A587F15964DA8B0088';
wwv_flow_api.g_varchar2_table(660) := '89263DA4F0B599170EFAAFC67B0EA49D559C6E9FE3063A4991F525902234E4446840775B020DA95B5485FB3A2C463BB9B8C6041E7FA583A98DDADB6286F37792A0C147B7BF725E0A5781ABF7F0D0507E961F112F2F060D57F8385F043484B524627CDF4A';
wwv_flow_api.g_varchar2_table(661) := '520661D2522A331CDE11343428346047C8EAE8AA0FB75E800688870A0D881A9C9D1A8106C3D53488D0109CBA0C9849730BB2F10D288C1BC2E9E1343A63D1833F6D210D5C448F6EC6870629D17F48415C7499CDD2BDCC19561897B881A0037F56E585075C';
wwv_flow_api.g_varchar2_table(662) := 'FC06F306D8ADE2759AE70B72B70CF83A0473E1D010F3F3073E40FE52B167C6F4AA61BD2FFBD04044A539CEA093BB04222E70C4A08486CA8BE298BE4AE77462829CF1440C9B0631D89399BCA2A3A04124067D9981F526165A69403799ADDA643C845B2F40';
wwv_flow_api.g_varchar2_table(663) := '03C4C3E58669EBA34517C9D01F6C0F1A988D7460EA52BBEBD22D36F42545E491254383E8E2E0D3C369B28C5181B04480B0E24C6FC6828633E157DA4629BF2C09ED09E645C835D4396EA0E796400C2234B0ED09994CFB639D4083B54863EC99A021D8EC98';
wwv_flow_api.g_varchar2_table(664) := '512D11090D760C6220D38F17D6F47BC3D9AC64DCF513B43DC1AE85EA2AC8C4C0D93A49D0507B5B9AA02F06FD13E7F83F73CCB8C14A8918ECF19D43433F5866580034D0416EAA696860938631DC77011A201E7074BE386CF144BAD070C841C391061A446E';
wwv_flow_api.g_varchar2_table(665) := '885F6F48000D610C1179FF5503C7E45C9EE61891CF5C7967B87B92D8AF6E8722CB0BF16468C8F965067A56E5C8F3B177E675BF5AD36B3B1934CCC80D76C2FC1DD07019010DB73F9ACD9DAA27235543434E4F0C7A6830578CC975834203AD0AA8A1E12215';
wwv_flow_api.g_varchar2_table(666) := '68989118C6E781DEC489121ADC32C31D40C336818675747BA934F7CDDBDB092B73420034403CC4E89F76AD558308214BF4B1A0E12DAC123A14357FF09235295C45249DD1E23A1434E5214C325231E089E1D8E4BD1C12171ECE92A55E09115E960860C499';
wwv_flow_api.g_varchar2_table(667) := 'E5DE9DB94F7E6EA3972E8B58E1493EB3E41E39B84391CBF16314FC89951389813BABC8999727E2BB0CBAF51362B07ED762CFF4E060BEE4FF5DDD8E28AC856C607FA7255AA6C97A551F610985C40DFE55C01F93CDF9C4E0F9446596B2CDCDD2F4AA29BFAA';
wwv_flow_api.g_varchar2_table(668) := '6110A04B671C7FA2526923AD2386B330FD2367CF20793A910C0E5BBAC4A03077FAE0EF9E68EF7BDBB1D50BB2112B604D0319B9EC7C6D00310034403CEC185DF5ADF50A1142969CCD7218347C0840C327011A5C6E1045911237F07E91C75A99A4C00DB1E7';
wwv_flow_api.g_varchar2_table(669) := '2C124283870E9A6AC499C40DEE3B2934707B80E8E76FEDD7B2B4A5B0E4D91112AB80271959DC1048BF8F4E1AF0E4A0CA11F15DD68386D987451F013404FE75F5977AE14CAF1BD8DF29A78486AC000DD225F0A0E109070D9EB3D352A6B3574144E2CDCE44';
wwv_flow_api.g_varchar2_table(670) := '161552858658C4A08086132D34F44568E82D101AB010B241E6B360DE12A001E2C1C7F4BFB1B35963D0B051E6D74F78DC80A121586CF8A4283670DC50F7A141C90D47416E50571D4609C59209A1214947837B3FBF3C9066EFAB55F82BC349F00834D02508';
wwv_flow_api.g_varchar2_table(671) := '417183AECC204243ED4D614C872DC59AC75CE8905211420B13E94246142888D0809B1AA373A7F48CBE8859516292E55B4539299FB8D090E5A1214BB9017DC0E06BDD8306DCA5A266A077010DF66C65060D34980A68E01C1A9242432B5EA5810C50548657';
wwv_flow_api.g_varchar2_table(672) := '3DB8E50234403CF0B89936764C6C0B4F5CDB08341872B161DF533648DC406F2EBEB8A1F7D59BA408481C02E8A0AD3A686A0F89E9215A09612B2A0D21F39CEE7B84E581E4EB215FA16DFC9367BB9296983564C645019E1B026795600CC09E6E0970D81BC6';
wwv_flow_api.g_varchar2_table(673) := 'E4B23189146CCEE35575794799183262B382DC29B86A545F17BCD730586CF0D041BC0464C8828C5BF87BAAA84F5726537A9E47D79D88183868380FAB372C041A121103E7E6C4262D15FB264C616E221E34B483D0B0C741C38E080D5B068386ADEAE4BF11';
wwv_flow_api.g_varchar2_table(674) := 'DC71011A201E7CB40F1C6BCD5040832487E42DA50F04CF067FFCF2AB8A1BF856850A2086E1F4A0D44B2A7311F31781541103FEB2D16D9A2DC876D573CC5550E086AC32FD8FE488016F48FA50430755B2655DF79E1E1694637A7E9F63A7676BAD9CE15A45';
wwv_flow_api.g_varchar2_table(675) := '9925618B985B54102F815763E0A181D62AF0E8449112836BD161D3EB320939C82FD2CED98821080D8204D2EC2584069E182468E0CB0C041AD8C22AA269309A7BF5DB9B09DC6F011A201E7CF48EDAF67A052B95F0826CC1E289141B2A62B1A1AA6C52F4A4';
wwv_flow_api.g_varchar2_table(676) := '268597B3A343901E34D287948A107A8C100A127492CD83067253A6D0603A9B157FC56286491ABDC75CC60DD2F32E4F154BFE032E597690E97E31A97E22D4674298EC487FC9E77DE303FDF40199A1C0D080BE5D33BE8651B80AB9AC7C09385CC8B0DA906F';
wwv_flow_api.g_varchar2_table(677) := 'E3CDA0C1D934A6578CDEF0E80483063B4D6808F93CE113130162089619866A62A807CB0CBD24650651D0A08106FAEB86D1F9ECC0D609800688C710E3AB81BD5125B206BCC1964203B7842246B141F4880CE106053AA8E50EC111CD0874886E619CCC8B11';
wwv_flow_api.g_varchar2_table(678) := '8A0FA09506060DF5CE47339FF34BE29C2FA1782C2993DB3741A3F43C373CB13D528932AD0AA0C3C582F3DEE00283864B0F1AECFE914D2F84070D19C525F042D43170F509D26ACA147299DE572A62704B0B670C1DC28A4069414314318C63941986C79656';
wwv_flow_api.g_varchar2_table(679) := 'CA30476F22041A7C73A72D060DFDE316DC6C011A201E43102D64D55A2DC58506DE20F293E7112972C3170E1ABE9A61D010CD0D71450F118587F9BA184A5C60C506363E5AEB1F3AC5FFE533FCB45E36363770C79BE72634BE6C8ECF4C74328D68A943CD0D';
wwv_flow_api.g_varchar2_table(680) := '5A3F89C5A2C37D22060A0DE43FD99C5E99E3AB66111B74BA6EDC492E810C0D4BD9D2DFD9F1650B9B3F5268100CCB7F3F3448C60C9ADE4450FF18283368A041366950434325121A4617B07502A001E2B144EBC0B2D6398B27B943C1E490DE2A0A9C07ACE4';
wwv_flow_api.g_varchar2_table(681) := 'E04383D4A7F8A25439085E0EE132498121E4CE452CB387D475947CBA9F997D1983437CB49B2B45BA4899AE6696923BB7441D039F59D70BF243159F0AA7CEF8CCC1EB34A515E1823C73DEBD1B0B2F4B2C3EA7141A2EACE9A5757BE538EB256F0885AE1ECD';
wwv_flow_api.g_varchar2_table(682) := '70664DA425A1BD04D4C4DB5536641B5B35227B9C3B23B841375AE97019B1984A5881CD5B39C99B26146A061F173ED7B47313BCB3D37ED8BCA5D79E6890416E67BB36FD055E90000D108F25BA874D6FD725E6862D4E0BC9EDA1F0940D3C34700B29B87AC3';
wwv_flow_api.g_varchar2_table(683) := 'E7106E309372C3208C1B62B52D8669082755C4E04303FD029A7B55A266C84BB5F1B087DDE08765B385BF32FD433AD5490F0333141A801BDC854FA443717BED743FD673AE28C197A662DB8C8088417AFD33BE37034587EE670422292D429BA5F0A0208608';
wwv_flow_api.g_varchar2_table(684) := '68087173D2F7261240C3876868E06CA4B1AD53EB83753B0515244003C42308E2CE36BCEAD99BD4E2C98786A061032B36F0AB2F796EE01CA6BB61F506AE5BA14487C8AA43D08E5A408750A3C9B9E72F029FD3FF3206C7E83FC42AE468893B9BC98827108F';
wwv_flow_api.g_varchar2_table(685) := '0E4B9C4B71F0B8C20E0DC5D1B9333AA7FD11742A9871B77D2E7C27F87DCFF1393DE31BE57F72DE8BCFAB4CB22E0DA82F813FA889DF305EE447178D44ABCEE6E506F9AF048881EA1874D0A0DC4D75C4FDAC29272D35D020F526668206DC9BE87E6B820A12';
wwv_flow_api.g_varchar2_table(686) := 'A001E211C91A262367AB46965094B90E850F0DDEEC258306699242516FA829EB0D3DA94FC1A143A4D641DDB3881CB8482A9F8C4AF9AFFBFF741D01C4E0C4AABF2B6633197F4FA58A1B14E9469654D4DB07F5211131E01A03ED9DC71D0A8D44072B1140DC';
wwv_flow_api.g_varchar2_table(687) := '3BB6885C407A6692C1CBA6BD5151BCFE19268ACC680B0CECC2E5F0680BD932FA1D9DD9668A5BD7674FC9F631D437DA25062BACCCA02486D8D01069D2C0A061B332BC005B27800688C7850DCD0FB6B55A76F862C35668B121C00D92B8C1F76FF81CE0067E';
wwv_flow_api.g_varchar2_table(688) := 'C155A0EA30D065ACF28315D1C298B997A18606538086535CDE40FFD5851CD52564A5FA811A1D02517A961B9E3AE8932362F06C2E939849045A1861D316B3162474B978380883860B66A039B9707ADF388FCEC00466C8EBEFBDB3F4770E51E0F8C29C5C3E';
wwv_flow_api.g_varchar2_table(689) := '28623856ADC00EAA19BE242E3384404340D0E00921CB8D9DDAE427D83A0134403CAEE81DB6AD35C35E276BB2373868087283206EA8698A0D757F3985A6E4D093D1A11E5178882F990C134E5AB35523045060BD0F53808613FCB5E14F825D9E0A59F1F851';
wwv_flow_api.g_varchar2_table(690) := 'A3832AD05F44AFFC90B2C23126004C0F67F3185589F430FBDACF78D0B0E0D47F3DE4BFD48586F1A935B96A9A2B056F5F7926FC8A682EC4E4D2199DD62717BF9915B4B8909C18FA016270A1A1165D66F8E0AB205B71A1C1687FB46F7F79BD89A9D7158500';
wwv_flow_api.g_varchar2_table(691) := '688078C031FE3EB4372AF67AC95E3768B1014383B2D8204F60D6787BE9AEE7F8A41BA9F81AE006860E81DA031DD1A4190B2038D9970C106443F79115010D7100C29FD710A1E1087F9DF44F3B9FEAA5BFF3898E282F8C7F0AFD4374D3AF611A38B2C74405';
wwv_flow_api.g_varchar2_table(692) := '29384ACD6870696B6DB3D9668D942411A9C1419CBDA332348CDC0E05CAE955A3F7CDCC3FCD09B8B0E40E53E858C1FD93CAABC2F0843468E8AB77DF0A0CA77AF1E331D79B8851665042834F0C7342C3B6D13B6AF2454D800680068807DB93B8E1A449D3A9';
wwv_flow_api.g_varchar2_table(693) := 'B359B5D77868108B0D2234088AC820377CF4B8A12EF84CEBEA0D4AAD030F0DDF12171E02E860F9196E1E1591DC9CE7B1000DA3631BA3C3516D74D1B0D76BD9A559A0A17D600FCFECC1711577438E9DD1316D4FD8291963DB710B12B3A7B5E0D44303694F';
wwv_flow_api.g_varchar2_table(694) := '9039552C6B189D98E3AB86B565669F045A0F21D785CC5CE472F9F6676CE8343A469FCA19FD566818C5878663191AE43243586F22021ABCB1A964D0B0630CCE3B1C2800340034403C82203FC3DD6F4D9374283CC306EC18BF5345E8E0714353C30DD210A6';
wwv_flow_api.g_varchar2_table(695) := '641649E729E4918A2F210E923C40A867356700083F8FFD1C264E0D4C1CDA0447D0E7AC0F4ED0AFB6BD66E458A11B7B0465B9BA37DBDCEC3DDC3EC951F30073BD2C70CC896F563DE374A8B0EAD35DB535E7E64F456B230591C4DC5012ACE7D3FFC646FD4D';
wwv_flow_api.g_varchar2_table(696) := '3ECB5A42E4555FCA7AAF7F56D533CA3DC9A06FEF31628513EAAC45CDB5D4B9289EF00A0CE76A5670FD186C1D2E086506945F71F6BE9A1A37A79A6FE8F45122069C6D5ECDA05041569B9E1012DD2BB62834541C040DBB267668B881D10980068847070DC3';
wwv_flow_api.g_varchar2_table(697) := 'F3AEB56ED86B9C61C3A6816E017E93828D51282629046E706F37D23C855B72A8E9B8A1A7E686BA861BEA8334D06118C73F2A0E341CB9D07054C79FF6D4E97DB11037647D34C8725571EFEDACB7E0A0BE5C1C9C3418341C05A0611E7B89B3B01CA79BA9C1';
wwv_flow_api.g_varchar2_table(698) := '44C20A44E02C77FFEBECC1915D7B5B90DB0FBECA81783C7943134F328D9DDAE8BC890EE6F1293303C5CA86BB8486B3E802036FE2A4E84AF065065A690812830F0D8294410B0D7A2F48091AE863068586D62707EFA90268006880781CA0C00F4F4F27239B';
wwv_flow_api.g_varchar2_table(699) := '0C5EDA1B7EBD41A36CD070C3815C6FE8C8DC40A7316B0A74F81A071DD219B8483EC919071A2C171AC8A7C2B77567706C5B1B46E99FAC28B0939F720BB90C1E4B3B7230791C735F0037B2918E39D559E24C8F27EC8499104A94D0808F55133DAC0F4E1CF4';
wwv_flow_api.g_varchar2_table(700) := '5D5DF84B595DC87A3851F85FAEB58789617CD640579340037152F2EB34B6EA1FBA6B6290A121BCCCC0BA128A32432FA87F9488E1A3AACCE041C39E772BA8346987625B82864AFFAC030E0D000D108F56E4D0FA88072F0934186C8C6293291B846203E286';
wwv_flow_api.g_varchar2_table(701) := 'DD99B8C1478788C18A508030B9B6458C818BA35972A84B8608F2FB07DC1B7E25E3C41C5E389D4F75F37DA9FC1C6F64E6FC1870969FE7EC8D4AF733FA8BF608F738FCCF20ED045F84AF651C8C183F900C1CB1161B39B9B00714BF4E9DEE27D35E338C7F72';
wwv_flow_api.g_varchar2_table(702) := '398E1DD0DB857CA6F232DFD8AEF60EB193123E920FCDF10955A15AE30B011A247410DEB9385CD0D718E210830B0D3231F4428C197C3543A0CC206CC4A6A547020DB8CC80EDE7B11C6A07134363A73AFE39841B2B4003C4A38DFE591741039EBDDCE0A061';
wwv_flow_api.g_varchar2_table(703) := 'BBE2A5B032DBE3863D4D9FE240D5A750342C0232C92F21F4608AD090BCFC2091C47C6C2170C6B1080DB84F511F1CD64727E8A6EF0C8E6C746835F76AE84E8AB2B95B4530D13FB279872801595C5943323389D394F3FEC1416472C4400E57FC9E133ABFEA';
wwv_flow_api.g_varchar2_table(704) := '8CCE1DF49A77BF59ED4FF5D6871A3AF93A1FEBBD6F882AD8A93F3A31495AE353020DF4253DD79FE56941437C62385111C351183128C62CC34DA379FD6380185C68A878C4D0226A271F1AC8C63B040DAD03F3760ACA4780068847D59E10623219DB9B1556';
wwv_flow_api.g_varchar2_table(705) := '6CF05D9EDCE41652B8F586AA8E1B78FF062D37E86CA0BE448D682A8493C9FD1E667283888086E34077E3B04E128F6F8C3CD9DAA90F0AE888C2787188E593FD63091A62EDF69CDF1BFB014146DCDA896FFB6D8FE8F18FAF0529399C5903AC70B4BD991477';
wwv_flow_api.g_varchar2_table(706) := '62D31C1DD778DA60C071E60EB09CA5800EF13F0FDF8C5013832C6530651D839E187AE1C4705093D75305CB0CFB3E31B4765D0F690C0D78DD9D83A061A7D63B6EC28D16A001E2D16A1AE87B3A9F6C6BD560C5063A43B1E9AECCE6C50DC1214C911B3AA2EF';
wwv_flow_api.g_varchar2_table(707) := '935A1DE9D9407DF6EBA571AA0E3D2D3AD4757E0FDAC5DCA9F284C00DE499CF4507928C09EAD4739AECC6AC8FDCFA043A03FA61A28AB9E9E1CE01E25E2421030267B878C040ED9CBC87C201939D9202C399890E66A263C5D50562B165D38685F009E7E086';
wwv_flow_api.g_varchar2_table(708) := '1489415C30A18186E0FE6B9DFEF193A07C54971984494BBECCC036DBF1D0D0D8AB8F7FF4E1460BD000F1C8A16178D6B6D72B081AAC75DAA4C0C31464E4BAA282069579836B16D9E6FD1BF892C30CDC105172601365616D8B05A303BE83D39684DF62B086';
wwv_flow_api.g_varchar2_table(709) := '8716FBA3638BFC15524F261FD6274FBD8343FC31A3231B1B513013AA18FB3C43E96104F4C0279E9934D910CA116E528C483F68E4BF803697E4053C77064437E0561D6CDC60924064A1D0703A5B99C10C1A33F482D010ABCC50539419F80D55726F8240C3';
wwv_flow_api.g_varchar2_table(710) := '9E000DCD0FE6ED0DACC306688078F431993A5B756BBD6CAD95C8FEAA0AE7F564D06EA5A788E474913E37C8FE0DBEC4A12AC9AC540D0B774966083D24534D6A2A108711B9E85E46CA7E12BC49E5899528FF147A50EE1B4BF06A24E92CCC99C12909353190';
wwv_flow_api.g_varchar2_table(711) := 'EF0DE5124BDD8CA5C2CAA9DE41C4F029CA984180868A2F81746F028D5D83DE0AA8AC01DD3706675DB89B023440FC111588CEE7A6F9BE4C2CA5CB78F692281B386E108A0D3E3770D010F47D6AFB3B6F94AD8A7A70BCC2E5869A961BBE44B52DE2D0839621';
wwv_flow_api.g_varchar2_table(712) := 'EA61561077C60D4721D0106E839D0C20C2CFDA07509C88FC22E77A1DDC53FC6E8941312BE117187C62104C9C5C62E8AB884186068A0B3A680810439B12830E1AE83D013F5718CDBDDAF8C700EEA6000D107F448CAE07D41A12255E7DE919446E8AC5861D';
wwv_flow_api.g_varchar2_table(713) := '690833506CD08D624A0399A1B31561D60EA1558750A3C9B0E6056388004C5038E8FF268688673FA5B1BB9EA90231C3DEF0DFD91009FFB7A2CA0CFABFAB6A16DC518D81E48966BA32480CDF2462882A337CE2A041EE4DD4E489091E1AF602BD09CA0D3BCC';
wwv_flow_api.g_varchar2_table(714) := 'A7013D6374BF124F27088006883F22A693C69E69AE1268582BFBAB2F113428B941B59942E917A9E3060D3A50AD83CADA2161DBA217ABFC109CC288C28BC3F40DA666319098CDC232C162CFB4016201997CADB9E6E3E340C322D041810BBECC42E5C79084';
wwv_flow_api.g_varchar2_table(715) := '183E8BCBAF796386648D89AA8E18BCC51378367BA73ABC209E4E306909D000F18744FFA463BE372CC20D240DAFDE403B143234A886299456D31D9A071A81A4763833680C15557E88C9100A0708091A94306186E7EC458854DCA8FC0516B161E2C454E7B1';
wwv_flow_api.g_varchar2_table(716) := 'DA66EAB7552C920341DCAFEA34AA37912867543B7AB8E0B382DABE29480C3E2E981AE5A37E6222D4FCD19732E8CA0CE4C71F772576A93D8335F96F0477518006883F2826E391BD5923CA060E1AC4ED970A74109D1BD47BAD3C74E0B941EA5684A1435DAC';
wwv_flow_api.g_varchar2_table(717) := '40C418BB886A6144C08454A2483AE799D68CC6028DB193EEF94C5CA2B8B799BC87622F2815B8A05E2AA1513E2A71E14B00179212C30749CA20A45463C06A066204D93B6EC1B2098006883F2C6E6EBB5F5BD8B061B5244083BF90C2AD3784EB1B74ABADC8';
wwv_flow_api.g_varchar2_table(718) := '4CA6CC0D4A7408293C7CAA69D1616E80E827CDF88289B4C63E53E86B045784A747150F073E928B3016000D270162380E1A3EFAF8A82286503F86286250DA458B13135A35035B6EB943640DFB75268184DE044003C41F15E3EB81BD5E31DF17F1DE4BA26C';
wwv_flow_api.g_varchar2_table(719) := '70D6456503293934656EA8B6BC0C42C3BE080D7A6EE806330637A8D161267A480C0D8257C4ECF91B00222E342C121D12A4FE0B4B831BE2F52CE27040DCBF2B2FB9E6886118B48896165ECBD395A6D68F218418A2CB0CA1D0B0C341C36EA5FDC9BABD9D00';
wwv_flow_api.g_varchar2_table(720) := '34003440FC89D1D8B7CD55A26C582B49CA06DF613AB09682DBA0EDA5388AB9AF70B3576EBA0AA61E1DDC322CB74E339670728E5E461CC8486C20A119015DC0BC86A54DAE891EB1B8EB1EE67CDCE0BFE7D4CFD9DB0D24D5BE0B2AF785C088844AF3986CB4';
wwv_flow_api.g_varchar2_table(721) := 'D2FFB9504C57325CD0AFA4DAF7D09FFB7126AD0AB60B7B8FCE4D188D9D3216346C5747D77D20068006883F3406173D2C875C2BBB4D8AB2D7A1D04283DFA410B921113484734348E1E1735DDFB9A825E38639006226E3A9580E548B448700498443C33D87';
wwv_flow_api.g_varchar2_table(722) := '89543A177370C350C30D61C410BF1F11E5E02443838E183E526208DF631980065ED0B0E7151BB06F6CE7B33D9D8C011A001A20FE5059C3EDEDD4D9AE9B2B65AF436173CA0667CB15376CE9B961D7AD3404FB14AA814C7A0B13D041C31061420755F3C29F';
wwv_flow_api.g_varchar2_table(723) := 'B68833739162CE635B39DB90676A339F82F26EDE95E2BF1D32D2408760C68486A13C48A9173C8AC410B07AF404B991660C759EA1953506BFCCA0DB3111460C86000DBBF8F9617821B940821C12A001E20F8BFE49A7BE8C97655B8C1BFC95D91C375474DC';
wwv_flow_api.g_varchar2_table(724) := 'D00C7243D0FD693F587250691D74F4102196544C5B84A91F666B67CC5AB188E15F196B15F8E09EF85EA7623B11CE16A9A046DAE8A04A5BDC6AA1660541BB1018911804AB0B7ECFCBD4EFAE9489412962F0750CCA19CB3D5599615765CF40DB13BB95F647';
wwv_flow_api.g_varchar2_table(725) := '732A4F5A0234003440FC293506FAC6F4F6D7D8DEAAD757B03524337A12B9A1E10D616E29873035F3143AE34877D3154EA9EA10931E22072E04D1434D0F130B2B4B7C9DCDC232616522ADCDE0F7033B3C7AD00B39EFDB04870A1142B40BC7B2DA51490C3D';
wwv_flow_api.g_varchar2_table(726) := 'CDD6CA7062E87E8A5760E09D1F95C4C043C39E6F0449B23A386B070C9D001A001A20FEBCE81DB76BEFCAD6FB1251442AEC9E9C0037A8FD22435C1CF4E8D0519A3AE8E941830E756D0582CFA0719E7823EECD93F30044184998F13B1AFDC394367CA6980B';
wwv_flow_api.g_varchar2_table(727) := 'B1C8BC7FF39FE23FA40685E070C461B43374C0BB294E8141355D293B3FAA886197F526BC379A8C182AAD0FD6643CF41F3940D300D000F1C7C6743276B64D73A564BD2F336E08F62962D41BD49691EA6E454DCA8E6E3E334ED521BE004280095D59A29E34';
wwv_flow_api.g_varchar2_table(728) := '93753DE60288A876865E5979EF90222D86F8EDF410810B01A9E3A152EA68EAAA0B3D8DD5A366E1352106F663A5808696B0C7B22A13C3AEDC9B68D09FEEBD6AFFB40B75058006883FBD4331751F17BA876D0F1A2C4F1429151B24D3A79D24DCB017010D77';
wwv_flow_api.g_varchar2_table(729) := 'CB0DA14D8D042D8F500389F9A121C21F6286C59E8F111D7E63D541870BC751750549BEA061851073689D7D13070DA1960CFC1ECB3D2D31303727F413BD5F9B4E26E48E01DC00D000017183D3DEA8D4974BD823F27DD926F50667A36C6F9425E70687ADB3';
wwv_flow_api.g_varchar2_table(730) := 'D28E620A8315BB95886E857238F383B8685B4EF78F923A3D2C2E132DDC4AD1C2F2DBCC29C1871235EACAD41DFF911FB0309E50FB4FB081D2C5E82182FF50A01311787DDC57B8C7DB3B46541762081E653F86909DD7113396EC07761F3F1820F4273FD406';
wwv_flow_api.g_varchar2_table(731) := '2936D486E75DB84D4200344008D0D03B6AD697CBE6FB328686356E0853727CE2CC22D5FA869D086888CB0DFEEE2B1D3D44583EFC067A486504F44EE9211C2654A98189E09F3E127448C00A66082B28882144E7286A743A7A1B06A1C010BDC1520F0D7EA5';
wwv_flow_api.g_varchar2_table(732) := '8110C3B6B7A4AA82BD19C6B09E0A02A001428A5F2367AB5E7BCBE490D6AAA88BE4FD1B3CDFA72D7F8FB64A1A99841BA218A213C9101F63E59DD3839C0BF29E4A8F24A2A0412BC98CA5B198BD57328F15E61C1831388E5757082E9A3A145E96DE57353168';
wwv_flow_api.g_varchar2_table(733) := '2B0A21A0A0903D6A6625041D433434D09604FA53F4438D7F8B272DAB016F06088006080812FD930E8506134F52948853A4961BB8FD1442C322E940661843CC460FF118A29B6EC60688797D236675BFD6FA462CB674710F9D31B5241191475A5090758EEA';
wwv_flow_api.g_varchar2_table(734) := '414A171A249B2679C6877D4785B1429C418984C4C0E918AADE4F2EB680FCEADCFE1AC3BD1102A0014211D3C9A4B16BD6DE15EBCB45CC0D6BFC30854E1A2973433364B0423F5BD18A5B78A8059A17B564F931E5BC2FBE1173BA5F2F2E6773A1B83B7F4C2B';
wwv_flow_api.g_varchar2_table(735) := '7606FE62C84C046B46A87D17BA72278265445D211131F05286BD08298368E544CA0C7B98189A7B35D8340101D0001116C3AB7E7DB95C5F2EA124F586086E905662AA059292EDB48E1EF6E2A34378ED214A03912A55A8EA0DF5806F443D35DF88996142C7';
wwv_flow_api.g_varchar2_table(736) := '16EE47F6BFFEA64C4E158B1146C46085C008AB0E175CF982F8226B58C1C785A84E049F91C490A025A19898A838DB95DE6113C62C21001A2022A2FDB1515FC1DC60AE14CD55911BFC5685B8DA8A47876D7DB742903B54C3E861AFDAF63256F9A12603C487';
wwv_flow_api.g_varchar2_table(737) := '39B86126C898750434966FC45DD860C74BEDB6CF54C8E3CE9C31E397229494A02406D6069271A14B535B5DA8872B1C03C205ED0E2A0531EC57B4D0103263B9877F6D7FB2263F86703F840068808888C9CF517DD9A8AF94EA081ADE172DB7DE6089DCE078';
wwv_flow_api.g_varchar2_table(738) := '12075EE5B019A572906592553975E8B097A0F620D3C3DD3044B86062BE494E55EDE1CE5773A5C11631EC2866818614D0E1D05266849053E9002DE182040D222646C91B030A47E53A09F58065458486A83203FBD9349AA43731C4A6D1ACD000D506088006';
wwv_flow_api.g_varchar2_table(739) := '88B0E81D75AA6FCBB577B843C19A146B344B041D0C9CC432529EAAF0BC1CC4B5DA8D1D353A0493DBB81D5BFAF0416BF6E0DF5B0FE44CDCD4D07E64846FC4EC1B3492CB23689B432D8FF82D84F135B917C5EC33A271E735C28738A2F940215C707FF5540B';
wwv_flow_api.g_varchar2_table(740) := '8AEA826A324267B47010344053C87A14360CE17E0C41E7C7BD2ACE1D4E8AB45B6EEC189D6FCEF486BA39913B02681A20001A20C28A0DE37163C7AABC2C982B259C041D48AB82A923AD55020DEB86EF362D0A1D7C74D8AEF0D98CA28796C00D7C72B587E4';
wwv_flow_api.g_varchar2_table(741) := 'BA07E5835A47AB8750A4BA86A1E38C19A6365218ECE4B51135991EEE0F4C846A2C66953EC458D2311B55E82D3895D290105C08132E1CC487866A3AD0B0C7462B493FA2EAFD2436B6CAAD83FAE8BAE7D717A0CE0001D000111983F35E7DC5A8BD29625124';
wwv_flow_api.g_varchar2_table(742) := '4587952237876948EAC80874D832B41A494DE1A115CC3DAD7C72963A44FCBE0649EDC7C7945ECE30F6999E3984DA3182A49A3066A1815A2017EC45910A4344A73F98AAFEC29433111C2E84B24255DF8C888B0B0A6808B56F626586ED0AFA48FF478F983F';
wwv_flow_api.g_varchar2_table(743) := '92ACF54F5AE8C1C12F3040990102A00122464CBBDF9AD537A5DA5B3A4951A6250757DF60F812877074D812D161AB12517BD8D5B72D22E921720A2378CFFD904EC635AF8C37A3916629C28389B86C91643B9752633167DD62CE91D1D45841353619347E96';
wwv_flow_api.g_varchar2_table(744) := '70E193A05A081B8838086A17421D1734ACA08006DD68A52865C03F7AE44789184513BB68F206FAA99FFE07FE8F10000D108982AEB3FA356EECDAD5D7841B564AACE4F09E362CCA8C1EA840D283063258216FACA00E92BCA983B030D3082B3F282A10D5C8';
wwv_flow_api.g_varchar2_table(745) := 'C90BA9FC106D05113393162A521AF84CBF20B100A7CB64958C10C2087FA08F0F1073E2C2575575E18B9E18E20F4FCAD0102A6C4C5460884D0CD48F019B3F72350667BBD2FA581F7F1FF2370108088006885050984EF9DF8EBF8FCCF795EAEB62F54DB1F6';
wwv_flow_api.g_varchar2_table(746) := '96983EB156055E5161BD2F0B8315EBFE4066702653EDEBC0AC1D84E6456327209C54D71EE2D1C35E8CAD9B8BE4898E5A3C91826FC46F82098DE7C48C5D92E4BBC5639528CCF9321414140BA5DC8CEDCBD409317E8E576050D9308412C31E9EA5C4E94920';
wwv_flow_api.g_varchar2_table(747) := '771934B4B0A153A5B1571B5E76A41B027903440D10000D101A68E0EE14ECFF7B872DCC0DAF8A35C40DEF8AB4E4E0752B8840B2CC8D5748F46004273315F399310D1EE22828E3B73094539DF133193DF01BC03D80A809B9A0A6462452DC4DB922880B210B';
wwv_flow_api.g_varchar2_table(748) := '42EF932F85665735AF5A8862059DE342FAB8109B187027C2AD3DEC10EBE8DD7AEFB8CDA40CCA3B03044003BC0410BABBC354B84D4C9AFB56ED4DA9468A0D881B70C981D51BFCD90AAF5BA1143AD87A7410150F3C3ACCC810010788580C114909DABF92AC';
wwv_flow_api.g_varchar2_table(749) := '8B5153A92C6B8901E2E3C2966BDC193D84DA51446829F487FABC84F139841202D21097BA043848BA8572E67E84CC0AC9A081E5B681A161BBDAF9EC4C27231D284C811B20001A20E2C7F4D76D63DF365E16AA6F0AF577B8E4507F5B426F9854E8B0EC961C';
wwv_flow_api.g_varchar2_table(750) := '283A703D0BBFF0B0A11FCEDC546ECEAC2824937CC6AE40F0A6FA7CCE5C996825028859E596AA5950091D02EF949E6BEF725F578A749258809930359C11412D4197851875857650E778A062822868686959218C125C5630F09484DBD1C33A06F23342F75F';
wwv_flow_api.g_varchar2_table(751) := 'D3F7B40FCCF18FC12D0C5742003440A4810CF4C963E2ECD42B881B5E1770BD814A1CDE1529344885074B9249F20D0B6F7B851E1D047A500D5CA40110AA91CEF8A97AC88BE086F98635E61546DC59A122E592864633F1A9D6F3B3AECCC8D245F7B3D6DA39';
wwv_flow_api.g_varchar2_table(752) := '98B116557F5482C21C35866868A8C44A1F1AFC9F0BECC7B08FB9A1B9C75C19A6A05D8000688048B16D31198FCCB52AE68637C5EA6BB74F41A081020422068B6A1D58CFA2CC5657AC9585F9CC35412FA9934C2A440F4C3B19B0A94EC4105184A1038594DD';
wwv_flow_api.g_varchar2_table(753) := '2352E209054968EDAA740CA1F3B34ADF5D3B0C4A66D758C410664A958CB0CF237F25F1858D6AC785A4C311EA151289358F7E4BC2FDDE660B2D7D3F06034B20F7EBFDD30E7D32F045D01010000D102970C3CD74FC73545FA994FFCDD7DE96AAAF0B955705';
wwv_flow_api.g_varchar2_table(754) := '3655F10E772B8486856025C9151E023B2C141E0F1A9328878706796E3386EF645A294F7024EC71CC33029A8A51D522C8200D98F00EE93B5560043E672244984BE118DA9BD0CF52862DB9F6DC549B6EB658330E7F3C020562C940B861CF68EC56FBA76D56';
wwv_flow_api.g_varchar2_table(755) := '4B04D502044003443ADD09BE6879733BBA1AD4968DF28B42E5751143C3EB62F555817243CD0308B76751E79592FC88263F6DB12E4B267DE1A4AA7F11A83DF05BB9C5D1CDC59184BAD3514D3C057A87001158C0C10EB985571A522A4BCCB5B29C6782983E';
wwv_flow_api.g_varchar2_table(756) := '0A092A0AB5192B0A3AC331ADE0D1F353D77A303068D8E5A061AF86FF8A575D60EFAF36762AFDD3E6ED742C3E1B40B10102A00162EE984CC820967B3F195EF5ABEF0C0371C3CB42F56D09A143E5952F74A0496A0F25ADE241490F6B657F9F050608AF7F11';
wwv_flow_api.g_varchar2_table(757) := '218008CC5F5412E5BCDC30BF0D76F81C47DAF28898B6D99D58858A3819D9168947120711E30933E8366251C2C7A8EE434A1722747F440CF982D44DF38A0D3B55B6BB72D768EDB3B5D78DDD6AF7B0399D8EA0C60001D000B1987A83F80432B81CD4570837';
wwv_flow_api.g_varchar2_table(758) := '9062032B39D0E4D001EB1E3CB1E4B23CA529CD6AF20061AD1962F3A22C5420740CA1C308BE97E1A56AB0331DBC88145ACE369A111326925629160C25C1FDA2F29651DDDCE907E9B4BEBBE2075F4510DE13678354F24E4440BE20ADB48EC70D4A6820360C';
wwv_flow_api.g_varchar2_table(759) := 'B4FCD0DC335C62A875BF3A935F13B9FF080101D00091528742F1CED155D75CC5DCC0A0E115EE5354293DBC11AA0E123AC88A07269954A2834AFD20C927E38F718667127A8805106A74A846E75EE2D646A26C2F5298B9B80A878E3FC256992B3F8FAEA7C0';
wwv_flow_api.g_varchar2_table(760) := 'B3020F0773B24262C123258610B28C0D0DBB2E345095032936E01AC357E7763A9AC6FE498780006880482746D74373BD86B9E12DE2867CE565BEF6BA4031C2AF3AE02C60C5830B1042E7C22F3F508BC9320508593BB91AC00861E1856A4F77644D22A22C';
wwv_flow_api.g_varchar2_table(761) := '110F2676924C6DF0ED8CF823A0F3F846F03589544A147762BCBDE08C7FF6CF5A51D84FB2C35A9949872ABD7109E20FDD3AA835BD314BF4CEED726BCF68912555DDC3D6F417081720001A207E1B370CAC8D5AF99F3C9535545EE42AAF70E1A1F25A283C60';
wwv_flow_api.g_varchar2_table(762) := 'B1245F7BF0440F0A7AE02636DF976501C46A6811625D6F431909101E4678D39E3AD1658863C4F6BC9ACA6602978838A7481CAAA8B0DCAFDEEB4CFBE17E519F5FF709174D0C3BD88FA1F5A1DA203D08BAC192CE58A27F9D9A9BE19DD792F2110202A001E2';
wwv_flow_api.g_varchar2_table(763) := 'EE82FA37FC1C3576ADCACBA2F16F1E91012206E365BEF2B2400592158A0EAF8AD5D7C4E0E18D287A50D51EFCB10BBFFCE0FEBA5A8AAE40AC6930422409B9C1E171830E2FB6F495099569047D670A0612F35851C52A4B441346ACB6484A6D9407CF2591AB';
wwv_flow_api.g_varchar2_table(764) := 'ABF763BE864988815614763829037DFFB6D1DEAF6186D8AF0FCEDBB737400C10000D10BF9518D848C5F4B6FDB9597955C4D2480207181D5EE4A9D601F1044A5678C0B58782D7BC5001445100089D7C52598490ECABB51861B02DDE2AA450082636E39B57';
wwv_flow_api.g_varchar2_table(765) := '1A2AA1657A939FBB61392B4F541266F561671C5899030E7E032E301143D563053C2841DE6EE34A43B575600E2E3AEA65541010000D10BF0720A6D3C179AFFACE28FF4B58E14D89A0034EC20D059642ED8143075DF9415D81F030A2EC653843C4AB4694F5';
wwv_flow_api.g_varchar2_table(766) := '2411DDDD50773414031A6A85C4ECD5883074A88A8BBB94D2CBD41670DCAF8CE7D73973F921123E9250C2AC00273996EE510727CFFCB1DADAC19BA8C6DFFBC25A09503B42003440FCB64A037F03BA990EAFB0C4C1785944E840A62A8A645D05513988DCE0';
wwv_flow_api.g_varchar2_table(767) := '372F3CD5A40E20540208850C42C488B05244384F684512B12B10B28B65E4E0C6026C24823C9152A122F15F8FA7F68FFCFC4933BA53335F37644668D8539A35CD50EF098E4B10E1C28E413F6763A7DADCAB77BF36267877A54F0CD31BB08B86006880F8ED';
wwv_flow_api.g_varchar2_table(768) := 'E8C0C5643C6A1D38D53765EAFEC4E0E0655E60859762FAE507AF7951D00184DBC2280619424D12EFC5D94EDD74868711B160C298456BB91596A1CBC1170916F17A1F0F2EA304A471D161364D469A0D88246506B73D81FE45135B44F3B2C729D41820001A';
wwv_flow_api.g_varchar2_table(769) := '20EE59B873DED3DE51A7BE62B84090AFBCCED35605CB970545F254F15A53810874318446C6BB180CE11724E261C46A542942E71B81DF4332AD82849627E46C06673A74B9F37833D8A3511CD8D1DD8AD9049B774D0CBBC24AAACE477374DD558818001A20';
wwv_flow_api.g_varchar2_table(770) := '001A20EE233A90F2E7E4BFB1B36B192F0B282B6F0A2E31502670872C48D5A1FA8AF52FC8268B22030819238AFA464689A4FB46284344C084BF2983E46A6CA165D0374209139B713362EC73D66687D26A42998B38C8E35447F45F2A37A29254E1A16D0470';
wwv_flow_api.g_varchar2_table(771) := 'C4A05908A28506B5B8A1921616F81310BB154EE158697DA0F31186A75DC0C3963BE89F26BCB85BEB1DB5A7639892800068807890CD8B49EFB85D5F31CA2FF2D5D7EE3CC5EBA2F1926DC834586382133DBCC059F5F042E406191D5C7A503532303DD4DCF5';
wwv_flow_api.g_varchar2_table(772) := '9B9118A1A787506D84D4C850EA21368474A4F4473DE97BF49BBAC48C6E73C4C588591A2273A711FBEBB9736898C56DB3E2E75E25B55A42001A885353857E854D77CF35FD9AD18BD3F96C8D2EBBB7BF801820001A201E649382FD6EFC63D8D8B58D7FF3B2';
wwv_flow_api.g_varchar2_table(773) := '28920C50F0ED096FCE827D982AABC17C2D8F71FABD0C952422B2A311AE8DB0D29AD4906062BD2C70C30CCE54F1F4138D05A50E3ED2FF9CA1DCB01BCE0D4926487F172E044B0EBBFE7ECBF65E8DCDBCEC55E8022A6ADCD43B698E7F705312D08980006880';
wwv_flow_api.g_varchar2_table(774) := '78380586C01BD3E9E0B463AE568C7F0B5E9302971C5EE47D69245BB4CD1C1D2A0953E103C1925B87A123098127DC8C608878631ABA5EC65ADC694F27323793E75674363613A6EEE04FFAF1D1DC90ACD8109B1B2A09CDAC2A7791D257CE9A11ECB78D1DBC';
wwv_flow_api.g_varchar2_table(775) := '4BA2F3D5C105869B49D80F2004044003C47DE7861B0F18D87BA6FF4D3A5F5AB5652C902482867CF5AD7FC073F586C4C4105D909049C2AF495435FACA5AFC010DD13182C144FC394F0A0A91339FDC7E0DCF844AA3C19C0F29D2CDD0AF211E3104DB16C98A';
wwv_flow_api.g_varchar2_table(776) := '0DCD3823A0893DACEE0417383503CDB6AB766C207438C0231293FF46D1F80E0101D000F1802A0D536EDC6BFC73D4FC6057DF962837545EB812488E1B82760E293144D1CF204690AC69E73C4B31EC22CA7E06DB1969FA46E873439D4E9CA2C51D64226E10';
wwv_flow_api.g_varchar2_table(777) := '282149B12172A9C75EE54E4B05BB89FF96FF35D31512EE6FD91BFBF5DE6173FC73E0FE80012E400034403C2E8690840EA3EB0199ADF059811DDB29551A9294228ABE3DE56B7147464423432389083A572A1C2384694F3CF019CE132252685B1E2942C67A';
wwv_flow_api.g_varchar2_table(778) := 'C25C3837CCDBA4882839243EDAA30A0F33630A374BC997195A64A95863AF86FB11D7FDDB9B298002044003C463AC37DC061E875C37C9E1C5C0DEA8A2B3198B1B5CFD63F595667A22F4EC77DF5354653C9260D319053FDFDC85B252CAD8958952F4E2AEC8';
wwv_flow_api.g_varchar2_table(779) := '5C4F2D9D8DF00C4243396E93424D0FDEE8A6312337CC5B12886A55EC2A8EFF24060CBED5B70B0DD5F6416DF4BD37F5E6236E801820001A20FEBC189CF5ED2DABF29A98487AD310AFF2D5D7F9EA1B6CF4443592153AABF9B2E82EC1723595EEE445C294BA';
wwv_flow_api.g_varchar2_table(780) := '156ECA85078D06225256C90CB0F94C38F319EA6829BC7FD5CF50C8F092E30C55196316F1A6B61BC271435265431CF72A1D3424B28CDC4BCD063B720802FB3DEF55B83488E982212CB946FF5D7BE5D67EB9B96FE00F40B8F0D91E5EF614D5050808800688';
wwv_flow_api.g_varchar2_table(781) := '3F2BDCDBE0F0AADFD8B5AA6F4A1E3A60F3E99779BCF8EA35210344126F4B5E17C3DB5BA11DC554A70A205E8BD0F03A0C1A6ACA4CC40D331B4F4555297C5B2A2995D0B09A101AD6EF2D3418F342C3EEC2A181173336F9DAC33EAF63C0FF2D8C2DF6ABD865';
wwv_flow_api.g_varchar2_table(782) := '6BB7DAFD6A8FAE7AB7D309941320001A2020DCCA2A7B84C25A87E607A7FAB65C11AD1A58F981CE5CB0528434AB99141A788F87824E17E911432D3CE342830620421922422AB1120F20564B6A6E78ACD0902E3ACC9F52178395370C3642294D49E037CCEE';
wwv_flow_api.g_varchar2_table(783) := 'D7E6F8BACF70010202A0010242C310D3C978DCFEDA34D7AB066E437862C93C82065C81784DC62E183DC46943A86A0C715821B2C010031A62734351C70A66CC4C060DA51062B012AB1F8C8540431C6E60D0602C6817575ADB3ED94229FE9D3B0649060DCC';
wwv_flow_api.g_varchar2_table(784) := '427BB7DAFE68F68E9CC978E4E3C28D6A3E020202A001E2CF4404A1E4C0372E7E4D06E73DDAB3F0C732092EE086C5EBF82D8982AAAEA04BD596AC9958414F0C090A0C5A3288030A71A0616DCE3283BC6B6351D0B0A52B36C4808639D0213568502831AB6D';
wwv_flow_api.g_varchar2_table(785) := '42126CDDD47EBDF3C5199C77A66C99F554D5CA0376800068808050362CB85BE5F8E7B0F3B569AE558D1705227160E9BB36BD4A4203BE53A4624A621EF9420241436C5C883DC0A9AC2EE88490A5941A13C6C2A1614BB4A356708391801B767E1B34087F11';
wwv_flow_api.g_varchar2_table(786) := 'AF04ABA26C925F5B0766EFB031BAEEF19BACA7D3A900D62081840068808008561742DE3FF935195E0DEC6DB3BE52A9BC227AC997057A90D3B6C52CF9469B33B2C2BB801D751017EE0C1A046E98B531F16743435AC9C921ABCDDD5A73AFDE3AB0DA9FECD1';
wwv_flow_api.g_varchar2_table(787) := '75DF2D2D28631AEB87050202A001E28F46871BF52D92DC41A7939FA3FE71A7B16BD6DE96C966ED422D2E22F093934988E14D0262F0350A21C41047F9B89C606822617B424B0C49A0C1B82368D8524383CB0D09A1E1377103D63CD27DD6FBB5CE671BDB3F';
wwv_flow_api.g_varchar2_table(788) := '8F07888405FB542D134C011720001A2020E6E58CF178D43DEED8DB66E59D41A62D8A7473263EF83125E46BAFF3D5970829D0A95FA2FA47FCC61B3CB7893883A2468D22C25B52B1C07C50A8BD2DF81CF0266E6981CF7A48EAF880E61CB2C728F16384D1E4';
wwv_flow_api.g_varchar2_table(789) := 'CC1E509C2964686EF289CD9D92EDAF52CB21C5DC89931A8CD8617E0972AF618FEF3B545B3B2C71C1608726AF6DACB4F1C79005D6FEE7319A7B15C4B8EDCFCEE0BC8B158ED06B8000688080F85D319D4E26FF8DFAA79DD647C75CAD54C8A805A681D7C59A';
wwv_flow_api.g_varchar2_table(790) := '5B3390FA11E8FDA43E811902FF2919DA247C50227F852389487448440CE1D0B0F220A1C19E051ACA32346CCEBA7A3B313784971FB80F53D70CA845635569BDC0248DF84F0955A037F6EBDDAFCEE0B435FD6F44240B5318848000688080F8CDD8E0E77432';
wwv_flow_api.g_varchar2_table(791) := 'BA1E74BFB59C6DB3BE6C90C203B37920673C2B3FD4DFB90D08C20A75AC5864F4E043832B630C8786FABB8439B3A1530C68B07E1334C4E2864D75CADC100E1031D1613B3934D03F952C9F775DDF46051C945BBB65BF38E13A3C36762B8D3DAC6DEC1E36B0';
wwv_flow_api.g_varchar2_table(792) := '29D3AFB14B09C00A10000D1010F72DBCC2EFCD74F47DD83FED36F72D73BD5A65404009A080B8A1463B117CBE2DD4BDC6842068600C910C1A967529FB3585B936CD66C9903A34C42F3684A3C3668C7AC3E6ECDCD098ABE460F0DC406B06D49FD12B42B4F6';
wwv_flow_api.g_varchar2_table(793) := 'A8D933B676F67751E20FAB36F76A0814DA9FACFE797BF4A3777B0345050880060888075A88F885CB0FBDA37673CFB2DE57704BE215EE23B056C5BB022E3C205C789347D0E0C918052C5826D5082F63551416030D738A1FEF1F3484A1C34CDC20D0437C74';
wwv_flow_api.g_varchar2_table(794) := 'A005838058B2B56DB82E4C24775DE9C3361E82687D303B9F9DFE716B74D50B198298DEB83AC79B70C123040440030444CAB584F9FE3A0288AB011EBED833ADF54AF55DC9173ABCC500E1CD4AB8DC407591857AD24EC47268AE08B9106248171A9272C37A';
wwv_flow_api.g_varchar2_table(795) := '14376C2CB0DED09845206934452B059A9EC29156145A7BB5F641BDF3C91C9C744697BD29AF6A0CFA36021C40003440403C1AF2984E27E31F43AAA0B4376BF5E572F53511376039A4AB63C0DA465A8D480F1AD4C4501433EE98A54C09BF0F1A6271030F0D';
wwv_flow_api.g_varchar2_table(796) := '1B8A7A835AE83067BD217ED5C123866D26696C6C579B7BF5F647ABFBADD13F6D73B60AD364DF6F30310101D00001718F20E026F95F117E3B9D8EC7A3CB7EF76BA3F5C1B2D72BF5E512AB34506878BB1068E00A092A625849480C0B858619B821121A3616';
wwv_flow_api.g_varchar2_table(797) := '0B0D0A6ED88EEA53E00FA8B43FD4BA5FACFE913DBAEE8DC70357A3405833D6B717200204400304C41F135384103F47838B7EE7B0D5D8B7ADCD3A1E897C57A29A06F31DC965F46BC14304D3CB77E4FDCB058D94C1FD300A0ACB0C14EA4A4A5829592B456B';
wwv_flow_api.g_varchar2_table(798) := '8510007E037F247EE33DCAB29825F606FE2B3E37D82857CBB6E00829393B95F8B4F95C57A4B3564E960A86C0A64F8D8DB2980649DEC841C8E656C59FADC054516E6C9589E95325C0106567BBDCDC224959618B660527FA238F12B6F18E2866B77060B7BF';
wwv_flow_api.g_varchar2_table(799) := '347AC7EDE1557F321E092ECE101010000D101031F981F8F14D263F87A3CB5EFFB8DDFEE43476EAD67AA5BE52AEF13B2ADD894A66D3B4EC03018303CA13940C96B9142A0DAA3E85801145F7EDA232AD555D7AD020BCDF5E2DC9C9A041576F88A00A0C161B';
wwv_flow_api.g_varchar2_table(800) := '25B5F871A3C4A552F4404D9FCA3E161020C0DC4098432E3C609830C887B9C9A1839F0C297021C1D9AE36766BCD0FF5F667BB7BD8189C75C6DF7BCC9CD19FDDD594A32020001A2020206641895F93F17834C44319ADCE974673DFB2376BE62A2209A3FEAE';
wwv_flow_api.g_varchar2_table(801) := '8C12D1006608AF32C10A0C05D3AD3D50A4C0350399128A1697DA0EC5AA944537E53F625504171A6438207508456A3B143C1F708D898D52C2E49062C3AF2E34364B5E3A38DDCE858705AC7FE1A200A928049A171507E53643043CE3F0C5EE1F3707E7EDF1';
wwv_flow_api.g_varchar2_table(802) := 'CFC1F8BFD1743A860E020404400304C462E2C6AB39048F1ADF576AFADF78FC7D3038EFF58E3BED8F0E220967B366AD1AE64A991BB3246A86E5427DA56092C46FBFCB0B0509091A0489835B54A06D8895E0D004D7B3E0B50B810FB659F3429331550E5172';
wwv_flow_api.g_varchar2_table(803) := '074797C19203A3811229331062D8E0B9A1E86CA12C35B64ACE56D94DAF7F51C18AC5DD7AFBC0EA7E717ADF9AFDB3EEF0B23FFE319C4EC6E12244B053808000688080B8271589E9F4D778321E0DAFFAFDB34EEFA8D5FE6437F74D67BB66AD55CCF7659C2B';
wwv_flow_api.g_varchar2_table(804) := '24D91BF298A5B5CC151EF0615F64A7FE8A2635E3973A38709B1445B943A16858E074E46410403F52F8A375924A71038186869BEC23710ADD0A7FF7D5A66153384094B05D61C5834F36E203F4AA0E2FBBE31FFDC984F834DF4CE26280249E05FB04080880';
wwv_flow_api.g_varchar2_table(805) := '060888C5151E66F900FAC88B07FAA7B7BFF0BCC6F8FB7078D11F9CF6BADF9A9D2F0D5A9F68EC98B84481A9A262AD94AD15172C383D044712F172B5C065D15A7393533CD86BD1E9AC15BDB46912E6E0DFCF73830235D6E9FB691DC21012F1C156B5B15D6B';
wwv_flow_api.g_varchar2_table(806) := 'EE99AD03ABF3D9E97E6BF48E5B78D6F1B23FBE1E4C7E8E70E560CA6F7D8432010404400304C49F5A9AC06071439A1DBFC6E8801C5D0F4657FDE145AF7FDAE91DB7BBDF5A9D2FCDF6E746F38385F162CF6CECD49DAD9ABD59B5D62B28CDD532CBF77CEA87';
wwv_flow_api.g_varchar2_table(807) := '36BDFE85DA1E2A309CE9092AA59DDAEEC7D86BE2CAECCD8AB35965F2C3FD3AF65AFE68B53FD99DAFCDEE610BFD170DCE3AC38B2EFA6F1C7F474C40BA09BF10164C70CD80BE14B3715BF0850585230404400304C443AA4FDC048FB1695839FD26D6A79DE2';
wwv_flow_api.g_varchar2_table(808) := '26C804C77FE3F1CFE1F8C7101DC088368697FDC1456F70DE1B9C7507C79DFE71BB7FD4EEA1A3FA5BABFBA5D9FDDCEC7C6E74D0F94DF3A3DDA67960E1246FA377FA1FF0D9218FFE4D9CE8931CE123BF7FD24634830EFEC1596F78DE1B5EF44757037CFCFF';
wwv_flow_api.g_varchar2_table(809) := '184E7E8EF0ECE2AF094E0401D3E95C064737A11C00CD050808800608080808080808800608080808080808800608080808080808800608080808080808800608080808080808088006080808080808088006080808080808088006080808080808088006';
wwv_flow_api.g_varchar2_table(810) := '08080808080808800608080808080808800608080808080808800608080808080808088006080808080808088006080808080808088006080808080808088006080808080808088006080808080808088006080808080808088006080808080808080880';
wwv_flow_api.g_varchar2_table(811) := '06080808080808088006080808080808088006080808080808088006080808080808088006080808080808088006080808080808088006080808080808080880060808080808080880060808080808080880060808080808080880060808080808080880';
wwv_flow_api.g_varchar2_table(812) := '0608080808080808800608080808080808800608080808080808088006080808080808088006080808080808088006080808080808887B13FF07CE5A534A689765B60000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(15549598464922305627)
,p_file_name=>'Mushroom2.PNG'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(10194552141762177)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'LEGACY'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(11160895370762560)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'classic'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(15549418916778462533)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(15549419082447462536)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(15549419132140462537)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SELECT_LIST'
);
end;
/
prompt --application/shared_components/security/authorizations
begin
null;
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_processes
begin
null;
end;
/
prompt --application/shared_components/logic/application_items
begin
null;
end;
/
prompt --application/shared_components/logic/application_computations
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs
begin
null;
end;
/
prompt --application/shared_components/navigation/trees
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/comments
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(15549462949651463653)
,p_name=>' Breadcrumb'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15549463296816463672)
,p_parent_id=>0
,p_short_name=>'Home'
,p_link=>'f?p=&APP_ID.:1:&APP_SESSION.::&DEBUG.'
,p_page_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549419377909462635)
,p_theme_id=>42
,p_name=>'Left Side Column'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.leftSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft t-PageBody--hideActions no-anim #PAGE_CSS_CLASSES#" #ONLOAD# id="t_PageBody">',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" id="t_Button_navControl" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'    </div>',
'    <div class="t-Header-navBar">',
'      #NAVIGATION_BAR#',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">',
'    #TOP_GLOBAL_NAVIGATION_LIST#',
'    #REGION_POSITION_06#',
'  </div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'#SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="t-Body-side" id="t_Body_side">',
'      #REGION_POSITION_02#',
'    </div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      <div class="t-Body-contentInner">',
'        #BODY#',
'      </div>',
'        <footer class="t-Footer">',
'          #APP_VERSION#',
'          #CUSTOMIZE#',
'          #SCREEN_READER_TOGGLE#',
'          #REGION_POSITION_05#',
'        </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs">',
'  #REGION_POSITION_04#',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'        <span class="t-Icon a-Icon icon-user"></span>',
'        <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'      <span class="t-Icon #IMAGE#"></span>',
'      <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525196570560608698
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549419403956462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549419506778462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549419680150462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549419736018462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Inline Dialogs'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549419845757462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549419945325462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Page Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420069563462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Page Header'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420155612462672)
,p_page_template_id=>wwv_flow_api.id(15549419377909462635)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549420187316462691)
,p_theme_id=>42
,p_name=>'Left and Right Side Columns'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.bothSideCols();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft no-anim #PAGE_CSS_CLASSES#" #ONLOAD# id="t_PageBody">',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" id="t_Button_navControl" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'    </div>',
'    <div class="t-Header-navBar">',
'      #NAVIGATION_BAR#',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">',
'    #TOP_GLOBAL_NAVIGATION_LIST#',
'    #REGION_POSITION_06#',
'  </div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'#SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="t-Body-side" id="t_Body_side">',
'      #REGION_POSITION_02#',
'    </div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      <div class="t-Body-contentInner">',
'        #BODY#',
'      </div>',
'      <footer class="t-Footer">',
'        #APP_VERSION#',
'        #CUSTOMIZE#',
'        #SCREEN_READER_TOGGLE#',
'        #REGION_POSITION_05#',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Button t-Button--icon t-Button--header t-Button--headerRight" id="t_Button_rightControlButton" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent">',
'    #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs">',
'  #REGION_POSITION_04#',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'        <span class="t-Icon a-Icon icon-user"></span>',
'        <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'      <span class="t-Icon #IMAGE#"></span>',
'      <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525203692562657055
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420378026462691)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>6
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420421903462691)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420561702462691)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>3
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420599899462691)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>3
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420748703462691)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Inline Dialogs'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420851147462692)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549420909913462692)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Page Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421020607462692)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Page Header'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421089065462692)
,p_page_template_id=>wwv_flow_api.id(15549420187316462691)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549421244566462692)
,p_theme_id=>42
,p_name=>'Login'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.appLogin();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="html-login no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="html-login no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="html-login no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="html-login no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="html-login no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody--login no-anim #PAGE_CSS_CLASSES#" #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #REGION_POSITION_01#',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="t-Body-wrap">',
'    <div class="t-Body-col t-Body-col--main">',
'      <div class="t-Login-container">',
'      #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>6
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2099711150063350616
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421360380462692)
,p_page_template_id=>wwv_flow_api.id(15549421244566462692)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421464477462692)
,p_page_template_id=>wwv_flow_api.id(15549421244566462692)
,p_name=>'Body Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549421509998462692)
,p_theme_id=>42
,p_name=>'Master Detail'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.masterDetail();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody t-PageBody--masterDetail t-PageBody--hideLeft no-anim #PAGE_CSS_CLASSES#" #ONLOAD# id="t_PageBody">',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" id="t_Button_navControl" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'    </div>',
'    <div class="t-Header-navBar">',
'      #NAVIGATION_BAR#',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">',
'    #TOP_GLOBAL_NAVIGATION_LIST#',
'    #REGION_POSITION_06#',
'  </div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'#SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      <div class="t-Body-info" id="t_Body_info">',
'        #REGION_POSITION_02#',
'      </div>',
'      <div class="t-Body-contentInner">',
'        #BODY#',
'      </div>',
'      <footer class="t-Footer">',
'        #APP_VERSION#',
'        #CUSTOMIZE#',
'        #SCREEN_READER_TOGGLE#',
'        #REGION_POSITION_05#',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Button t-Button--icon t-Button--header t-Button--headerRight" id="t_Button_rightControlButton" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent">',
'    #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs">',
'  #REGION_POSITION_04#',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'        <span class="t-Icon a-Icon icon-user"></span>',
'        <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'      <span class="t-Icon #IMAGE#"></span>',
'      <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>1996914646461572319
,p_translate_this_template=>'N'
);
end;
/
begin
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421679593462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421732328462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421844678462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Master Detail'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549421969374462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Right Side Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422040238462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Inline Dialogs'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422113027462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422191247462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Page Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422301274462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Page Header'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422451171462693)
,p_page_template_id=>wwv_flow_api.id(15549421509998462692)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549422537453462694)
,p_theme_id=>42
,p_name=>'Minimal (No Navigation)'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#  ',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim #PAGE_CSS_CLASSES# t-PageBody--noNav" #ONLOAD# id="t_PageBody">',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" id="t_Button_navControl" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'    </div>',
'    <div class="t-Header-navBar">',
'      #NAVIGATION_BAR#',
'    </div>',
'  </div>',
'</header>',
'    '))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  <div class="t-Body-main">',
'      <div class="t-Body-title" id="t_Body_title">',
'        #REGION_POSITION_01#',
'      </div>',
'      <div class="t-Body-content" id="t_Body_content">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-contentInner">',
'          #BODY#',
'        </div>',
'        <footer class="t-Footer">',
'          #APP_VERSION#',
'          #CUSTOMIZE#',
'          #SCREEN_READER_TOGGLE#',
'          #REGION_POSITION_05#',
'        </footer>',
'      </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs">',
'  #REGION_POSITION_04#',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'        <span class="t-Icon a-Icon icon-user"></span>',
'        <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'      <span class="t-Icon #IMAGE#"></span>',
'      <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2977628563533209425
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422605205462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422768552462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422846539462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Inline Dialogs'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549422956092462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423038829462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Page Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423118740462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Page Header'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423202289462696)
,p_page_template_id=>wwv_flow_api.id(15549422537453462694)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549423311709462696)
,p_theme_id=>42
,p_name=>'Modal Dialog'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-wrapper">',
'    <div class="t-Dialog-header">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="t-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="t-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'500'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_css_classes=>'t-Dialog--standard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2098960803539086924
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423458129462697)
,p_page_template_id=>wwv_flow_api.id(15549423311709462696)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423523185462697)
,p_page_template_id=>wwv_flow_api.id(15549423311709462696)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423665356462697)
,p_page_template_id=>wwv_flow_api.id(15549423311709462696)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549423705004462697)
,p_theme_id=>42
,p_name=>'Right Side Column'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.rightSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft no-anim #PAGE_CSS_CLASSES#" #ONLOAD# id="t_PageBody">',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" id="t_Button_navControl" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'    </div>',
'    <div class="t-Header-navBar">',
'      #NAVIGATION_BAR#',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">',
'    #TOP_GLOBAL_NAVIGATION_LIST#',
'    #REGION_POSITION_06#',
'  </div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'#SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      <div class="t-Body-contentInner">',
'        #BODY#',
'      </div>',
'      <footer class="t-Footer">',
'        #APP_VERSION#',
'        #CUSTOMIZE#',
'        #SCREEN_READER_TOGGLE#',
'        #REGION_POSITION_05#',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Button t-Button--icon t-Button--header t-Button--headerRight" id="t_Button_rightControlButton" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent">',
'    #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs">',
'  #REGION_POSITION_04#',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'        <span class="t-Icon a-Icon icon-user"></span>',
'        <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'      <span class="t-Icon #IMAGE#"></span>',
'      <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525200116240651575
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423817221462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549423978336462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424005229462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424158926462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Inline Dialogs'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424221637462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424364370462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Page Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424461594462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Page Header'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424546123462697)
,p_page_template_id=>wwv_flow_api.id(15549423705004462697)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549424650381462697)
,p_theme_id=>42
,p_name=>'Standard'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#  ',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim #PAGE_CSS_CLASSES#" #ONLOAD# id="t_PageBody">',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" id="t_Button_navControl" type="button"><span class="t-Icon fa-bars" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'    </div>',
'    <div class="t-Header-navBar">',
'      #NAVIGATION_BAR#',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">',
'    #TOP_GLOBAL_NAVIGATION_LIST#',
'    #REGION_POSITION_06#',
'  </div>',
'</header>',
'    '))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'      <div class="t-Body-title" id="t_Body_title">',
'        #REGION_POSITION_01#',
'      </div>',
'      <div class="t-Body-content" id="t_Body_content">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-contentInner">',
'          #BODY#',
'        </div>',
'        <footer class="t-Footer">',
'          #APP_VERSION#',
'          #CUSTOMIZE#',
'          #SCREEN_READER_TOGGLE#',
'          #REGION_POSITION_05#',
'        </footer>',
'      </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs">',
'  #REGION_POSITION_04#',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'        <span class="t-Icon a-Icon icon-user"></span>',
'        <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'      <span class="t-Icon #IMAGE#"></span>',
'      <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>4070909157481059304
,p_translate_this_template=>'N'
);
end;
/
begin
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424730075462697)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424823327462697)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549424929694462697)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Inline Dialogs'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425035397462697)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425106180462697)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Page Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425270441462697)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Page Header'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425333928462698)
,p_page_template_id=>wwv_flow_api.id(15549424650381462697)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_glv_new_row=>false
);
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15549425429088462698)
,p_theme_id=>42
,p_name=>'Wizard Modal Dialog'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.wizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js" lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"/>',
'</head>',
'<body class="t-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Wizard t-Wizard--modal">',
'    <div class=" t-Wizard-steps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="t-Wizard-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="t-Wizard-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">',
'          #MESSAGE#',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>3
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES#" #ATTRIBUTES#>',
'#CONTENT#',
'</div>'))
,p_grid_first_column_attributes=>'alpha'
,p_grid_last_column_attributes=>'omega'
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_css_classes=>'t-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2120348229686426515
,p_translate_this_template=>'N'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425581170462698)
,p_page_template_id=>wwv_flow_api.id(15549425429088462698)
,p_name=>'Wizard Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425658457462698)
,p_page_template_id=>wwv_flow_api.id(15549425429088462698)
,p_name=>'Wizard Progress Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425782580462698)
,p_page_template_id=>wwv_flow_api.id(15549425429088462698)
,p_name=>'Wizard Buttons'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15549456372141462911)
,p_template_name=>'Icon'
,p_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL#" aria-label="#LABEL#"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"><'
||'/span></button>'
,p_hot_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL#" aria-label="#LABEL#"><span class="t-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_reference_id=>2347660919680321258
,p_translate_this_template=>'N'
,p_theme_class_id=>5
,p_theme_id=>42
);
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15549456414734462934)
,p_template_name=>'Text'
,p_template=>'<button onclick="#JAVASCRIPT#" class="t-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="t-Button t-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_reference_id=>4070916158035059322
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>42
);
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15549456504586462935)
,p_template_name=>'Text with Icon'
,p_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-label">#LABEL#'
||'</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-'
||'label">#LABEL#</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>2081382742158699622
,p_translate_this_template=>'N'
,p_theme_class_id=>4
,p_preset_template_options=>'t-Button--iconRight'
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549425840235462701)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# role="group" aria-labelledby="#REGION_STATIC_ID#_heading">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Alert'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--warning'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2039236646100190748
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549425974128462765)
,p_plug_template_id=>wwv_flow_api.id(15549425840235462701)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549427351625462780)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#"> ',
'#PREVIOUS##BODY##SUB_REGIONS##NEXT#',
'</div>'))
,p_page_plug_template_name=>'Blank with Attributes'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>4499993862448380551
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549427387568462780)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ButtonRegion t-Form--floatLeft #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# role="group" aria-labelledby="#REGION_STATIC_ID#_heading">',
'  <div class="t-ButtonRegion-wrap">',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--content">',
'      <h2 class="t-ButtonRegion-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'      #BODY#',
'      <div class="t-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Buttons Container'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>17
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2124982336649579661
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549427577714462780)
,p_plug_template_id=>wwv_flow_api.id(15549427387568462780)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549427628217462780)
,p_plug_template_id=>wwv_flow_api.id(15549427387568462780)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549428356227462780)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Region t-Region--carousel #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# role="group" aria-labelledby="#REGION_STATIC_ID#_heading">',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #BODY#',
'   <div class="t-Region-carouselRegions">',
'     #SUB_REGIONS#',
'   </div>',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'    <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'   </div>',
' </div>',
'</div>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">',
'  #SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'Carousel Container'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-Region--showCarouselControls'
,p_preset_template_options=>'t-Region--hiddenOverflow'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2865840475322558786
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549428412792462781)
,p_plug_template_id=>wwv_flow_api.id(15549428356227462780)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549428549430462781)
,p_plug_template_id=>wwv_flow_api.id(15549428356227462780)
,p_name=>'Slides'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549431695262462786)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Region t-Region--hideShow #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems  t-Region-headerItems--controls">',
'    <button class="t-Button t-Button--icon t-Button--hideShow" type="button"></button>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <h2 class="t-Region-title">#TITLE#</h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#EDIT#</div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#CLOSE#</div>',
'    <div class="t-Region-buttons-right">#CREATE#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #COPY#',
'     #BODY#',
'     #SUB_REGIONS#',
'     #CHANGE#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
' </div>',
'</div>'))
,p_page_plug_template_name=>'Collapsible'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>1
,p_preset_template_options=>'is-expanded:t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2662888092628347716
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549431886377462786)
,p_plug_template_id=>wwv_flow_api.id(15549431695262462786)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549431920931462786)
,p_plug_template_id=>wwv_flow_api.id(15549431695262462786)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549433878201462788)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-HeroRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-HeroRegion-wrap">',
'    <div class="t-HeroRegion-col t-HeroRegion-col--left"><span class="t-HeroRegion-icon t-Icon #ICON_CSS_CLASSES#"></span></div>',
'    <div class="t-HeroRegion-col t-HeroRegion-col--content">',
'      <h2 class="t-HeroRegion-title">#TITLE#</h2>',
'      #BODY#',
'    </div>',
'    <div class="t-HeroRegion-col t-HeroRegion-col--right"><div class="t-HeroRegion-form">#SUB_REGIONS#</div><div class="t-HeroRegion-buttons">#NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Hero'
,p_theme_id=>42
,p_theme_class_id=>22
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2672571031438297268
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549433963707462788)
,p_plug_template_id=>wwv_flow_api.id(15549433878201462788)
,p_name=>'Region Body'
,p_placeholder=>'#BODY#'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549434064370462788)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#"  class="t-DialogRegion #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="t-DialogRegion-body js-regionDialog-body">',
'#BODY#',
'  </div>',
'  <div class="t-DialogRegion-buttons js-regionDialog-buttons">',
'     <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'       <div class="t-ButtonRegion-wrap">',
'         <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Dialog'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal:js-draggable:js-resizable'
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2671226943886536762
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549434133144462788)
,p_plug_template_id=>wwv_flow_api.id(15549434064370462788)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549434898354462788)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-IRR-region #REGION_CSS_CLASSES#" role="group" aria-labelledby="#REGION_STATIC_ID#_heading">',
'  <h2 class="u-VisuallyHidden" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'#PREVIOUS##BODY##SUB_REGIONS##NEXT#',
'</div>'))
,p_page_plug_template_name=>'Interactive Report'
,p_theme_id=>42
,p_theme_class_id=>9
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2099079838218790610
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549435239035462788)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Login-region t-Form--stretchInputs t-Form--labelsAbove #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES# role="group" aria-labelledby="#REGION_STATIC_ID#_heading">',
'  <div class="t-Login-header">',
'    <span class="t-Login-logo #ICON_CSS_CLASSES#"></span>',
'    <h1 class="t-Login-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h1>',
'  </div>',
'  <div class="t-Login-body">',
'    #BODY#',
'  </div>',
'  <div class="t-Login-buttons">',
'    #NEXT#',
'  </div>',
'  <div class="t-Login-links">',
'    #EDIT##CREATE#',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_page_plug_template_name=>'Login'
,p_theme_id=>42
,p_theme_class_id=>23
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2672711194551076376
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549435311499462789)
,p_plug_template_id=>wwv_flow_api.id(15549435239035462788)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549435432162462789)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Region #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# role="group" aria-labelledby="#REGION_STATIC_ID#_heading">',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #BODY#',
'     #SUB_REGIONS#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'    <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'   </div>',
' </div>',
'</div>',
''))
,p_page_plug_template_name=>'Standard'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>4070912133526059312
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549435581508462792)
,p_plug_template_id=>wwv_flow_api.id(15549435432162462789)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549435658163462792)
,p_plug_template_id=>wwv_flow_api.id(15549435432162462789)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549437572534462794)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-TabsRegion #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  <div class="t-TabsRegion-items">',
'    #SUB_REGIONS#',
'  </div>',
'</div>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">',
'  #SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'Tabs Container'
,p_theme_id=>42
,p_theme_class_id=>5
,p_preset_template_options=>'t-TabsRegion-mod--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>3221725015618492759
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549437617353462794)
,p_plug_template_id=>wwv_flow_api.id(15549437572534462794)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549437729642462794)
,p_plug_template_id=>wwv_flow_api.id(15549437572534462794)
,p_name=>'Tabs'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549438695034462794)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-BreadcrumbRegion #REGION_CSS_CLASSES#"> ',
'  <div class="t-BreadcrumbRegion-body">',
'    <div class="t-BreadcrumbRegion-breadcrumb">',
'      #BODY#',
'    </div>',
'    <div class="t-BreadcrumbRegion-title">',
'      <h1 class="t-BreadcrumbRegion-titleText">#TITLE#</h1>',
'    </div>',
'  </div>',
'  <div class="t-BreadcrumbRegion-buttons">#PREVIOUS##CLOSE##DELETE##HELP##CHANGE##EDIT##COPY##CREATE##NEXT#</div>',
'</div>'))
,p_page_plug_template_name=>'Title Bar'
,p_theme_id=>42
,p_theme_class_id=>6
,p_default_template_options=>'t-BreadcrumbRegion--showBreadcrumb'
,p_preset_template_options=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2530016523834132090
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15549439208381462794)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Wizard #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Wizard-header">',
'    <h1 class="t-Wizard-title">#TITLE#</h1>',
'    <div class="u-Table t-Wizard-controls">',
'      <div class="u-Table-fit t-Wizard-buttons">#PREVIOUS##CLOSE#</div>',
'      <div class="u-Table-fill t-Wizard-steps">',
'        #BODY#',
'      </div>',
'      <div class="u-Table-fit t-Wizard-buttons">#NEXT#</div>',
'    </div>',
'  </div>',
'  <div class="t-Wizard-body">',
'    #SUB_REGIONS#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Wizard Container'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Wizard--hideStepsXSmall'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2117602213152591491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(15549439351495462794)
,p_plug_template_id=>wwv_flow_api.id(15549439208381462794)
,p_name=>'Wizard Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549447602844462832)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02#">',
'  <span class="t-BadgeList-label">#TEXT#</span>',
'  <span class="t-BadgeList-value"><a href="#LINK#" #A03#>#A01#</a></span>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02#">',
'  <span class="t-BadgeList-label">#TEXT#</span>',
'  <span class="t-BadgeList-value"><a href="#LINK#" #A03#>#A01#</a></span>',
'</li>',
''))
,p_list_template_name=>'Badge List'
,p_theme_id=>42
,p_theme_class_id=>3
,p_default_template_options=>'t-BadgeList--responsive'
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--fixed'
,p_list_template_before_rows=>'<ul class="t-BadgeList t-BadgeList--circular #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Value'
,p_a02_label=>'List item CSS Classes'
,p_a03_label=>'Link Attributes'
,p_reference_id=>2062482847268086664
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A01: Large Number',
'A02: List Item Classes',
'A03: Link Attributes'))
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549449340242462845)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #A04#">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap">',
'      <div class="t-Card-icon"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#TEXT#</h3></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #A04#">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap">',
'      <div class="t-Card-icon"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#TEXT#</h3></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_name=>'Cards'
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Cards--3cols:t-Cards--featured'
,p_list_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Secondary Information'
,p_a03_label=>'Initials'
,p_a04_label=>'List Item CSS Classes'
,p_reference_id=>2885322685880632508
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549451474412462846)
,p_list_template_current=>'<li class="t-LinksList-item is-current #A03#"><a href="#LINK#" class="t-LinksList-link" #A02#><span class="t-LinksList-icon"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span><span class="t-LinksList-label">#TEXT#</span><span class="t-LinksList-b'
||'adge">#A01#</span></a></li>'
,p_list_template_noncurrent=>'<li class="t-LinksList-item #A03#"><a href="#LINK#" class="t-LinksList-link" #A02#><span class="t-LinksList-icon"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span><span class="t-LinksList-label">#TEXT#</span><span class="t-LinksList-badge">#A01#'
||'</span></a></li>'
,p_list_template_name=>'Links List'
,p_theme_id=>42
,p_theme_class_id=>18
,p_list_template_before_rows=>'<ul class="t-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul class="t-LinksList-list">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="t-LinksList-item is-current #A03#"><a href="#LINK#" class="t-LinksList-link" #A02#><span class="t-LinksList-icon"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span><span class="t-LinksList-label">#TEXT#</span><span class="t-LinksList-b'
||'adge">#A01#</span></a></li>'
,p_sub_list_item_noncurrent=>'<li class="t-LinksList-item#A03#"><a href="#LINK#" class="t-LinksList-link" #A02#><span class="t-LinksList-icon"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span><span class="t-LinksList-label">#TEXT#</span><span class="t-LinksList-badge">#A01#<'
||'/span></a></li>'
,p_item_templ_curr_w_child=>'<li class="t-LinksList-item is-current is-expanded #A03#"><a href="#LINK#" class="t-LinksList-link" #A02#><span class="t-LinksList-icon"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span><span class="t-LinksList-label">#TEXT#</span><span class="t'
||'-LinksList-badge">#A01#</span></a>#SUB_LISTS#</li>'
,p_item_templ_noncurr_w_child=>'<li class="t-LinksList-item #A03#"><a href="#LINK#" class="t-LinksList-link" #A02#><span class="t-LinksList-icon"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span><span class="t-LinksList-label">#TEXT#</span><span class="t-LinksList-badge">#A01#'
||'</span></a></li>'
,p_a01_label=>'Badge Value'
,p_a02_label=>'Link Attributes'
,p_a03_label=>'List Item CSS Classes'
,p_reference_id=>4070914341144059318
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549452278647462850)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item is-active #A04#">',
'    <a href="#LINK#" class="t-MediaList-itemWrap" #A03#>',
'        <div class="t-MediaList-iconWrap">',
'            <span class="t-MediaList-icon"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="t-MediaList-body">',
'            <h3 class="t-MediaList-title">#TEXT#</h3>',
'            <p class="t-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="t-MediaList-badgeWrap">',
'            <span class="t-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item  #A04#">',
'    <a href="#LINK#" class="t-MediaList-itemWrap" #A03#>',
'        <div class="t-MediaList-iconWrap">',
'            <span class="t-MediaList-icon"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="t-MediaList-body">',
'            <h3 class="t-MediaList-title">#TEXT#</h3>',
'            <p class="t-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="t-MediaList-badgeWrap">',
'            <span class="t-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'Media List'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-MediaList--showDesc:t-MediaList--showIcons'
,p_list_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'List Item CSS Classes'
,p_reference_id=>2066548068783481421
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549453158367462851)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Menu Bar'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  if ( apex.actions ) {',
'    apex.actions.addFromMarkup( e );',
'  } else {',
'    apex.debug.warn("Include actions.js to support menu shortcuts");',
'  }',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  iconType: ''fa'',',
'  slide: e.hasClass("js-slide"),',
'  menubar: true,',
'  menubarOverflow: true',
'});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-showSubMenuIcons'
,p_list_template_before_rows=>'<div class="t-MenuBar #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_menubar"><ul style="display:none">'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>2008709236185638887
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549453610204462865)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'Menu Popup'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  if ( apex.actions ) {',
'    apex.actions.addFromMarkup( e );',
'  } else {',
'    apex.debug.warn("Include actions.js to support menu shortcuts");',
'  }',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Data ID'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute'
,p_a05_label=>'Shortcut'
,p_reference_id=>3492264004432431646
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549453773527462866)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" role="button">',
'      <span class="t-Icon #ICON_CSS_CLASSES#"></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" role="button">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Navigation Bar'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<ul class="t-NavigationBar #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<div class="t-NavigationBar-menu" style="display: none" id="menu_#PARENT_LIST_ITEM_ID#"><ul>'
,p_after_sub_list=>'</ul></div></li>'
,p_sub_list_item_current=>'<li data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#">',
'      <span class="t-Icon #ICON_CSS_CLASSES#"></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow"></span>',
'  </button>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#">',
'      <span class="t-Icon #ICON_CSS_CLASSES#"></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow"></span>',
'  </button>'))
,p_sub_templ_curr_w_child=>'<li data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#">#TEXT_ESC_SC#</a></li>'
,p_sub_templ_noncurr_w_child=>'<li data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#">#TEXT_ESC_SC#</a></li>'
,p_a01_label=>'Badge Value'
,p_a02_label=>'List  Item CSS Classes'
,p_reference_id=>2846096252961119197
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549453876012462873)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Side Navigation Menu'
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js?v=#APEX_VERSION#'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(''body'').addClass(''t-PageBody--leftNav'');',
''))
,p_theme_id=>42
,p_theme_class_id=>19
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-nav" id="t_Body_nav" role="navigation" aria-label="&APP_TITLE!ATTR.">',
'<div class="t-TreeNav #COMPONENT_CSS_CLASSES#" id="t_TreeNav" data-id="#PARENT_STATIC_ID#_tree" aria-label="&APP_TITLE!ATTR."><ul style="display:none">'))
,p_list_template_after_rows=>'</ul></div></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Disabled True/False'
,p_a04_label=>'Title'
,p_reference_id=>2466292414354694776
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549453983850462880)
,p_list_template_current=>'<li class="t-Tabs-item is-active"><a href="#LINK#" class="t-Tabs-link"><span class="t-Icon #ICON_CSS_CLASSES#"></span><span class="t-Tabs-label">#TEXT#</span></a></li>'
,p_list_template_noncurrent=>'<li class="t-Tabs-item"><a href="#LINK#" class="t-Tabs-link"><span class="t-Icon #ICON_CSS_CLASSES#"></span><span class="t-Tabs-label">#TEXT#</span></a></li>'
,p_list_template_name=>'Tabs'
,p_theme_id=>42
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul class="t-Tabs #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>3288206686691809997
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549454832003462882)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Top Navigation Menu'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  if ( apex.actions ) {',
'    apex.actions.addFromMarkup( e );',
'  } else {',
'    apex.debug.warn("Include actions.js to support menu shortcuts");',
'  }',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  slide: e.hasClass("js-slide"),',
'  menubar: true,',
'  menubarOverflow: true',
'});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-tabLike'
,p_list_template_before_rows=>'<div class="t-Header-nav-list #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_menubar"><ul style="display:none">'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Disabled True / False'
,p_a03_label=>'Hide'
,p_a04_label=>'Title Attribute'
,p_a05_label=>'Shortcut Key'
,p_reference_id=>2525307901300239072
);
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15549455372738462882)
,p_list_template_current=>'<li class="t-WizardSteps-step is-active" id="#LIST_ITEM_ID#"><div class="t-WizardSteps-wrap"><span class="t-WizardSteps-marker"></span><span class="t-WizardSteps-label">#TEXT# <span class="t-WizardSteps-labelState"></span></span></div></li>'
,p_list_template_noncurrent=>'<li class="t-WizardSteps-step" id="#LIST_ITEM_ID#"><div class="t-WizardSteps-wrap"><span class="t-WizardSteps-marker"><span class="t-Icon a-Icon icon-check"></span></span><span class="t-WizardSteps-label">#TEXT# <span class="t-WizardSteps-labelState"'
||'></span></span></div></li>'
,p_list_template_name=>'Wizard Progress'
,p_javascript_code_onload=>'apex.theme.initWizardProgressBar();'
,p_theme_id=>42
,p_theme_class_id=>17
,p_preset_template_options=>'t-WizardSteps--displayLabels'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2 class="u-VisuallyHidden">#CURRENT_PROGRESS#</h2>',
'<ul class="t-WizardSteps #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>2008702338707394488
);
end;
/
prompt --application/shared_components/user_interface/templates/report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549439824126462800)
,p_row_template_name=>'Alerts'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--horizontal t-Alert--colorBG t-Alert--defaultIcons t-Alert--#ALERT_TYPE#" role="alert">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title">#ALERT_TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">',
'        #ALERT_DESC#',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      #ALERT_ACTION#',
'    </div>',
'  </div>',
'</div>'))
,p_row_template_before_rows=>'<div class="t-Alerts">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>14
,p_reference_id=>2881456138952347027
,p_translate_this_template=>'N'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549439976341462812)
,p_row_template_name=>'Badge List'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="t-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList t-BadgeList--circular #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_default_template_options=>'t-BadgeList--responsive'
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--fixed'
,p_reference_id=>2103197159775914759
,p_translate_this_template=>'N'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549441627270462815)
,p_row_template_name=>'Cards'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <a href="#CARD_LINK#" class="t-Card-wrap">',
'      <div class="t-Card-icon"><span class="t-Icon #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_cards">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Cards--3cols:t-Cards--featured'
,p_reference_id=>2973535649510699732
,p_translate_this_template=>'N'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549443747566462816)
,p_row_template_name=>'Comments'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Comments-item #COMMENT_MODIFIERS#">',
'    <div class="t-Comments-icon a-MediaBlock-graphic">',
'        <div class="t-Comments-userIcon #ICON_MODIFIER#" aria-hidden="true">#USER_ICON#</div>',
'    </div>',
'    <div class="t-Comments-body a-MediaBlock-content">',
'        <div class="t-Comments-info">',
'            #USER_NAME# &middot; <span class="t-Comments-date">#COMMENT_DATE#</span> <span class="t-Comments-actions">#ACTIONS#</span>',
'        </div>',
'        <div class="t-Comments-comment">',
'            #COMMENT_TEXT##ATTRIBUTE_1##ATTRIBUTE_2##ATTRIBUTE_3##ATTRIBUTE_4#',
'        </div>',
'    </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Comments #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>',
''))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Comments--chat'
,p_reference_id=>2611722012730764232
,p_translate_this_template=>'N'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549444150922462816)
,p_row_template_name=>'Search Results'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition1=>':LABEL_02 is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition2=>':LABEL_03 is null'
,p_row_template3=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition3=>':LABEL_04 is null'
,p_row_template4=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'      <span class="t-SearchResults-misc">#LABEL_04#: #VALUE_04#</span>',
'    </div>',
'  </li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-SearchResults #COMPONENT_CSS_CLASSES#">',
'<ul class="t-SearchResults-list">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>',
'</div>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070913431524059316
,p_translate_this_template=>'N'
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549444256321462821)
,p_row_template_name=>'Standard'
,p_row_template1=>'<td class="t-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="t-Report-wrap">',
'    <table class="t-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="t-Report-tableWrap">',
'    <table class="t-Report-report" summary="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="t-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="t-Report-pagination t-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="t-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</thead>',
'<tbody>'))
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
,p_reference_id=>2537207537838287671
,p_translate_this_template=>'N'
);
begin
wwv_flow_api.create_row_template_patch(
 p_id=>wwv_flow_api.id(15549444256321462821)
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
);
exception when others then null;
end;
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549445565449462823)
,p_row_template_name=>'Timeline'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <div class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':EVENT_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <a href="#EVENT_LINK#" class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </a>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-Timeline #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_timeline">',
''))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_reference_id=>1513373588340069864
,p_translate_this_template=>'N'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549445769170462823)
,p_row_template_name=>'Value Attribute Pairs - Column'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #COLUMN_HEADER#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #COLUMN_VALUE#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-AVPList--leftAligned'
,p_reference_id=>2099068636272681754
,p_translate_this_template=>'N'
);
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(15549446763123462823)
,p_row_template_name=>'Value Attribute Pairs - Row'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #1#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #2#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-AVPList--leftAligned'
,p_reference_id=>2099068321678681753
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(15549455790210462891)
,p_template_name=>'Hidden'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer t-Form-labelContainer--hiddenLabel col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label u-VisuallyHidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--hiddenLabel rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Button t-Button--noUI t-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden'
||'="true"></span></button>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>13
,p_reference_id=>2039339104148359505
,p_translate_this_template=>'N'
);
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(15549455921280462903)
,p_template_name=>'Optional'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>',
''))
,p_before_item=>'<div class="t-Form-fieldContainer rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Button t-Button--noUI t-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden'
||'="true"></span></button>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>2317154212072806530
,p_translate_this_template=>'N'
);
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(15549456000399462903)
,p_template_name=>'Optional - Above'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="t-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Button t-Button--noUI t-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden'
||'="true"></span></button>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>3030114864004968404
,p_translate_this_template=>'N'
);
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(15549456125307462903)
,p_template_name=>'Required'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label><span class="t-Form-required"><span class="a-Icon icon-asterisk"></span></span>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Button t-Button--noUI t-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden'
||'="true"></span></button>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>2525313812251712801
,p_translate_this_template=>'N'
);
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(15549456271714462906)
,p_template_name=>'Required - Above'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label><span class="t-Form-required"><span class="a-Icon icon-asterisk"></span></span> #HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="t-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Button t-Button--noUI t-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden'
||'="true"></span></button>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>3030115129444970113
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(15549456919338462940)
,p_name=>'Breadcrumb'
,p_before_first=>'<ul class="t-Breadcrumb #COMPONENT_CSS_CLASSES#">'
,p_current_page_option=>'<li class="t-Breadcrumb-item is-active"><span class="t-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="t-Breadcrumb-item"><a href="#LINK#" class="t-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070916542570059325
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(15549457178106462961)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#THEME_STYLE_CSS#',
'#FAVICONS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="t-Page t-Page--popupLOV"'
,p_before_field_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="t-Form-field t-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="t-Button t-Button--hot t-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="t-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'380'
,p_result_row_x_of_y=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>100
,p_before_result_set=>'<div class="t-PopupLOV-links">'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>2885398517835871876
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(15549457061096462947)
,p_cal_template_name=>'Calendar'
,p_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" summary="#IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>',
''))
,p_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--weekly">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_weekly_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_weekly_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_weekly_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_day_close_format=>'</div></td>'
,p_weekly_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_close_format=>'</div></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_weekly_time_close_format=>'</th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" id="#DY#" class="t-ClassicCalendar-dayColumn">#IDAY#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--daily">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #DD#, #YYYY#</h1>'))
,p_daily_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t-ClassicCalendar-calendar">'
,p_daily_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_daily_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_day_close_format=>'</div></td>'
,p_daily_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol" id="#TIME#">'
,p_daily_time_close_format=>'</th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_cust_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="uCal">',
'<h1 class="uMonth">#IMONTH# <span>#YYYY#</span></h1>'))
,p_cust_day_of_week_format=>'<th scope="col" class="uCalDayCol" id="#DY#">#IDAY#</th>'
,p_cust_month_open_format=>'<table class="uCal" cellpadding="0" cellspacing="0" border="0" summary="#IMONTH# #YYYY#">'
,p_cust_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'<div class="uCalFooter"></div>',
'</div>',
''))
,p_cust_week_open_format=>'<tr>'
,p_cust_week_close_format=>'</tr> '
,p_cust_day_title_format=>'<span class="uDayTitle">#DD#</span>'
,p_cust_day_open_format=>'<td class="uDay" headers="#DY#"><div class="uDayData">'
,p_cust_day_close_format=>'</td>'
,p_cust_today_open_format=>'<td class="uDay today" headers="#DY#">'
,p_cust_nonday_title_format=>'<span class="uDayTitle">#DD#</span>'
,p_cust_nonday_open_format=>'<td class="uDay nonday" headers="#DY#">'
,p_cust_nonday_close_format=>'</td>'
,p_cust_weekend_title_format=>'<span class="uDayTitle weekendday">#DD#</span>'
,p_cust_weekend_open_format=>'<td class="uDay" headers="#DY#">'
,p_cust_weekend_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="uDayData">#DATA#</span>',
'</td>'))
,p_cust_hour_open_format=>'<tr>'
,p_cust_hour_close_format=>'</tr>'
,p_cust_time_title_format=>'#TIME#'
,p_cust_time_open_format=>'<th scope="row" class="uCalHour" id="#TIME#">'
,p_cust_time_close_format=>'</th>'
,p_cust_wk_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="uCal uCalWeekly">',
'<h1 class="uMonth">#WTITLE#</h1>'))
,p_cust_wk_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="uCalDayCol" id="#DY#">',
'  <span class="visible-desktop">#DD# #IDAY#</span>',
'  <span class="hidden-desktop">#DD# <em>#IDY#</em></span>',
'</th>'))
,p_cust_wk_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="uCal">'
,p_cust_wk_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'<div class="uCalFooter"></div>',
'</div>'))
,p_cust_wk_week_open_format=>'<tr>'
,p_cust_wk_week_close_format=>'</tr> '
,p_cust_wk_day_title_format=>'<span class="uDayTitle">#DD#</span>'
,p_cust_wk_day_open_format=>'<td class="uDay" headers="#DY#"><div class="uDayData">'
,p_cust_wk_day_close_format=>'</div></td>'
,p_cust_wk_today_open_format=>'<td class="uDay today" headers="#DY#"><div class="uDayData">'
,p_cust_wk_weekend_open_format=>'<td class="uDay weekend" headers="#DY#"><div class="uDayData">'
,p_cust_wk_weekend_close_format=>'</div></td>'
,p_agenda_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--list">',
'  <div class="t-ClassicCalendar-title">#IMONTH# #YYYY#</div>',
'  <ul class="t-ClassicCalendar-list">',
'    #DAYS#',
'  </ul>',
'</div>'))
,p_agenda_past_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-past">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_today_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-today">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_future_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-future">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_past_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-past">#DATA#</li>'
,p_agenda_today_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-today">#DATA#</li>'
,p_agenda_future_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-future">#DATA#</li>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'<span class="t-ClassicCalendar-event">#DATA#</span>'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070916747979059326
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_api.create_theme(
 p_id=>wwv_flow_api.id(15549457584569463046)
,p_theme_id=>42
,p_theme_name=>'Universal Theme'
,p_ui_type_name=>'DESKTOP'
,p_navigation_type=>'L'
,p_nav_bar_type=>'LIST'
,p_reference_id=>4070917134413059350
,p_is_locked=>false
,p_default_page_template=>wwv_flow_api.id(15549424650381462697)
,p_default_dialog_template=>wwv_flow_api.id(15549423311709462696)
,p_error_template=>wwv_flow_api.id(15549421244566462692)
,p_printer_friendly_template=>wwv_flow_api.id(15549424650381462697)
,p_breadcrumb_display_point=>'REGION_POSITION_01'
,p_sidebar_display_point=>'REGION_POSITION_02'
,p_login_template=>wwv_flow_api.id(15549421244566462692)
,p_default_button_template=>wwv_flow_api.id(15549456414734462934)
,p_default_region_template=>wwv_flow_api.id(15549435432162462789)
,p_default_chart_template=>wwv_flow_api.id(15549435432162462789)
,p_default_form_template=>wwv_flow_api.id(15549435432162462789)
,p_default_reportr_template=>wwv_flow_api.id(15549435432162462789)
,p_default_tabform_template=>wwv_flow_api.id(15549435432162462789)
,p_default_wizard_template=>wwv_flow_api.id(15549435432162462789)
,p_default_menur_template=>wwv_flow_api.id(15549438695034462794)
,p_default_listr_template=>wwv_flow_api.id(15549435432162462789)
,p_default_irr_template=>wwv_flow_api.id(15549434898354462788)
,p_default_report_template=>wwv_flow_api.id(15549444256321462821)
,p_default_label_template=>wwv_flow_api.id(15549455921280462903)
,p_default_menu_template=>wwv_flow_api.id(15549456919338462940)
,p_default_calendar_template=>wwv_flow_api.id(15549457061096462947)
,p_default_list_template=>wwv_flow_api.id(15549451474412462846)
,p_default_nav_list_template=>wwv_flow_api.id(15549454832003462882)
,p_default_top_nav_list_temp=>wwv_flow_api.id(15549454832003462882)
,p_default_side_nav_list_temp=>wwv_flow_api.id(15549453876012462873)
,p_default_nav_list_position=>'SIDE'
,p_default_dialogbtnr_template=>wwv_flow_api.id(15549427387568462780)
,p_default_dialogr_template=>wwv_flow_api.id(15549427351625462780)
,p_default_option_label=>wwv_flow_api.id(15549455921280462903)
,p_default_required_label=>wwv_flow_api.id(15549456125307462903)
,p_default_page_transition=>'NONE'
,p_default_popup_transition=>'NONE'
,p_default_navbar_list_template=>wwv_flow_api.id(15549453773527462866)
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(42),'#IMAGE_PREFIX#themes/theme_42/1.0/')
,p_files_version=>62
,p_icon_library=>'FONTAWESOME'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyTableHeader#MIN#.js?v=#APEX_VERSION#',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#tooltipManager#MIN#.js?v=#APEX_VERSION#',
'#HAMMERJS_URL#',
'#THEME_IMAGES#js/modernizr-custom#MIN#.js?v=#APEX_VERSION#',
'#IMAGE_PREFIX#plugins/com.oracle.apex.carousel/1.0/com.oracle.apex.carousel#MIN#.js?v=#APEX_VERSION#',
'#THEME_IMAGES#js/theme42#MIN#.js?v=#APEX_VERSION#'))
,p_css_file_urls=>'#THEME_IMAGES#css/Core#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(15549457251453462966)
,p_theme_id=>42
,p_name=>'Vista'
,p_css_file_urls=>'#THEME_IMAGES#css/Vista#MIN#.css?v=#APEX_VERSION#'
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>true
,p_reference_id=>4007676303523989775
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(15549457299968462967)
,p_theme_id=>42
,p_name=>'Vita'
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Vita.less'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Vita#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>2719875314571594493
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(15549457406603462967)
,p_theme_id=>42
,p_name=>'Vita - Slate'
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_IMAGES#less/theme/Vita-Slate.less'
,p_theme_roller_config=>'{"customCSS":"","vars":{"@g_Accent-BG":"#505f6d","@g_Accent-OG":"#ececec","@g_Body-Title-BG":"#dee1e4","@l_Link-Base":"#337ac0","@g_Body-BG":"#f5f5f5"}}'
,p_theme_roller_output_file_url=>'#THEME_IMAGES#css/Vita-Slate#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>3291983347983194966
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_display_points
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549426159237462777)
,p_theme_id=>42
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>3
,p_template_types=>'REGION'
,p_help_text=>'Sets the type of alert which can be used to determine the icon, icon color, and the background color.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549426379423462780)
,p_theme_id=>42
,p_name=>'ALERT_ICONS'
,p_display_name=>'Alert Icons'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets how icons are handled for the Alert Region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549426542459462780)
,p_theme_id=>42
,p_name=>'ALERT_DISPLAY'
,p_display_name=>'Alert Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the layout of the Alert Region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549427729666462780)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the region is styled. Use the "Remove Borders" template option to remove the region''s borders and shadows.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549427981728462780)
,p_theme_id=>42
,p_name=>'BODY_PADDING'
,p_display_name=>'Body Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body padding for the region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549428616883462781)
,p_theme_id=>42
,p_name=>'TIMER'
,p_display_name=>'Timer'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets the timer for when to automatically navigate to the next region within the Carousel Region.'
,p_null_text=>'No Timer'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549428989684462781)
,p_theme_id=>42
,p_name=>'BODY_HEIGHT'
,p_display_name=>'Body Height'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body height. You can also specify a custom height by modifying the Region''s CSS Classes and using the height helper classes "i-hXXX" where XXX is any increment of 10 from 100 to 800.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549429634549462781)
,p_theme_id=>42
,p_name=>'ACCENT'
,p_display_name=>'Accent'
,p_display_sequence=>30
,p_template_types=>'REGION'
,p_help_text=>'Set the Region''s accent. This accent corresponds to a Theme-Rollable color and sets the background of the Region''s Header.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549430283247462782)
,p_theme_id=>42
,p_name=>'HEADER'
,p_display_name=>'Header'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Determines the display of the Region Header which also contains the Region Title.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549430404065462782)
,p_theme_id=>42
,p_name=>'BODY_OVERFLOW'
,p_display_name=>'Body Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the scroll behavior when the region contents are larger than their container.'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549431297592462786)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the animation when navigating within the Carousel Region.'
,p_null_text=>'Fade'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549432929522462787)
,p_theme_id=>42
,p_name=>'DEFAULT_STATE'
,p_display_name=>'Default State'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the default state of the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549434384747462788)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549437802265462794)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549438003342462794)
,p_theme_id=>42
,p_name=>'TAB_STYLE'
,p_display_name=>'Tab Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549438473114462794)
,p_theme_id=>42
,p_name=>'TABS_SIZE'
,p_display_name=>'Tabs Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549438872710462794)
,p_theme_id=>42
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the source of the Title Bar region''s title.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549439450201462794)
,p_theme_id=>42
,p_name=>'HIDE_STEPS_FOR'
,p_display_name=>'Hide Steps For'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549440021340462814)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549440198575462814)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Determines the layout of Cards in the report.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549441883401462815)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'REPORT'
,p_help_text=>'Determines the amount of text to display for the Card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549442515871462815)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Controls the style and design of the cards in the report.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549442787339462815)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Controls how to handle icons in the report.'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549443533513462816)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549443840386462816)
,p_theme_id=>42
,p_name=>'COMMENTS_STYLE'
,p_display_name=>'Comments Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the style in which comments are displayed.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549444327323462822)
,p_theme_id=>42
,p_name=>'ALTERNATING_ROWS'
,p_display_name=>'Alternating Rows'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Shades alternate rows in the report with slightly different background colors.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549444607828462822)
,p_theme_id=>42
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Determines whether you want the row to be highlighted on hover.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549444828557462822)
,p_theme_id=>42
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of the Report''s borders.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549445800565462823)
,p_theme_id=>42
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549447769004462844)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549448533141462845)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>70
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549449527589462846)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'LIST'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549450272960462846)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549450532602462846)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549451218176462846)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549451916919462850)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549454356006462881)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549455411157462882)
,p_theme_id=>42
,p_name=>'LABEL_DISPLAY'
,p_display_name=>'Label Display'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549456638508462935)
,p_theme_id=>42
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>50
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the position of the icon relative to the label.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549457651148463155)
,p_theme_id=>42
,p_name=>'TYPE'
,p_display_name=>'Type'
,p_display_sequence=>20
,p_template_types=>'BUTTON'
,p_null_text=>'Normal'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549457835918463231)
,p_theme_id=>42
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing Left'
,p_display_sequence=>70
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the left of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549458084176463234)
,p_theme_id=>42
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>80
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the right of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549458249643463234)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the size of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549458458282463234)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>30
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the style of the button. Use the "Simple" option for secondary actions or sets of buttons. Use the "Remove UI Decoration" option to make the button appear as text.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549458886392463234)
,p_theme_id=>42
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>40
,p_template_types=>'BUTTON'
,p_help_text=>'Enables you to group many buttons together into a pill. You can use this option to specify where the button is within this set. Set the option to Default if this button is not part of a button set.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549459531635463235)
,p_theme_id=>42
,p_name=>'WIDTH'
,p_display_name=>'Width'
,p_display_sequence=>60
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the width of the button.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549459894025463235)
,p_theme_id=>42
,p_name=>'LABEL_POSITION'
,p_display_name=>'Label Position'
,p_display_sequence=>140
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the label relative to the form item.'
,p_null_text=>'Inline - Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549460146692463235)
,p_theme_id=>42
,p_name=>'ITEM_SIZE'
,p_display_name=>'Item Size'
,p_display_sequence=>110
,p_template_types=>'REGION'
,p_help_text=>'Sets the size of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549460369189463235)
,p_theme_id=>42
,p_name=>'LABEL_ALIGNMENT'
,p_display_name=>'Label Alignment'
,p_display_sequence=>130
,p_template_types=>'REGION'
,p_help_text=>'Set the label text alignment for items within this region.'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549460537657463235)
,p_theme_id=>42
,p_name=>'ITEM_PADDING'
,p_display_name=>'Item Padding'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the padding around items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549460817803463235)
,p_theme_id=>42
,p_name=>'ITEM_WIDTH'
,p_display_name=>'Item Width'
,p_display_sequence=>120
,p_template_types=>'REGION'
,p_help_text=>'Sets the width of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(15549461135930463235)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426037780462768)
,p_theme_id=>42
,p_name=>'COLOREDBACKGROUND'
,p_display_name=>'Highlight Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--colorBG'
,p_template_types=>'REGION'
,p_help_text=>'Set alert background color to that of the alert type (warning, success, etc.)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426205470462778)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--danger'
,p_group_id=>wwv_flow_api.id(15549426159237462777)
,p_template_types=>'REGION'
,p_help_text=>'Show an error or danger alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426410826462780)
,p_theme_id=>42
,p_name=>'HIDE_ICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--noIcon'
,p_group_id=>wwv_flow_api.id(15549426379423462780)
,p_template_types=>'REGION'
,p_help_text=>'Hides alert icons'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426610644462780)
,p_theme_id=>42
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(15549426542459462780)
,p_template_types=>'REGION'
,p_help_text=>'Show horizontal alert with buttons to the right.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426752921462780)
,p_theme_id=>42
,p_name=>'INFORMATION'
,p_display_name=>'Information'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--info'
,p_group_id=>wwv_flow_api.id(15549426159237462777)
,p_template_types=>'REGION'
,p_help_text=>'Show informational alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426791571462780)
,p_theme_id=>42
,p_name=>'SHOW_CUSTOM_ICONS'
,p_display_name=>'Show Custom Icons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--customIcons'
,p_group_id=>wwv_flow_api.id(15549426379423462780)
,p_template_types=>'REGION'
,p_help_text=>'Set custom icons by modifying the Alert Region''s Icon CSS Classes property.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549426983265462780)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--success'
,p_group_id=>wwv_flow_api.id(15549426159237462777)
,p_template_types=>'REGION'
,p_help_text=>'Show success alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549427047884462780)
,p_theme_id=>42
,p_name=>'USEDEFAULTICONS'
,p_display_name=>'Show Default Icons'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--defaultIcons'
,p_group_id=>wwv_flow_api.id(15549426379423462780)
,p_template_types=>'REGION'
,p_help_text=>'Uses default icons for alert types.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549427140933462780)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--warning'
,p_group_id=>wwv_flow_api.id(15549426159237462777)
,p_template_types=>'REGION'
,p_help_text=>'Show a warning alert.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549427217463462780)
,p_theme_id=>42
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549425840235462701)
,p_css_classes=>'t-Alert--wizard'
,p_group_id=>wwv_flow_api.id(15549426542459462780)
,p_template_types=>'REGION'
,p_help_text=>'Show the alert in a wizard style region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549427860086462780)
,p_theme_id=>42
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(15549427387568462780)
,p_css_classes=>'t-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549428023598462780)
,p_theme_id=>42
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(15549427387568462780)
,p_css_classes=>'t-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(15549427981728462780)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549428159262462780)
,p_theme_id=>42
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>4
,p_region_template_id=>wwv_flow_api.id(15549427387568462780)
,p_css_classes=>'t-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549428261788462780)
,p_theme_id=>42
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_api.id(15549427387568462780)
,p_css_classes=>'t-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(15549427981728462780)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549428726260462781)
,p_theme_id=>42
,p_name=>'10_SECONDS'
,p_display_name=>'10 Seconds'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'js-cycle10s'
,p_group_id=>wwv_flow_api.id(15549428616883462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549428878246462781)
,p_theme_id=>42
,p_name=>'15_SECONDS'
,p_display_name=>'15 Seconds'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'js-cycle15s'
,p_group_id=>wwv_flow_api.id(15549428616883462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549428919369462781)
,p_theme_id=>42
,p_name=>'20_SECONDS'
,p_display_name=>'20 Seconds'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'js-cycle20s'
,p_group_id=>wwv_flow_api.id(15549428616883462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429168858462781)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429223084462781)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429323172462781)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429437115462781)
,p_theme_id=>42
,p_name=>'5_SECONDS'
,p_display_name=>'5 Seconds'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'js-cycle5s'
,p_group_id=>wwv_flow_api.id(15549428616883462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429532727462781)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429732956462781)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429870153462781)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549429932127462781)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430060980462781)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430177761462781)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430378017462782)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--removeHeader'
,p_group_id=>wwv_flow_api.id(15549430283247462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430547234462782)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_api.id(15549430404065462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430587144462786)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(15549430283247462782)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430737791462786)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430852472462786)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549430904931462786)
,p_theme_id=>42
,p_name=>'REMEMBER_CAROUSEL_SLIDE'
,p_display_name=>'Remember Carousel Slide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431009365462786)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_api.id(15549430404065462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431122321462786)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431224123462786)
,p_theme_id=>42
,p_name=>'SHOW_NEXT_AND_PREVIOUS_BUTTONS'
,p_display_name=>'Show Next and Previous Buttons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--showCarouselControls'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431437972462786)
,p_theme_id=>42
,p_name=>'SLIDE'
,p_display_name=>'Slide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--carouselSlide'
,p_group_id=>wwv_flow_api.id(15549431297592462786)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431501322462786)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--carouselSpin'
,p_group_id=>wwv_flow_api.id(15549431297592462786)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431621693462786)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549428356227462780)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549431994397462786)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432140517462786)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432200947462786)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 480px.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432323766462787)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 640px.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432390725462787)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432569666462787)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432653167462787)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432754150462787)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549432826064462787)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433019765462787)
,p_theme_id=>42
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(15549432929522462787)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433151024462787)
,p_theme_id=>42
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(15549432929522462787)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433271659462787)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_api.id(15549430404065462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433331330462787)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433454601462788)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433540015462788)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433619622462788)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_api.id(15549430404065462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549433753219462788)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549431695262462786)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549434269329462788)
,p_theme_id=>42
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549434064370462788)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549434410808462788)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549434064370462788)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_api.id(15549434384747462788)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549434550080462788)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549434064370462788)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_api.id(15549434384747462788)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549434634903462788)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549434064370462788)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549434745401462788)
,p_theme_id=>42
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549434064370462788)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549434854799462788)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549434064370462788)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_api.id(15549434384747462788)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549435034825462788)
,p_theme_id=>42
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549434898354462788)
,p_css_classes=>'t-IRR-region--noBorders'
,p_template_types=>'REGION'
,p_help_text=>'Removes borders around the Interactive Report'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549435158462462788)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549434898354462788)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Interactive Reports toolbar to maximize the report. Clicking this button will toggle the maximize state and stretch the report to fill the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549435694113462792)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549435867007462793)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549435944144462793)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436031431462793)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_api.id(15549428989684462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436162878462793)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436257205462793)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436379813462793)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436393561462793)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436543841462793)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_api.id(15549429634549462781)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436676744462793)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--removeHeader'
,p_group_id=>wwv_flow_api.id(15549430283247462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436695258462793)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_api.id(15549430404065462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436852659462793)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(15549430283247462782)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549436929903462793)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549437069434462793)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549437112828462793)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549437201238462793)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_api.id(15549430404065462782)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549437303546462794)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549437407860462794)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549435432162462789)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_api.id(15549427729666462780)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549437906300462794)
,p_theme_id=>42
,p_name=>'FILL_TAB_LABELS'
,p_display_name=>'Fill Tab Labels'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549437572534462794)
,p_css_classes=>'t-TabsRegion-mod--fillLabels'
,p_group_id=>wwv_flow_api.id(15549437802265462794)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549438112560462794)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549437572534462794)
,p_css_classes=>'t-TabsRegion-mod--pill'
,p_group_id=>wwv_flow_api.id(15549438003342462794)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549438236019462794)
,p_theme_id=>42
,p_name=>'REMEMBER_ACTIVE_TAB'
,p_display_name=>'Remember Active Tab'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549437572534462794)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549438363130462794)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549437572534462794)
,p_css_classes=>'t-TabsRegion-mod--simple'
,p_group_id=>wwv_flow_api.id(15549438003342462794)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549438539063462794)
,p_theme_id=>42
,p_name=>'TABSLARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549437572534462794)
,p_css_classes=>'t-TabsRegion-mod--large'
,p_group_id=>wwv_flow_api.id(15549438473114462794)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549438645014462794)
,p_theme_id=>42
,p_name=>'TABS_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549437572534462794)
,p_css_classes=>'t-TabsRegion-mod--small'
,p_group_id=>wwv_flow_api.id(15549438473114462794)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549438890199462794)
,p_theme_id=>42
,p_name=>'GET_TITLE_FROM_BREADCRUMB'
,p_display_name=>'Use Current Breadcrumb Entry'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(15549438695034462794)
,p_css_classes=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_group_id=>wwv_flow_api.id(15549438872710462794)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549439044705462794)
,p_theme_id=>42
,p_name=>'HIDE_BREADCRUMB'
,p_display_name=>'Show Breadcrumbs'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(15549438695034462794)
,p_css_classes=>'t-BreadcrumbRegion--showBreadcrumb'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549439102692462794)
,p_theme_id=>42
,p_name=>'REGION_HEADER_VISIBLE'
,p_display_name=>'Use Region Title'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(15549438695034462794)
,p_css_classes=>'t-BreadcrumbRegion--useRegionTitle'
,p_group_id=>wwv_flow_api.id(15549438872710462794)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549439505887462794)
,p_theme_id=>42
,p_name=>'HIDESMALLSCREENS'
,p_display_name=>'Small Screens (Tablet)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(15549439208381462794)
,p_css_classes=>'t-Wizard--hideStepsSmall'
,p_group_id=>wwv_flow_api.id(15549439450201462794)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549439617064462794)
,p_theme_id=>42
,p_name=>'HIDEXSMALLSCREENS'
,p_display_name=>'X Small Screens (Mobile)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549439208381462794)
,p_css_classes=>'t-Wizard--hideStepsXSmall'
,p_group_id=>wwv_flow_api.id(15549439450201462794)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549439726291462794)
,p_theme_id=>42
,p_name=>'SHOW_TITLE'
,p_display_name=>'Show Title'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(15549439208381462794)
,p_css_classes=>'t-Wizard--showTitle'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440176464462814)
,p_theme_id=>42
,p_name=>'128PX'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(15549440021340462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440329586462814)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440415458462814)
,p_theme_id=>42
,p_name=>'32PX'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_api.id(15549440021340462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440570498462814)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440619175462814)
,p_theme_id=>42
,p_name=>'48PX'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(15549440021340462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440747781462814)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440800746462814)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440905856462814)
,p_theme_id=>42
,p_name=>'64PX'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_api.id(15549440021340462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549440989516462814)
,p_theme_id=>42
,p_name=>'96PX'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(15549440021340462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441170972462815)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441228842462815)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441375750462815)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441405272462815)
,p_theme_id=>42
,p_name=>'RESPONSIVE'
,p_display_name=>'Responsive'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--responsive'
,p_template_types=>'REPORT'
,p_help_text=>'Automatically resize badges to smaller sizes as screen becomes smaller.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441570643462815)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549439976341462812)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441729145462815)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>15
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549441928053462815)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_api.id(15549441883401462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442035045462815)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442128922462815)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_api.id(15549441883401462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442275250462815)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442299996462815)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_api.id(15549441883401462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442407092462815)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442595516462815)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_api.id(15549442515871462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442745330462815)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_api.id(15549442515871462815)
,p_template_types=>'REPORT'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549442902380462815)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_api.id(15549442787339462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443037138462815)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_api.id(15549442787339462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443138482462815)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--featured'
,p_group_id=>wwv_flow_api.id(15549442515871462815)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443222126462815)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443354643462815)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_api.id(15549441883401462815)
,p_template_types=>'REPORT'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443480566462816)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443635902462816)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Use Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549441627270462815)
,p_css_classes=>'t-Cards--colorize'
,p_group_id=>wwv_flow_api.id(15549443533513462816)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549443958864462816)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549443747566462816)
,p_css_classes=>'t-Comments--basic'
,p_group_id=>wwv_flow_api.id(15549443840386462816)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549444055240462816)
,p_theme_id=>42
,p_name=>'SPEECH_BUBBLES'
,p_display_name=>'Speech Bubbles'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549443747566462816)
,p_css_classes=>'t-Comments--chat'
,p_group_id=>wwv_flow_api.id(15549443840386462816)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549444458166462822)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(15549444327323462822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549444583436462822)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--altRowsDefault'
,p_group_id=>wwv_flow_api.id(15549444327323462822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549444734119462822)
,p_theme_id=>42
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(15549444607828462822)
,p_template_types=>'REPORT'
,p_help_text=>'Enable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549444972826462822)
,p_theme_id=>42
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(15549444828557462822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549444995548462822)
,p_theme_id=>42
,p_name=>'REMOVEALLBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--noBorders'
,p_group_id=>wwv_flow_api.id(15549444828557462822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549445091631462823)
,p_theme_id=>42
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'No Outer Borders'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--inline'
,p_group_id=>wwv_flow_api.id(15549444828557462822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549445236937462823)
,p_theme_id=>42
,p_name=>'ROWHIGHLIGHTDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--rowHighlightOff'
,p_group_id=>wwv_flow_api.id(15549444607828462822)
,p_template_types=>'REPORT'
,p_help_text=>'Disable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549445363705462823)
,p_theme_id=>42
,p_name=>'STRETCHREPORT'
,p_display_name=>'Stretch Report'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--stretch'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549445401714462823)
,p_theme_id=>42
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549444256321462821)
,p_css_classes=>'t-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(15549444828557462822)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549445588876462823)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(15549445565449462823)
,p_css_classes=>'t-Timeline--compact'
,p_group_id=>wwv_flow_api.id(15549442515871462815)
,p_template_types=>'REPORT'
,p_help_text=>'Displays a compact video of timeline with smaller font-sizes and fewer columns.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549445936450462823)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446041199462823)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446116835462823)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446270262462823)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446318133462823)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446460873462823)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446508783462823)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446606709462823)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(15549445769170462823)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446858180462823)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446986386462823)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549446992371462823)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447135100462823)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447214544462824)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_api.id(15549440198575462814)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447289744462824)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447399685462824)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447535062462824)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_api.id(15549446763123462823)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_api.id(15549445800565462823)
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447806248462844)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549447887368462845)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448020877462845)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in 4 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448172036462845)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 5 column grid'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448226724462845)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Span badges horizontally'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448327766462845)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Use flexbox to arrange items'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448431364462845)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Float badges to left'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448668759462845)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_api.id(15549448533141462845)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448718925462845)
,p_theme_id=>42
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(15549448533141462845)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448853167462845)
,p_theme_id=>42
,p_name=>'RESPONSIVE'
,p_display_name=>'Responsive'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--responsive'
,p_template_types=>'LIST'
,p_help_text=>'Automatically resize badges to smaller sizes as screen becomes smaller.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549448895113462845)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_api.id(15549448533141462845)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449075863462845)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Stack badges on top of each other'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449182415462845)
,p_theme_id=>42
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'.t-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(15549448533141462845)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449241887462845)
,p_theme_id=>42
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(15549447602844462832)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(15549448533141462845)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449442697462846)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449637332462846)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_api.id(15549449527589462846)
,p_template_types=>'LIST'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449689334462846)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449837015462846)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_api.id(15549449527589462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549449972377462846)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450071462462846)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_api.id(15549449527589462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450175732462846)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450330127462846)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_api.id(15549450272960462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450431360462846)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_api.id(15549450272960462846)
,p_template_types=>'LIST'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450606045462846)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_api.id(15549450532602462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450729637462846)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_api.id(15549450532602462846)
,p_template_types=>'LIST'
,p_help_text=>'Initials come from List Attribute 3'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450856357462846)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--featured'
,p_group_id=>wwv_flow_api.id(15549450272960462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549450902305462846)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451001699462846)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_api.id(15549449527589462846)
,p_template_types=>'LIST'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451138483462846)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451380185462846)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Use Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549449340242462845)
,p_css_classes=>'t-Cards--colorize'
,p_group_id=>wwv_flow_api.id(15549451218176462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451521418462850)
,p_theme_id=>42
,p_name=>'ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549451474412462846)
,p_css_classes=>'t-LinksList--actions'
,p_group_id=>wwv_flow_api.id(15549450272960462846)
,p_template_types=>'LIST'
,p_help_text=>'Render as actions to be placed on the right side column.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451670530462850)
,p_theme_id=>42
,p_name=>'DISABLETEXTWRAPPING'
,p_display_name=>'Disable Text Wrapping'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549451474412462846)
,p_css_classes=>'t-LinksList--nowrap'
,p_template_types=>'LIST'
,p_help_text=>'Do not allow link text to wrap to new lines. Truncate with ellipsis.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451784926462850)
,p_theme_id=>42
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549451474412462846)
,p_css_classes=>'t-LinksList--showBadge'
,p_template_types=>'LIST'
,p_help_text=>'Show badge to right of link (requires Attribute 1 to be populated)'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549451819406462850)
,p_theme_id=>42
,p_name=>'SHOWGOTOARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549451474412462846)
,p_css_classes=>'t-LinksList--showArrow'
,p_template_types=>'LIST'
,p_help_text=>'Show arrow to the right of link'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452002266462850)
,p_theme_id=>42
,p_name=>'SHOWICONS'
,p_display_name=>'For All Items'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549451474412462846)
,p_css_classes=>'t-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(15549451916919462850)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452151857462850)
,p_theme_id=>42
,p_name=>'SHOWTOPICONS'
,p_display_name=>'For Top Level Items Only'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549451474412462846)
,p_css_classes=>'t-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(15549451916919462850)
,p_template_types=>'LIST'
,p_help_text=>'This will show icons for top level items of the list only. It will not show icons for sub lists.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452302306462851)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452438551462851)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452555834462851)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452649321462851)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452746664462851)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'LIST'
,p_help_text=>'Show a badge (Attribute 2) to the right of the list item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452791819462851)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'LIST'
,p_help_text=>'Shows the description (Attribute 1) for each list item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452924175462851)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'LIST'
,p_help_text=>'Shows an icon for each list item.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549452998609462851)
,p_theme_id=>42
,p_name=>'SPANHORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_api.id(15549452278647462850)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Show all list items in one horizontal row.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549453194184462859)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_api.id(15549453158367462851)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549453291617462865)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549453158367462851)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549453479932462865)
,p_theme_id=>42
,p_name=>'ENABLE_SLIDE_ANIMATION'
,p_display_name=>'Enable Slide Animation'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549453158367462851)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549453507713462865)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549453158367462851)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454041124462881)
,p_theme_id=>42
,p_name=>'ABOVE_LABEL'
,p_display_name=>'Above Label'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--iconsAbove'
,p_group_id=>wwv_flow_api.id(15549450532602462846)
,p_template_types=>'LIST'
,p_help_text=>'Places icons above tab label.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454161604462881)
,p_theme_id=>42
,p_name=>'FILL_LABELS'
,p_display_name=>'Fill Labels'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--fillLabels'
,p_group_id=>wwv_flow_api.id(15549447769004462844)
,p_template_types=>'LIST'
,p_help_text=>'Stretch tabs to fill to the width of the tabs container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454227391462881)
,p_theme_id=>42
,p_name=>'INLINE_WITH_LABEL'
,p_display_name=>'Inline with Label'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--inlineIcons'
,p_group_id=>wwv_flow_api.id(15549450532602462846)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454467634462881)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--large'
,p_group_id=>wwv_flow_api.id(15549454356006462881)
,p_template_types=>'LIST'
,p_help_text=>'Increases font size and white space around tab items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454560801462881)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--pill'
,p_group_id=>wwv_flow_api.id(15549450272960462846)
,p_template_types=>'LIST'
,p_help_text=>'Displays tabs in a pill container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454621803462881)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--simple'
,p_group_id=>wwv_flow_api.id(15549450272960462846)
,p_template_types=>'LIST'
,p_help_text=>'A very simplistic tab UI.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454702397462882)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_api.id(15549453983850462880)
,p_css_classes=>'t-Tabs--small'
,p_group_id=>wwv_flow_api.id(15549454356006462881)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549454984776462882)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(15549454832003462882)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549455013591462882)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(15549454832003462882)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549455138078462882)
,p_theme_id=>42
,p_name=>'ENABLE_SLIDE_ANIMATION'
,p_display_name=>'Enable Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(15549454832003462882)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549455204408462882)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(15549454832003462882)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549455510409462882)
,p_theme_id=>42
,p_name=>'ALLSTEPS'
,p_display_name=>'All Steps'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_api.id(15549455372738462882)
,p_css_classes=>'t-WizardSteps--displayLabels'
,p_group_id=>wwv_flow_api.id(15549455411157462882)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549455655243462882)
,p_theme_id=>42
,p_name=>'CURRENTSTEPONLY'
,p_display_name=>'Current Step Only'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_api.id(15549455372738462882)
,p_css_classes=>'t-WizardSteps--displayCurrentLabelOnly'
,p_group_id=>wwv_flow_api.id(15549455411157462882)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549455783160462882)
,p_theme_id=>42
,p_name=>'HIDELABELS'
,p_display_name=>'Hide Labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_api.id(15549455372738462882)
,p_css_classes=>'t-WizardSteps--hideLabels'
,p_group_id=>wwv_flow_api.id(15549455411157462882)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549456697220462935)
,p_theme_id=>42
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_api.id(15549456504586462935)
,p_css_classes=>'t-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(15549456638508462935)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549456880993462935)
,p_theme_id=>42
,p_name=>'RIGHTICON'
,p_display_name=>'Right'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_api.id(15549456504586462935)
,p_css_classes=>'t-Button--iconRight'
,p_group_id=>wwv_flow_api.id(15549456638508462935)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549457770438463229)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>30
,p_css_classes=>'t-Button--danger'
,p_group_id=>wwv_flow_api.id(15549457651148463155)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549457912834463231)
,p_theme_id=>42
,p_name=>'LARGELEFTMARGIN'
,p_display_name=>'Large Left Margin'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(15549457835918463231)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549458127575463234)
,p_theme_id=>42
,p_name=>'LARGERIGHTMARGIN'
,p_display_name=>'Large Right Margin'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapRight'
,p_group_id=>wwv_flow_api.id(15549458084176463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549458322911463234)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--large'
,p_group_id=>wwv_flow_api.id(15549458249643463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549458500637463234)
,p_theme_id=>42
,p_name=>'NOUI'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>20
,p_css_classes=>'t-Button--noUI'
,p_group_id=>wwv_flow_api.id(15549458458282463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549458625418463234)
,p_theme_id=>42
,p_name=>'SMALLLEFTMARGIN'
,p_display_name=>'Small Left Margin'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padLeft'
,p_group_id=>wwv_flow_api.id(15549457835918463231)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549458752970463234)
,p_theme_id=>42
,p_name=>'SMALLRIGHTMARGIN'
,p_display_name=>'Small Right Margin'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padRight'
,p_group_id=>wwv_flow_api.id(15549458084176463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549458921227463235)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Inner Button'
,p_display_sequence=>20
,p_css_classes=>'t-Button--pill'
,p_group_id=>wwv_flow_api.id(15549458886392463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459030849463235)
,p_theme_id=>42
,p_name=>'PILLEND'
,p_display_name=>'Last Button'
,p_display_sequence=>30
,p_css_classes=>'t-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(15549458886392463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459132450463235)
,p_theme_id=>42
,p_name=>'PILLSTART'
,p_display_name=>'First Button'
,p_display_sequence=>10
,p_css_classes=>'t-Button--pillStart'
,p_group_id=>wwv_flow_api.id(15549458886392463234)
,p_template_types=>'BUTTON'
,p_help_text=>'Use this for the start of a pill button.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459236790463235)
,p_theme_id=>42
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>10
,p_css_classes=>'t-Button--primary'
,p_group_id=>wwv_flow_api.id(15549457651148463155)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459318478463235)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_css_classes=>'t-Button--simple'
,p_group_id=>wwv_flow_api.id(15549458458282463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459410684463235)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--small'
,p_group_id=>wwv_flow_api.id(15549458249643463234)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459619524463235)
,p_theme_id=>42
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>10
,p_css_classes=>'t-Button--stretch'
,p_group_id=>wwv_flow_api.id(15549459531635463235)
,p_template_types=>'BUTTON'
,p_help_text=>'Stretches button to fill container'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459689191463235)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_css_classes=>'t-Button--success'
,p_group_id=>wwv_flow_api.id(15549457651148463155)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549459790733463235)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>20
,p_css_classes=>'t-Button--warning'
,p_group_id=>wwv_flow_api.id(15549457651148463155)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549460034653463235)
,p_theme_id=>42
,p_name=>'SHOWFORMLABELSABOVE'
,p_display_name=>'Show Form Labels Above'
,p_display_sequence=>10
,p_css_classes=>'t-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(15549459894025463235)
,p_template_types=>'REGION'
,p_help_text=>'Show form labels above input fields.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549460213859463235)
,p_theme_id=>42
,p_name=>'FORMSIZELARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form--large'
,p_group_id=>wwv_flow_api.id(15549460146692463235)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549460414192463235)
,p_theme_id=>42
,p_name=>'FORMLEFTLABELS'
,p_display_name=>'Left'
,p_display_sequence=>20
,p_css_classes=>'t-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(15549460369189463235)
,p_template_types=>'REGION'
,p_help_text=>'Align form labels to left.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549460682629463235)
,p_theme_id=>42
,p_name=>'FORMREMOVEPADDING'
,p_display_name=>'Remove Padding'
,p_display_sequence=>20
,p_css_classes=>'t-Form--noPadding'
,p_group_id=>wwv_flow_api.id(15549460537657463235)
,p_template_types=>'REGION'
,p_help_text=>'Removes padding between items.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549460716298463235)
,p_theme_id=>42
,p_name=>'FORMSLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>10
,p_css_classes=>'t-Form--slimPadding'
,p_group_id=>wwv_flow_api.id(15549460537657463235)
,p_template_types=>'REGION'
,p_help_text=>'Reduces form item padding to 4px.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549460921438463235)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_FIELDS'
,p_display_name=>'Stretch Form Fields'
,p_display_sequence=>10
,p_css_classes=>'t-Form--stretchInputs'
,p_group_id=>wwv_flow_api.id(15549460817803463235)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549461066489463235)
,p_theme_id=>42
,p_name=>'FORMSIZEXLARGE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form--xlarge'
,p_group_id=>wwv_flow_api.id(15549460146692463235)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549461200036463235)
,p_theme_id=>42
,p_name=>'LARGE_FIELD'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--large'
,p_group_id=>wwv_flow_api.id(15549461135930463235)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549461354645463235)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_ITEM'
,p_display_name=>'Stretch Form Item'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--stretchInputs'
,p_template_types=>'FIELD'
,p_help_text=>'Stretches the form item to fill its container.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(15549461432099463235)
,p_theme_id=>42
,p_name=>'X_LARGE_SIZE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form-fieldContainer--xlarge'
,p_group_id=>wwv_flow_api.id(15549461135930463235)
,p_template_types=>'FIELD'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/globalization/translations
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts
begin
null;
end;
/
prompt --application/shared_components/security/authentications
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(15549461811539463384)
,p_name=>'APEX'
,p_scheme_type=>'NATIVE_APEX_ACCOUNTS'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/ui_types
begin
null;
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(15549461660198463248)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>42
,p_home_url=>'f?p=&APP_ID.:4:&SESSION.'
,p_login_url=>'f?p=&APP_ID.:LOGIN_DESKTOP:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_navigation_list_id=>wwv_flow_api.id(15549419238425462538)
,p_navigation_list_position=>'SIDE'
,p_navigation_list_template_id=>wwv_flow_api.id(15549453876012462873)
,p_nav_list_template_options=>'#DEFAULT#'
,p_nav_bar_type=>'LIST'
,p_nav_bar_list_id=>wwv_flow_api.id(15549461502300463242)
,p_nav_bar_list_template_id=>wwv_flow_api.id(15549453773527462866)
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Home'
,p_page_mode=>'NORMAL'
,p_step_title=>'Home'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Home'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'GRLICAA@GMAIL.COM'
,p_last_upd_yyyymmddhh24miss=>'20151026192241'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15549558312687387740)
,p_plug_name=>'<h2>Home</h2>'
,p_icon_css_classes=>'fa-home'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(15549433878201462788)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'BODY'
,p_plug_query_row_template=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15549558439436387741)
,p_plug_name=>'<h3>About</h3>'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(15549435432162462789)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'BODY'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Sample application for different types of reports<br/>',
'<br/>',
'Currenty available: <br/>',
'- PL/SQL based generator of PDF''s - GEN_PDF<br/>',
'<br/>',
'Coming soon:  Exel, Word,...<br/>',
'<br/>',
'<br/>',
'For more information please send <a href="mailto:andrej.grlica@gmail.com&subject=GEN_PDF">e-mail</a>.',
'',
' '))
,p_plug_query_row_template=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Employers'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Employers'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'700'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221133736'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549557980482387736)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.emp_demo();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Fonts'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Fonts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Fonts'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'1200'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221133828'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549570539984950158)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.fonts_demo();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_api.create_page(
 p_id=>4
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'PDF'
,p_page_mode=>'NORMAL'
,p_step_title=>'PDF'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'GRLICAA@GMAIL.COM'
,p_last_upd_yyyymmddhh24miss=>'20151026192009'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15549558109766387738)
,p_plug_name=>'<h2>GEN PDF</h2>'
,p_icon_css_classes=>'fa-file-pdf-o'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(15549433878201462788)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'BODY'
,p_plug_query_row_template=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15549558228730387739)
,p_plug_name=>'<h3>GEN_PDF is PL/SQL based generator for PDF.</h3>'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(15549435432162462789)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'BODY'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'GEN_PDF is mix of WPDF(1.4.8b) and AS_PDF3.',
'</p>',
'<p>',
'Why ? <br/>',
'Because I prefer more pl/sql for smaller applications rather then print servers.<br><br/>',
'Further on:',
'<br/>',
'- WPDF is great for setting position of custom tables<br/>',
'- AS_PDF3 is great for importing fonts into PDF<br/>',
'<br/>',
'GEN_PDF is set to work on apex. Fonts and images are stored in WWV_FLOW_FILES, so there is no need to use UTL.FILE package (like in AS_PDF3)  <br/>',
'and there is also no need for "ordsys.ordImage" (like in PL_FPDF which don''t work on XE db).<br/>',
'<br/>',
'Package also contains some examples on how to use embedded tool.',
'</p>',
''))
,p_plug_query_row_template=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15549652335062768436)
,p_plug_name=>'<h3>Download GEN_PDF</h3>'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_api.id(15549435432162462789)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'BODY'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Download PACKAGE and Static files used in demo (version 1.0).',
'</p>',
'<p>',
'Run demo sample: <br/>',
'<br/>',
'begin<br/>',
'&nbsp;',
'&nbsp;gen_pdf.emp_demo();<br/>',
'&nbsp;',
'&nbsp;apex_application.stop_apex_engine;<br/>',
'end;<br/>',
'</p>',
''))
,p_plug_query_row_template=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15549652553093768438)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15549652335062768436)
,p_button_name=>'Download'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--iconRight'
,p_button_template_id=>wwv_flow_api.id(15549456504586462935)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Download'
,p_button_position=>'REGION_TEMPLATE_COPY'
,p_icon_css_classes=>'fa-download'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15552273450251242002)
,p_branch_action=>'#WORKSPACE_IMAGES#GEN_PDF.zip'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15552273330735242001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Download log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'INSERT INTO DOWNLOAD_LOG(ID, IP, APP_ID, DOWNLOAD_DATE, HTTP_USER_AGENT)',
'VALUES (DOWNLOAD_LOG_SEQ.NEXTVAL,  OWA_UTIL.get_cgi_env (''REMOTE_ADDR''), :APP_ID, sysdate, OWA_UTIL.get_cgi_env (''HTTP_USER_AGENT''));',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(15549652553093768438)
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Barcode'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Barcode'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Barcode'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'700'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221133914'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549573756093944771)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.barcode_demo();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_api.create_page(
 p_id=>7
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Rotate'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Rotate'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Rotate'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'700'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221133940'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549593442075468601)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.rotate_demo();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_api.create_page(
 p_id=>8
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Images'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Images'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Images'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'700'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221133948'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549597050487115785)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.images_demo();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Chart'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Chart'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Chart'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'700'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221133959'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549600370996568509)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.chart_demo();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_api.create_page(
 p_id=>10
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Header'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Header'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title=>'Header'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'NO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'800'
,p_dialog_width=>'700'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'N'
,p_cache_mode=>'NOCACHE'
,p_help_text=>'No help is available for this page.'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20170221134020'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549670335161304364)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'gen_pdf.testHeader();',
'apex_application.stop_apex_engine;',
'',
'end;'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101
,p_user_interface_id=>wwv_flow_api.id(15549461660198463248)
,p_name=>'Login Page'
,p_alias=>'LOGIN_DESKTOP'
,p_page_mode=>'NORMAL'
,p_step_title=>'PDF - WPDF - Log In'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_step_sub_title_type=>'TEXT_WITH_SUBSTITUTIONS'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(15549421244566462692)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'Y'
,p_overwrite_navigation_list=>'N'
,p_page_is_public_y_n=>'Y'
,p_cache_mode=>'NOCACHE'
,p_last_updated_by=>'ANDREJGR'
,p_last_upd_yyyymmddhh24miss=>'20151026144956'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15549462091412463554)
,p_plug_name=>'Gen PDF'
,p_icon_css_classes=>'fa-file-pdf-o'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(15549435239035462788)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'N'
,p_plug_display_point=>'BODY'
,p_plug_query_row_template=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15549462392801463634)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(15549462091412463554)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--large:t-Button--stretch'
,p_button_template_id=>wwv_flow_api.id(15549456414734462934)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Log In'
,p_button_position=>'REGION_TEMPLATE_CREATE'
,p_grid_new_grid=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15549462225106463582)
,p_name=>'P101_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15549462091412463554)
,p_prompt=>'Username   (Demo / demo)'
,p_placeholder=>'username'
,p_post_element_text=>'<span class="t-Login-iconValidation a-Icon icon-check"></span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(15549455921280462903)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15549462364313463594)
,p_name=>'P101_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15549462091412463554)
,p_prompt=>'Password'
,p_placeholder=>'password'
,p_post_element_text=>'<span class="t-Login-iconValidation a-Icon icon-check"></span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(15549455921280462903)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549462677596463652)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => lower(:P101_USERNAME) );'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549462581018463648)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.login(',
'    p_username => :P101_USERNAME,',
'    p_password => :P101_PASSWORD );'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549462879245463653)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15549462764768463653)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>':P101_USERNAME := apex_authentication.get_login_username_cookie;'
);
end;
/
prompt --application/deployment/definition
begin
null;
end;
/
prompt --application/deployment/install
begin
null;
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
